/* info-notification.c generated by valac 0.56.16, the Vala compiler
 * generated from info-notification.vala, do not modify */

/*
 * Copyright 2015 Canonical Ltd.
 * Copyright 2021-2023 Robert Tari
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Charles Kerr <charles.kerr@canonical.com>
 *      Robert Tari <robert@tari.in>
 */

#include <glib-object.h>
#include <libnotify/notify.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>
#include <gio/gio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define INDICATOR_SOUND_TYPE_NOTIFICATION (indicator_sound_notification_get_type ())
#define INDICATOR_SOUND_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), INDICATOR_SOUND_TYPE_NOTIFICATION, IndicatorSoundNotification))
#define INDICATOR_SOUND_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), INDICATOR_SOUND_TYPE_NOTIFICATION, IndicatorSoundNotificationClass))
#define INDICATOR_SOUND_IS_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), INDICATOR_SOUND_TYPE_NOTIFICATION))
#define INDICATOR_SOUND_IS_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), INDICATOR_SOUND_TYPE_NOTIFICATION))
#define INDICATOR_SOUND_NOTIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), INDICATOR_SOUND_TYPE_NOTIFICATION, IndicatorSoundNotificationClass))

typedef struct _IndicatorSoundNotification IndicatorSoundNotification;
typedef struct _IndicatorSoundNotificationClass IndicatorSoundNotificationClass;
typedef struct _IndicatorSoundNotificationPrivate IndicatorSoundNotificationPrivate;

#define INDICATOR_SOUND_TYPE_INFO_NOTIFICATION (indicator_sound_info_notification_get_type ())
#define INDICATOR_SOUND_INFO_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), INDICATOR_SOUND_TYPE_INFO_NOTIFICATION, IndicatorSoundInfoNotification))
#define INDICATOR_SOUND_INFO_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), INDICATOR_SOUND_TYPE_INFO_NOTIFICATION, IndicatorSoundInfoNotificationClass))
#define INDICATOR_SOUND_IS_INFO_NOTIFICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), INDICATOR_SOUND_TYPE_INFO_NOTIFICATION))
#define INDICATOR_SOUND_IS_INFO_NOTIFICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), INDICATOR_SOUND_TYPE_INFO_NOTIFICATION))
#define INDICATOR_SOUND_INFO_NOTIFICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), INDICATOR_SOUND_TYPE_INFO_NOTIFICATION, IndicatorSoundInfoNotificationClass))

typedef struct _IndicatorSoundInfoNotification IndicatorSoundInfoNotification;
typedef struct _IndicatorSoundInfoNotificationClass IndicatorSoundInfoNotificationClass;
typedef struct _IndicatorSoundInfoNotificationPrivate IndicatorSoundInfoNotificationPrivate;
enum  {
	INDICATOR_SOUND_INFO_NOTIFICATION_0_PROPERTY,
	INDICATOR_SOUND_INFO_NOTIFICATION_NUM_PROPERTIES
};
static GParamSpec* indicator_sound_info_notification_properties[INDICATOR_SOUND_INFO_NOTIFICATION_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	VOLUME_CONTROL_ACTIVE_OUTPUT_SPEAKERS,
	VOLUME_CONTROL_ACTIVE_OUTPUT_HEADPHONES,
	VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_HEADPHONES,
	VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_SPEAKER,
	VOLUME_CONTROL_ACTIVE_OUTPUT_USB_SPEAKER,
	VOLUME_CONTROL_ACTIVE_OUTPUT_USB_HEADPHONES,
	VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_SPEAKER,
	VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_HEADPHONES,
	VOLUME_CONTROL_ACTIVE_OUTPUT_CALL_MODE
} VolumeControlActiveOutput;

#define VOLUME_CONTROL_TYPE_ACTIVE_OUTPUT (volume_control_active_output_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_settings_schema_source_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_source_unref (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _IndicatorSoundNotification {
	GObject parent_instance;
	IndicatorSoundNotificationPrivate * priv;
	NotifyNotification* _notification;
};

struct _IndicatorSoundNotificationClass {
	GObjectClass parent_class;
	NotifyNotification* (*create_notification) (IndicatorSoundNotification* self);
};

struct _IndicatorSoundInfoNotification {
	IndicatorSoundNotification parent_instance;
	IndicatorSoundInfoNotificationPrivate * priv;
};

struct _IndicatorSoundInfoNotificationClass {
	IndicatorSoundNotificationClass parent_class;
};

struct _IndicatorSoundInfoNotificationPrivate {
	gchar* sReaderSchema;
	gchar* sReaderKey;
	gboolean bHints;
};

static gint IndicatorSoundInfoNotification_private_offset;
static gpointer indicator_sound_info_notification_parent_class = NULL;

VALA_EXTERN GType indicator_sound_notification_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IndicatorSoundNotification, g_object_unref)
VALA_EXTERN GType indicator_sound_info_notification_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IndicatorSoundInfoNotification, g_object_unref)
VALA_EXTERN NotifyNotification* indicator_sound_notification_create_notification (IndicatorSoundNotification* self);
static NotifyNotification* indicator_sound_info_notification_real_create_notification (IndicatorSoundNotification* base);
VALA_EXTERN gboolean indicator_sound_notification_notify_server_supports (IndicatorSoundNotification* self,
                                                              const gchar* cap);
VALA_EXTERN GType volume_control_active_output_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void indicator_sound_info_notification_show (IndicatorSoundInfoNotification* self,
                                             VolumeControlActiveOutput active_output,
                                             gdouble volume,
                                             gboolean is_high_volume);
static const gchar* indicator_sound_info_notification_get_notification_label (VolumeControlActiveOutput active_output);
static const gchar* indicator_sound_info_notification_get_volume_notification_icon (VolumeControlActiveOutput active_output,
                                                                             gdouble volume,
                                                                             gboolean is_high_volume);
static GVariant* _variant_new1 (const gchar* value);
static GVariant* _variant_new2 (const gchar* value);
static GVariant* _variant_new3 (const gchar* value);
static GVariant* _variant_new4 (gint32 value);
VALA_EXTERN void indicator_sound_notification_show_notification (IndicatorSoundNotification* self);
static const gchar* indicator_sound_info_notification_get_volume_icon (VolumeControlActiveOutput active_output,
                                                                gdouble volume);
VALA_EXTERN IndicatorSoundInfoNotification* indicator_sound_info_notification_new (void);
VALA_EXTERN IndicatorSoundInfoNotification* indicator_sound_info_notification_construct (GType object_type);
VALA_EXTERN IndicatorSoundNotification* indicator_sound_notification_construct (GType object_type);
static void indicator_sound_info_notification_finalize (GObject * obj);
static GType indicator_sound_info_notification_get_type_once (void);

static inline gpointer
indicator_sound_info_notification_get_instance_private (IndicatorSoundInfoNotification* self)
{
	return G_STRUCT_MEMBER_P (self, IndicatorSoundInfoNotification_private_offset);
}

static NotifyNotification*
indicator_sound_info_notification_real_create_notification (IndicatorSoundNotification* base)
{
	IndicatorSoundInfoNotification * self;
	gchar* sUser = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	NotifyNotification* _tmp5_;
	NotifyNotification* result;
	self = (IndicatorSoundInfoNotification*) base;
	_tmp0_ = g_get_user_name ();
	_tmp1_ = g_strdup (_tmp0_);
	sUser = _tmp1_;
	self->priv->bHints = indicator_sound_notification_notify_server_supports ((IndicatorSoundNotification*) self, "x-lomiri-private-synchronous");
	_tmp2_ = sUser;
	if (g_strcmp0 (_tmp2_, "lightdm") == 0) {
		gchar* _tmp3_;
		gchar* _tmp4_;
		_tmp3_ = g_strdup ("org.ArcticaProject.arctica-greeter");
		_g_free0 (self->priv->sReaderSchema);
		self->priv->sReaderSchema = _tmp3_;
		_tmp4_ = g_strdup ("screen-reader");
		_g_free0 (self->priv->sReaderKey);
		self->priv->sReaderKey = _tmp4_;
	}
	_tmp5_ = notify_notification_new (_ ("Volume"), "", "audio-volume-muted");
	result = _tmp5_;
	_g_free0 (sUser);
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gpointer
_g_settings_schema_source_ref0 (gpointer self)
{
	return self ? g_settings_schema_source_ref (self) : NULL;
}

static GVariant*
_variant_new1 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new2 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new3 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static GVariant*
_variant_new4 (gint32 value)
{
	return g_variant_ref_sink (g_variant_new_int32 (value));
}

void
indicator_sound_info_notification_show (IndicatorSoundInfoNotification* self,
                                        VolumeControlActiveOutput active_output,
                                        gdouble volume,
                                        gboolean is_high_volume)
{
	gchar* volume_label = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* icon = NULL;
	const gchar* _tmp2_;
	NotifyNotification* n = NULL;
	NotifyNotification* _tmp3_;
	NotifyNotification* _tmp4_;
	gint32 nValue = 0;
	NotifyNotification* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp29_;
	NotifyNotification* _tmp30_;
	NotifyNotification* _tmp31_;
	GVariant* _tmp32_;
	NotifyNotification* _tmp33_;
	GVariant* _tmp34_;
	const gchar* _tmp35_ = NULL;
	NotifyNotification* _tmp36_;
	GVariant* _tmp37_;
	NotifyNotification* _tmp38_;
	GVariant* _tmp39_;
	g_return_if_fail (self != NULL);
	_tmp0_ = indicator_sound_info_notification_get_notification_label (active_output);
	_tmp1_ = g_strdup (_tmp0_);
	volume_label = _tmp1_;
	_tmp2_ = indicator_sound_info_notification_get_volume_notification_icon (active_output, volume, is_high_volume);
	icon = _tmp2_;
	_tmp3_ = ((IndicatorSoundNotification*) self)->_notification;
	_tmp4_ = _g_object_ref0 (_tmp3_);
	n = _tmp4_;
	nValue = CLAMP ((gint32) ((volume * 100.0) + 0.5), (gint32) 0, (gint32) 100);
	if (!self->priv->bHints) {
		const gchar* _tmp5_;
		gchar* _tmp6_;
		GSettingsSchemaSource* pSource = NULL;
		GSettingsSchemaSource* _tmp7_;
		GSettingsSchemaSource* _tmp8_;
		GSettingsSchema* pSchema = NULL;
		GSettingsSchemaSource* _tmp9_;
		const gchar* _tmp10_;
		GSettingsSchema* _tmp11_;
		gboolean bOrcaActive = FALSE;
		GSettingsSchema* _tmp12_;
		_tmp5_ = volume_label;
		_tmp6_ = g_strconcat (_tmp5_, "\n", NULL);
		_g_free0 (volume_label);
		volume_label = _tmp6_;
		_tmp7_ = g_settings_schema_source_get_default ();
		_tmp8_ = _g_settings_schema_source_ref0 (_tmp7_);
		pSource = _tmp8_;
		_tmp9_ = pSource;
		_tmp10_ = self->priv->sReaderSchema;
		_tmp11_ = g_settings_schema_source_lookup (_tmp9_, _tmp10_, FALSE);
		pSchema = _tmp11_;
		bOrcaActive = FALSE;
		_tmp12_ = pSchema;
		if (_tmp12_ != NULL) {
			GSettings* pSettings = NULL;
			const gchar* _tmp13_;
			GSettings* _tmp14_;
			GSettings* _tmp15_;
			const gchar* _tmp16_;
			_tmp13_ = self->priv->sReaderSchema;
			_tmp14_ = g_settings_new (_tmp13_);
			pSettings = _tmp14_;
			_tmp15_ = pSettings;
			_tmp16_ = self->priv->sReaderKey;
			bOrcaActive = g_settings_get_boolean (_tmp15_, _tmp16_);
			_g_object_unref0 (pSettings);
		}
		if (bOrcaActive) {
			gchar* sValue = NULL;
			gchar* _tmp17_;
			const gchar* _tmp18_;
			const gchar* _tmp19_;
			gchar* _tmp20_;
			gchar* _tmp21_;
			gchar* _tmp22_;
			_tmp17_ = g_strdup_printf ("%i", nValue);
			sValue = _tmp17_;
			_tmp18_ = volume_label;
			_tmp19_ = sValue;
			_tmp20_ = g_strconcat (_tmp19_, "%", NULL);
			_tmp21_ = _tmp20_;
			_tmp22_ = g_strconcat (_tmp18_, _tmp21_, NULL);
			_g_free0 (volume_label);
			volume_label = _tmp22_;
			_g_free0 (_tmp21_);
			_g_free0 (sValue);
		} else {
			guint nChars = 0U;
			nChars = (guint) CLAMP ((gint32) ((volume * 20) + 0.5), (gint32) 0, (gint32) 20);
			{
				guint nChar = 0U;
				nChar = (guint) 0;
				{
					gboolean _tmp23_ = FALSE;
					_tmp23_ = TRUE;
					while (TRUE) {
						const gchar* _tmp25_;
						gchar* _tmp26_;
						if (!_tmp23_) {
							guint _tmp24_;
							_tmp24_ = nChar;
							nChar = _tmp24_ + 1;
						}
						_tmp23_ = FALSE;
						if (!(nChar < nChars)) {
							break;
						}
						_tmp25_ = volume_label;
						_tmp26_ = g_strconcat (_tmp25_, "◼", NULL);
						_g_free0 (volume_label);
						volume_label = _tmp26_;
					}
				}
			}
		}
		_g_settings_schema_unref0 (pSchema);
		_g_settings_schema_source_unref0 (pSource);
	}
	_tmp27_ = n;
	_tmp28_ = volume_label;
	_tmp29_ = icon;
	notify_notification_update (_tmp27_, _ ("Volume"), _tmp28_, _tmp29_);
	_tmp30_ = n;
	notify_notification_clear_hints (_tmp30_);
	_tmp31_ = n;
	_tmp32_ = _variant_new1 ("true");
	notify_notification_set_hint (_tmp31_, "x-lomiri-non-shaped-icon", _tmp32_);
	_g_variant_unref0 (_tmp32_);
	_tmp33_ = n;
	_tmp34_ = _variant_new2 ("true");
	notify_notification_set_hint (_tmp33_, "x-lomiri-private-synchronous", _tmp34_);
	_g_variant_unref0 (_tmp34_);
	if (is_high_volume) {
		_tmp35_ = "true";
	} else {
		_tmp35_ = "false";
	}
	_tmp36_ = n;
	_tmp37_ = _variant_new3 (_tmp35_);
	notify_notification_set_hint (_tmp36_, "x-lomiri-value-bar-tint", _tmp37_);
	_g_variant_unref0 (_tmp37_);
	_tmp38_ = n;
	_tmp39_ = _variant_new4 (nValue);
	notify_notification_set_hint (_tmp38_, "value", _tmp39_);
	_g_variant_unref0 (_tmp39_);
	indicator_sound_notification_show_notification ((IndicatorSoundNotification*) self);
	_g_object_unref0 (n);
	_g_free0 (volume_label);
}

static const gchar*
indicator_sound_info_notification_get_notification_label (VolumeControlActiveOutput active_output)
{
	const gchar* result;
	switch (active_output) {
		case VOLUME_CONTROL_ACTIVE_OUTPUT_SPEAKERS:
		{
			result = _ ("Speakers");
			return result;
		}
		case VOLUME_CONTROL_ACTIVE_OUTPUT_HEADPHONES:
		{
			result = _ ("Headphones");
			return result;
		}
		case VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_HEADPHONES:
		{
			result = _ ("Bluetooth headphones");
			return result;
		}
		case VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_SPEAKER:
		{
			result = _ ("Bluetooth speaker");
			return result;
		}
		case VOLUME_CONTROL_ACTIVE_OUTPUT_USB_SPEAKER:
		{
			result = _ ("Usb speaker");
			return result;
		}
		case VOLUME_CONTROL_ACTIVE_OUTPUT_USB_HEADPHONES:
		{
			result = _ ("Usb headphones");
			return result;
		}
		case VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_SPEAKER:
		{
			result = _ ("HDMI speaker");
			return result;
		}
		case VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_HEADPHONES:
		{
			result = _ ("HDMI headphones");
			return result;
		}
		default:
		{
			result = "";
			return result;
		}
	}
}

static const gchar*
indicator_sound_info_notification_get_volume_notification_icon (VolumeControlActiveOutput active_output,
                                                                gdouble volume,
                                                                gboolean is_high_volume)
{
	const gchar* result;
	if (!is_high_volume) {
		const gchar* _tmp0_;
		_tmp0_ = indicator_sound_info_notification_get_volume_icon (active_output, volume);
		result = _tmp0_;
		return result;
	}
	switch (active_output) {
		case VOLUME_CONTROL_ACTIVE_OUTPUT_SPEAKERS:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_HEADPHONES:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_HEADPHONES:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_SPEAKER:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_USB_SPEAKER:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_USB_HEADPHONES:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_SPEAKER:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_HEADPHONES:
		{
			result = "audio-volume-high";
			return result;
		}
		default:
		{
			result = "";
			return result;
		}
	}
}

static const gchar*
indicator_sound_info_notification_get_volume_icon (VolumeControlActiveOutput active_output,
                                                   gdouble volume)
{
	const gchar* result;
	switch (active_output) {
		case VOLUME_CONTROL_ACTIVE_OUTPUT_SPEAKERS:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_HEADPHONES:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_HEADPHONES:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_SPEAKER:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_USB_SPEAKER:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_USB_HEADPHONES:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_SPEAKER:
		case VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_HEADPHONES:
		{
			if (volume <= 0.0) {
				result = "audio-volume-muted";
				return result;
			}
			if (volume <= 0.3) {
				result = "audio-volume-low";
				return result;
			}
			if (volume <= 0.7) {
				result = "audio-volume-medium";
				return result;
			}
			result = "audio-volume-high";
			return result;
		}
		default:
		{
			result = "";
			return result;
		}
	}
}

IndicatorSoundInfoNotification*
indicator_sound_info_notification_construct (GType object_type)
{
	IndicatorSoundInfoNotification * self = NULL;
	self = (IndicatorSoundInfoNotification*) indicator_sound_notification_construct (object_type);
	return self;
}

IndicatorSoundInfoNotification*
indicator_sound_info_notification_new (void)
{
	return indicator_sound_info_notification_construct (INDICATOR_SOUND_TYPE_INFO_NOTIFICATION);
}

static void
indicator_sound_info_notification_class_init (IndicatorSoundInfoNotificationClass * klass,
                                              gpointer klass_data)
{
	indicator_sound_info_notification_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &IndicatorSoundInfoNotification_private_offset);
	((IndicatorSoundNotificationClass *) klass)->create_notification = (NotifyNotification* (*) (IndicatorSoundNotification*)) indicator_sound_info_notification_real_create_notification;
	G_OBJECT_CLASS (klass)->finalize = indicator_sound_info_notification_finalize;
}

static void
indicator_sound_info_notification_instance_init (IndicatorSoundInfoNotification * self,
                                                 gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	self->priv = indicator_sound_info_notification_get_instance_private (self);
	_tmp0_ = g_strdup ("org.gnome.desktop.a11y.applications");
	self->priv->sReaderSchema = _tmp0_;
	_tmp1_ = g_strdup ("screen-reader-enabled");
	self->priv->sReaderKey = _tmp1_;
	self->priv->bHints = FALSE;
}

static void
indicator_sound_info_notification_finalize (GObject * obj)
{
	IndicatorSoundInfoNotification * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, INDICATOR_SOUND_TYPE_INFO_NOTIFICATION, IndicatorSoundInfoNotification);
	_g_free0 (self->priv->sReaderSchema);
	_g_free0 (self->priv->sReaderKey);
	G_OBJECT_CLASS (indicator_sound_info_notification_parent_class)->finalize (obj);
}

static GType
indicator_sound_info_notification_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (IndicatorSoundInfoNotificationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) indicator_sound_info_notification_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IndicatorSoundInfoNotification), 0, (GInstanceInitFunc) indicator_sound_info_notification_instance_init, NULL };
	GType indicator_sound_info_notification_type_id;
	indicator_sound_info_notification_type_id = g_type_register_static (INDICATOR_SOUND_TYPE_NOTIFICATION, "IndicatorSoundInfoNotification", &g_define_type_info, 0);
	IndicatorSoundInfoNotification_private_offset = g_type_add_instance_private (indicator_sound_info_notification_type_id, sizeof (IndicatorSoundInfoNotificationPrivate));
	return indicator_sound_info_notification_type_id;
}

GType
indicator_sound_info_notification_get_type (void)
{
	static volatile gsize indicator_sound_info_notification_type_id__once = 0;
	if (g_once_init_enter (&indicator_sound_info_notification_type_id__once)) {
		GType indicator_sound_info_notification_type_id;
		indicator_sound_info_notification_type_id = indicator_sound_info_notification_get_type_once ();
		g_once_init_leave (&indicator_sound_info_notification_type_id__once, indicator_sound_info_notification_type_id);
	}
	return indicator_sound_info_notification_type_id__once;
}

