/* sound-menu.c generated by valac 0.56.16, the Vala compiler
 * generated from sound-menu.vala, do not modify */

/*
 * Copyright 2013 Canonical Ltd.
 * Copyright 2021-2024 Robert Tari
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Lars Uebernickel <lars.uebernickel@canonical.com>
 *      Robert Tari <robert@tari.in>
 */

#include <glib-object.h>
#include <gio/gio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <ayatana/common/utils.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>

#define SOUND_MENU_PLAYBACK_ITEM_TYPE "org.ayatana.indicator.playback-item"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SOUND_MENU (sound_menu_get_type ())
#define SOUND_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SOUND_MENU, SoundMenu))
#define SOUND_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SOUND_MENU, SoundMenuClass))
#define IS_SOUND_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SOUND_MENU))
#define IS_SOUND_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SOUND_MENU))
#define SOUND_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SOUND_MENU, SoundMenuClass))

typedef struct _SoundMenu SoundMenu;
typedef struct _SoundMenuClass SoundMenuClass;
typedef struct _SoundMenuPrivate SoundMenuPrivate;

#define TYPE_MEDIA_PLAYER (media_player_get_type ())
#define MEDIA_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_PLAYER, MediaPlayer))
#define MEDIA_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_PLAYER, MediaPlayerClass))
#define IS_MEDIA_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_PLAYER))
#define IS_MEDIA_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_PLAYER))
#define MEDIA_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_PLAYER, MediaPlayerClass))

typedef struct _MediaPlayer MediaPlayer;
typedef struct _MediaPlayerClass MediaPlayerClass;
enum  {
	SOUND_MENU_0_PROPERTY,
	SOUND_MENU_SHOW_MIC_VOLUME_PROPERTY,
	SOUND_MENU_SHOW_HIGH_VOLUME_WARNING_PROPERTY,
	SOUND_MENU_NUM_PROPERTIES
};
static GParamSpec* sound_menu_properties[SOUND_MENU_NUM_PROPERTIES];
typedef enum  {
	SOUND_MENU_DISPLAY_FLAGS_NONE = 0,
	SOUND_MENU_DISPLAY_FLAGS_SHOW_MUTE = 1,
	SOUND_MENU_DISPLAY_FLAGS_HIDE_INACTIVE_PLAYERS = 2,
	SOUND_MENU_DISPLAY_FLAGS_HIDE_PLAYERS = 4,
	SOUND_MENU_DISPLAY_FLAGS_GREETER_PLAYERS = 8,
	SOUND_MENU_DISPLAY_FLAGS_SHOW_SILENT_MODE = 16,
	SOUND_MENU_DISPLAY_FLAGS_HIDE_INACTIVE_PLAYERS_PLAY_CONTROLS = 32,
	SOUND_MENU_DISPLAY_FLAGS_ADD_PLAY_CONTROL_INACTIVE_PLAYER = 64
} SoundMenuDisplayFlags;

#define SOUND_MENU_TYPE_DISPLAY_FLAGS (sound_menu_display_flags_get_type ())
typedef enum  {
	SOUND_MENU_PLAYER_SECTION_POSITION_LABEL = 0,
	SOUND_MENU_PLAYER_SECTION_POSITION_PLAYER_CONTROLS = 1,
	SOUND_MENU_PLAYER_SECTION_POSITION_PLAYLIST = 2
} SoundMenuPlayerSectionPosition;

#define SOUND_MENU_TYPE_PLAYER_SECTION_POSITION (sound_menu_player_section_position_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block1Data Block1Data;
typedef enum  {
	VOLUME_CONTROL_ACTIVE_OUTPUT_SPEAKERS,
	VOLUME_CONTROL_ACTIVE_OUTPUT_HEADPHONES,
	VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_HEADPHONES,
	VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_SPEAKER,
	VOLUME_CONTROL_ACTIVE_OUTPUT_USB_SPEAKER,
	VOLUME_CONTROL_ACTIVE_OUTPUT_USB_HEADPHONES,
	VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_SPEAKER,
	VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_HEADPHONES,
	VOLUME_CONTROL_ACTIVE_OUTPUT_CALL_MODE
} VolumeControlActiveOutput;

#define VOLUME_CONTROL_TYPE_ACTIVE_OUTPUT (volume_control_active_output_get_type ())
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	SOUND_MENU_LAST_PLAYER_UPDATED_SIGNAL,
	SOUND_MENU_NUM_SIGNALS
};
static guint sound_menu_signals[SOUND_MENU_NUM_SIGNALS] = {0};

struct _SoundMenu {
	GObject parent_instance;
	SoundMenuPrivate * priv;
	GMenu* root;
	GMenu* menu;
};

struct _SoundMenuClass {
	GObjectClass parent_class;
};

struct _SoundMenuPrivate {
	GDBusConnection* bus;
	guint export_id;
	GMenu* volume_section;
	gboolean mic_volume_shown;
	gboolean settings_shown;
	gboolean high_volume_warning_shown;
	gboolean hide_inactive;
	gboolean hide_players;
	gboolean hide_inactive_player_controls;
	gboolean add_play_button_inactive_player;
	GHashTable* notify_handlers;
	gboolean greeter_players;
	gint number_of_running_players;
	gchar* default_player;
};

struct _Block1Data {
	int _ref_count_;
	SoundMenu* self;
	MediaPlayer* player;
};

static gint SoundMenu_private_offset;
static gpointer sound_menu_parent_class = NULL;

VALA_EXTERN GType sound_menu_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SoundMenu, g_object_unref)
VALA_EXTERN GType media_player_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MediaPlayer, g_object_unref)
VALA_EXTERN GType sound_menu_display_flags_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType sound_menu_player_section_position_get_type (void) G_GNUC_CONST ;
VALA_EXTERN SoundMenu* sound_menu_new (const gchar* settings_action,
                           SoundMenuDisplayFlags flags);
VALA_EXTERN SoundMenu* sound_menu_construct (GType object_type,
                                 const gchar* settings_action,
                                 SoundMenuDisplayFlags flags);
static GMenuItem* sound_menu_create_slider_menu_item (SoundMenu* self,
                                               const gchar* label,
                                               const gchar* action,
                                               gdouble min,
                                               gdouble max,
                                               gdouble step,
                                               const gchar* min_icon_name,
                                               const gchar* max_icon_name,
                                               gboolean sync_action);
static void _g_object_unref0_ (gpointer var);
VALA_EXTERN void sound_menu_set_default_player (SoundMenu* self,
                                    const gchar* default_player_id);
static gint sound_menu_find_player_section (SoundMenu* self,
                                     MediaPlayer* player);
VALA_EXTERN const gchar* media_player_get_id (MediaPlayer* self);
static void sound_menu_add_player_playback_controls (SoundMenu* self,
                                              MediaPlayer* player,
                                              gint index,
                                              gboolean adding_default_player);
VALA_EXTERN void sound_menu_export (SoundMenu* self,
                        GDBusConnection* connection,
                        const gchar* object_path);
static gint sound_menu_find_action (SoundMenu* self,
                             GMenu* menu,
                             const gchar* in_action);
VALA_EXTERN void sound_menu_update_all_players_play_section (SoundMenu* self);
static void sound_menu_update_player_section (SoundMenu* self,
                                       MediaPlayer* player,
                                       gint index);
static void sound_menu_check_last_running_player (SoundMenu* self);
VALA_EXTERN gboolean media_player_get_is_running (MediaPlayer* self);
VALA_EXTERN void sound_menu_add_player (SoundMenu* self,
                            MediaPlayer* player);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void sound_menu_insert_player_section (SoundMenu* self,
                                       MediaPlayer* player);
static void sound_menu_update_playlists (SoundMenu* self,
                                  MediaPlayer* player);
static void __lambda4_ (Block1Data* _data1_);
static void sound_menu_remove_player_section (SoundMenu* self,
                                       MediaPlayer* player);
static void ___lambda4__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void _sound_menu_update_playlists_media_player_playlists_changed (MediaPlayer* _sender,
                                                                  gpointer self);
static void sound_menu_update_playbackstatus (SoundMenu* self,
                                       MediaPlayer* player);
static void _sound_menu_update_playbackstatus_media_player_playbackstatus_changed (MediaPlayer* _sender,
                                                                            gpointer self);
VALA_EXTERN void sound_menu_remove_player (SoundMenu* self,
                               MediaPlayer* player);
VALA_EXTERN GType volume_control_active_output_get_type (void) G_GNUC_CONST ;
VALA_EXTERN void sound_menu_update_volume_slider (SoundMenu* self,
                                      VolumeControlActiveOutput active_output);
static gint sound_menu_find_player_playback_controls_section (SoundMenu* self,
                                                       GMenu* player_menu);
static GMenuItem* sound_menu_create_playback_menu_item (SoundMenu* self,
                                                 MediaPlayer* player);
VALA_EXTERN gboolean media_player_get_can_do_play (MediaPlayer* self);
VALA_EXTERN gboolean media_player_get_can_do_next (MediaPlayer* self);
VALA_EXTERN gboolean media_player_get_can_do_prev (MediaPlayer* self);
VALA_EXTERN GIcon* media_player_get_icon (MediaPlayer* self);
VALA_EXTERN const gchar* media_player_get_name (MediaPlayer* self);
VALA_EXTERN guint media_player_get_n_playlists (MediaPlayer* self);
VALA_EXTERN gchar* media_player_get_playlist_id (MediaPlayer* self,
                                     gint index);
VALA_EXTERN gchar* media_player_get_playlist_name (MediaPlayer* self,
                                       gint index);
VALA_EXTERN gboolean sound_menu_get_show_mic_volume (SoundMenu* self);
VALA_EXTERN void sound_menu_set_show_mic_volume (SoundMenu* self,
                                     gboolean value);
VALA_EXTERN gboolean sound_menu_get_show_high_volume_warning (SoundMenu* self);
VALA_EXTERN void sound_menu_set_show_high_volume_warning (SoundMenu* self,
                                              gboolean value);
static void sound_menu_finalize (GObject * obj);
static GType sound_menu_get_type_once (void);
static void _vala_sound_menu_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_sound_menu_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);

static inline gpointer
sound_menu_get_instance_private (SoundMenu* self)
{
	return G_STRUCT_MEMBER_P (self, SoundMenu_private_offset);
}

static GType
sound_menu_display_flags_get_type_once (void)
{
	static const GEnumValue values[] = {{SOUND_MENU_DISPLAY_FLAGS_NONE, "SOUND_MENU_DISPLAY_FLAGS_NONE", "none"}, {SOUND_MENU_DISPLAY_FLAGS_SHOW_MUTE, "SOUND_MENU_DISPLAY_FLAGS_SHOW_MUTE", "show-mute"}, {SOUND_MENU_DISPLAY_FLAGS_HIDE_INACTIVE_PLAYERS, "SOUND_MENU_DISPLAY_FLAGS_HIDE_INACTIVE_PLAYERS", "hide-inactive-players"}, {SOUND_MENU_DISPLAY_FLAGS_HIDE_PLAYERS, "SOUND_MENU_DISPLAY_FLAGS_HIDE_PLAYERS", "hide-players"}, {SOUND_MENU_DISPLAY_FLAGS_GREETER_PLAYERS, "SOUND_MENU_DISPLAY_FLAGS_GREETER_PLAYERS", "greeter-players"}, {SOUND_MENU_DISPLAY_FLAGS_SHOW_SILENT_MODE, "SOUND_MENU_DISPLAY_FLAGS_SHOW_SILENT_MODE", "show-silent-mode"}, {SOUND_MENU_DISPLAY_FLAGS_HIDE_INACTIVE_PLAYERS_PLAY_CONTROLS, "SOUND_MENU_DISPLAY_FLAGS_HIDE_INACTIVE_PLAYERS_PLAY_CONTROLS", "hide-inactive-players-play-controls"}, {SOUND_MENU_DISPLAY_FLAGS_ADD_PLAY_CONTROL_INACTIVE_PLAYER, "SOUND_MENU_DISPLAY_FLAGS_ADD_PLAY_CONTROL_INACTIVE_PLAYER", "add-play-control-inactive-player"}, {0, NULL, NULL}};
	GType sound_menu_display_flags_type_id;
	sound_menu_display_flags_type_id = g_enum_register_static ("SoundMenuDisplayFlags", values);
	return sound_menu_display_flags_type_id;
}

GType
sound_menu_display_flags_get_type (void)
{
	static volatile gsize sound_menu_display_flags_type_id__once = 0;
	if (g_once_init_enter (&sound_menu_display_flags_type_id__once)) {
		GType sound_menu_display_flags_type_id;
		sound_menu_display_flags_type_id = sound_menu_display_flags_get_type_once ();
		g_once_init_leave (&sound_menu_display_flags_type_id__once, sound_menu_display_flags_type_id);
	}
	return sound_menu_display_flags_type_id__once;
}

static GType
sound_menu_player_section_position_get_type_once (void)
{
	static const GEnumValue values[] = {{SOUND_MENU_PLAYER_SECTION_POSITION_LABEL, "SOUND_MENU_PLAYER_SECTION_POSITION_LABEL", "label"}, {SOUND_MENU_PLAYER_SECTION_POSITION_PLAYER_CONTROLS, "SOUND_MENU_PLAYER_SECTION_POSITION_PLAYER_CONTROLS", "player-controls"}, {SOUND_MENU_PLAYER_SECTION_POSITION_PLAYLIST, "SOUND_MENU_PLAYER_SECTION_POSITION_PLAYLIST", "playlist"}, {0, NULL, NULL}};
	GType sound_menu_player_section_position_type_id;
	sound_menu_player_section_position_type_id = g_enum_register_static ("SoundMenuPlayerSectionPosition", values);
	return sound_menu_player_section_position_type_id;
}

GType
sound_menu_player_section_position_get_type (void)
{
	static volatile gsize sound_menu_player_section_position_type_id__once = 0;
	if (g_once_init_enter (&sound_menu_player_section_position_type_id__once)) {
		GType sound_menu_player_section_position_type_id;
		sound_menu_player_section_position_type_id = sound_menu_player_section_position_get_type_once ();
		g_once_init_leave (&sound_menu_player_section_position_type_id__once, sound_menu_player_section_position_type_id);
	}
	return sound_menu_player_section_position_type_id__once;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

SoundMenu*
sound_menu_construct (GType object_type,
                      const gchar* settings_action,
                      SoundMenuDisplayFlags flags)
{
	SoundMenu * self = NULL;
	GMenu* _tmp0_;
	GMenu* _tmp10_;
	GMenuItem* _tmp11_;
	GMenuItem* _tmp12_;
	GMenu* _tmp13_;
	GMenu* _tmp14_;
	GMenu* _tmp15_;
	GMenuItem* root_item = NULL;
	GMenuItem* _tmp17_;
	GMenu* _tmp18_;
	GMenu* _tmp19_;
	GMenu* _tmp20_;
	GHashFunc _tmp21_;
	GEqualFunc _tmp22_;
	GHashTable* _tmp23_;
	self = (SoundMenu*) g_object_new (object_type, NULL);
	_tmp0_ = g_menu_new ();
	_g_object_unref0 (self->priv->volume_section);
	self->priv->volume_section = _tmp0_;
	if ((flags & SOUND_MENU_DISPLAY_FLAGS_SHOW_MUTE) != 0) {
		if (ayatana_common_utils_is_lomiri ()) {
			GMenu* _tmp1_;
			_tmp1_ = self->priv->volume_section;
			g_menu_append (_tmp1_, _ ("Mute"), "indicator.mute");
		} else {
			GMenuItem* item = NULL;
			GMenuItem* _tmp2_;
			GMenuItem* _tmp3_;
			GMenu* _tmp4_;
			GMenuItem* _tmp5_;
			_tmp2_ = g_menu_item_new (_ ("Mute"), "indicator.mute(true)");
			item = _tmp2_;
			_tmp3_ = item;
			g_menu_item_set_attribute (_tmp3_, "x-ayatana-type", "s", "org.ayatana.indicator.switch", NULL);
			_tmp4_ = self->priv->volume_section;
			_tmp5_ = item;
			g_menu_append_item (_tmp4_, _tmp5_);
			_g_object_unref0 (item);
		}
	}
	if ((flags & SOUND_MENU_DISPLAY_FLAGS_SHOW_SILENT_MODE) != 0) {
		GMenuItem* item = NULL;
		GMenuItem* _tmp6_;
		GMenuItem* _tmp7_;
		GMenu* _tmp8_;
		GMenuItem* _tmp9_;
		_tmp6_ = g_menu_item_new (_ ("Silent Mode"), "indicator.silent-mode(true)");
		item = _tmp6_;
		_tmp7_ = item;
		g_menu_item_set_attribute (_tmp7_, "x-ayatana-type", "s", "org.ayatana.indicator.switch", NULL);
		_tmp8_ = self->priv->volume_section;
		_tmp9_ = item;
		g_menu_append_item (_tmp8_, _tmp9_);
		_g_object_unref0 (item);
	}
	_tmp10_ = self->priv->volume_section;
	_tmp11_ = sound_menu_create_slider_menu_item (self, _ ("Volume"), "indicator.volume(0)", 0.0, 1.0, 0.01, "audio-volume-low-zero", "audio-volume-high", TRUE);
	_tmp12_ = _tmp11_;
	g_menu_append_item (_tmp10_, _tmp12_);
	_g_object_unref0 (_tmp12_);
	_tmp13_ = g_menu_new ();
	_g_object_unref0 (self->menu);
	self->menu = _tmp13_;
	_tmp14_ = self->menu;
	_tmp15_ = self->priv->volume_section;
	g_menu_append_section (_tmp14_, NULL, (GMenuModel*) _tmp15_);
	if (settings_action != NULL) {
		GMenu* _tmp16_;
		self->priv->settings_shown = TRUE;
		_tmp16_ = self->menu;
		g_menu_append (_tmp16_, _ ("Sound Settings…"), settings_action);
	}
	_tmp17_ = g_menu_item_new (NULL, "indicator.root");
	root_item = _tmp17_;
	g_menu_item_set_attribute (root_item, "x-ayatana-type", "s", "org.ayatana.indicator.root", NULL);
	g_menu_item_set_attribute (root_item, "x-ayatana-scroll-action", "s", "indicator.scroll", NULL);
	g_menu_item_set_attribute (root_item, "x-ayatana-secondary-action", "s", "indicator.mute", NULL);
	g_menu_item_set_attribute (root_item, "submenu-action", "s", "indicator.indicator-shown", NULL);
	_tmp18_ = self->menu;
	g_menu_item_set_submenu (root_item, (GMenuModel*) _tmp18_);
	_tmp19_ = g_menu_new ();
	_g_object_unref0 (self->root);
	self->root = _tmp19_;
	_tmp20_ = self->root;
	g_menu_append_item (_tmp20_, root_item);
	self->priv->hide_players = (flags & SOUND_MENU_DISPLAY_FLAGS_HIDE_PLAYERS) != 0;
	self->priv->hide_inactive = (flags & SOUND_MENU_DISPLAY_FLAGS_HIDE_INACTIVE_PLAYERS) != 0;
	self->priv->hide_inactive_player_controls = (flags & SOUND_MENU_DISPLAY_FLAGS_HIDE_INACTIVE_PLAYERS_PLAY_CONTROLS) != 0;
	self->priv->add_play_button_inactive_player = (flags & SOUND_MENU_DISPLAY_FLAGS_ADD_PLAY_CONTROL_INACTIVE_PLAYER) != 0;
	_tmp21_ = g_direct_hash;
	_tmp22_ = g_direct_equal;
	_tmp23_ = g_hash_table_new_full (_tmp21_, _tmp22_, _g_object_unref0_, NULL);
	_g_hash_table_unref0 (self->priv->notify_handlers);
	self->priv->notify_handlers = _tmp23_;
	self->priv->greeter_players = (flags & SOUND_MENU_DISPLAY_FLAGS_GREETER_PLAYERS) != 0;
	_g_object_unref0 (root_item);
	return self;
}

SoundMenu*
sound_menu_new (const gchar* settings_action,
                SoundMenuDisplayFlags flags)
{
	return sound_menu_construct (TYPE_SOUND_MENU, settings_action, flags);
}

void
sound_menu_set_default_player (SoundMenu* self,
                               const gchar* default_player_id)
{
	gchar* _tmp0_;
	GHashTable* _tmp1_;
	GList* _tmp2_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (default_player_id != NULL);
	_tmp0_ = g_strdup (default_player_id);
	_g_free0 (self->priv->default_player);
	self->priv->default_player = _tmp0_;
	_tmp1_ = self->priv->notify_handlers;
	_tmp2_ = g_hash_table_get_keys (_tmp1_);
	{
		GList* player_stored_collection = NULL;
		GList* player_stored_it = NULL;
		player_stored_collection = _tmp2_;
		for (player_stored_it = player_stored_collection; player_stored_it != NULL; player_stored_it = player_stored_it->next) {
			MediaPlayer* player_stored = NULL;
			player_stored = (MediaPlayer*) player_stored_it->data;
			{
				gint index = 0;
				MediaPlayer* _tmp3_;
				gboolean _tmp4_ = FALSE;
				_tmp3_ = player_stored;
				index = sound_menu_find_player_section (self, _tmp3_);
				if (index != -1) {
					MediaPlayer* _tmp5_;
					const gchar* _tmp6_;
					const gchar* _tmp7_;
					const gchar* _tmp8_;
					_tmp5_ = player_stored;
					_tmp6_ = media_player_get_id (_tmp5_);
					_tmp7_ = _tmp6_;
					_tmp8_ = self->priv->default_player;
					_tmp4_ = g_strcmp0 (_tmp7_, _tmp8_) == 0;
				} else {
					_tmp4_ = FALSE;
				}
				if (_tmp4_) {
					MediaPlayer* _tmp9_;
					_tmp9_ = player_stored;
					sound_menu_add_player_playback_controls (self, _tmp9_, index, TRUE);
				}
			}
		}
		(player_stored_collection == NULL) ? NULL : (player_stored_collection = (g_list_free (player_stored_collection), NULL));
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
sound_menu_export (SoundMenu* self,
                   GDBusConnection* connection,
                   const gchar* object_path)
{
	GDBusConnection* _tmp0_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (connection != NULL);
	g_return_if_fail (object_path != NULL);
	_tmp0_ = _g_object_ref0 (connection);
	_g_object_unref0 (self->priv->bus);
	self->priv->bus = _tmp0_;
	{
		guint _tmp1_ = 0U;
		GDBusConnection* _tmp2_;
		GMenu* _tmp3_;
		_tmp2_ = self->priv->bus;
		_tmp3_ = self->root;
		_tmp1_ = g_dbus_connection_export_menu_model (_tmp2_, object_path, (GMenuModel*) _tmp3_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		self->priv->export_id = _tmp1_;
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp4_;
		const gchar* _tmp5_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->message;
		g_critical ("sound-menu.vala:126: %s", _tmp5_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static gint
sound_menu_find_action (SoundMenu* self,
                        GMenu* menu,
                        const gchar* in_action)
{
	gint n = 0;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (menu != NULL, 0);
	g_return_val_if_fail (in_action != NULL, 0);
	n = g_menu_model_get_n_items ((GMenuModel*) menu);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gchar* action = NULL;
				gchar* _tmp2_ = NULL;
				const gchar* _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < n)) {
					break;
				}
				g_menu_model_get_item_attribute ((GMenuModel*) menu, i, "action", "s", &_tmp2_, NULL);
				_g_free0 (action);
				action = _tmp2_;
				_tmp3_ = action;
				if (g_strcmp0 (in_action, _tmp3_) == 0) {
					result = i;
					_g_free0 (action);
					return result;
				}
				_g_free0 (action);
			}
		}
	}
	result = -1;
	return result;
}

void
sound_menu_update_all_players_play_section (SoundMenu* self)
{
	GHashTable* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->notify_handlers;
	_tmp1_ = g_hash_table_get_keys (_tmp0_);
	{
		GList* player_stored_collection = NULL;
		GList* player_stored_it = NULL;
		player_stored_collection = _tmp1_;
		for (player_stored_it = player_stored_collection; player_stored_it != NULL; player_stored_it = player_stored_it->next) {
			MediaPlayer* player_stored = NULL;
			player_stored = (MediaPlayer*) player_stored_it->data;
			{
				gint index = 0;
				MediaPlayer* _tmp2_;
				_tmp2_ = player_stored;
				index = sound_menu_find_player_section (self, _tmp2_);
				if (index != -1) {
					MediaPlayer* _tmp3_;
					_tmp3_ = player_stored;
					sound_menu_update_player_section (self, _tmp3_, index);
				}
			}
		}
		(player_stored_collection == NULL) ? NULL : (player_stored_collection = (g_list_free (player_stored_collection), NULL));
	}
}

static void
sound_menu_check_last_running_player (SoundMenu* self)
{
	GHashTable* _tmp0_;
	GList* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->notify_handlers;
	_tmp1_ = g_hash_table_get_keys (_tmp0_);
	{
		GList* player_collection = NULL;
		GList* player_it = NULL;
		player_collection = _tmp1_;
		for (player_it = player_collection; player_it != NULL; player_it = player_it->next) {
			MediaPlayer* player = NULL;
			player = (MediaPlayer*) player_it->data;
			{
				gboolean _tmp2_ = FALSE;
				MediaPlayer* _tmp3_;
				gboolean _tmp4_;
				gboolean _tmp5_;
				_tmp3_ = player;
				_tmp4_ = media_player_get_is_running (_tmp3_);
				_tmp5_ = _tmp4_;
				if (_tmp5_) {
					_tmp2_ = self->priv->number_of_running_players == 1;
				} else {
					_tmp2_ = FALSE;
				}
				if (_tmp2_) {
					MediaPlayer* _tmp6_;
					const gchar* _tmp7_;
					const gchar* _tmp8_;
					_tmp6_ = player;
					_tmp7_ = media_player_get_id (_tmp6_);
					_tmp8_ = _tmp7_;
					g_signal_emit (self, sound_menu_signals[SOUND_MENU_LAST_PLAYER_UPDATED_SIGNAL], 0, _tmp8_);
				}
			}
		}
		(player_collection == NULL) ? NULL : (player_collection = (g_list_free (player_collection), NULL));
	}
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		SoundMenu* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->player);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static void
__lambda4_ (Block1Data* _data1_)
{
	SoundMenu* self;
	gint index = 0;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = _data1_->self;
	index = sound_menu_find_player_section (self, _data1_->player);
	_tmp0_ = media_player_get_is_running (_data1_->player);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		gint _tmp2_;
		if (index == -1) {
			sound_menu_insert_player_section (self, _data1_->player);
		}
		_tmp2_ = self->priv->number_of_running_players;
		self->priv->number_of_running_players = _tmp2_ + 1;
	} else {
		gint _tmp3_;
		_tmp3_ = self->priv->number_of_running_players;
		self->priv->number_of_running_players = _tmp3_ - 1;
		if (self->priv->hide_inactive) {
			sound_menu_remove_player_section (self, _data1_->player);
		}
	}
	sound_menu_update_playlists (self, _data1_->player);
	sound_menu_update_all_players_play_section (self);
	sound_menu_check_last_running_player (self);
}

static void
___lambda4__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda4_ (self);
}

static void
_sound_menu_update_playlists_media_player_playlists_changed (MediaPlayer* _sender,
                                                             gpointer self)
{
	sound_menu_update_playlists ((SoundMenu*) self, _sender);
}

static void
_sound_menu_update_playbackstatus_media_player_playbackstatus_changed (MediaPlayer* _sender,
                                                                       gpointer self)
{
	sound_menu_update_playbackstatus ((SoundMenu*) self, _sender);
}

void
sound_menu_add_player (SoundMenu* self,
                       MediaPlayer* player)
{
	Block1Data* _data1_;
	MediaPlayer* _tmp0_;
	GHashTable* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gulong handler_id = 0UL;
	gulong _tmp5_;
	GHashTable* _tmp6_;
	MediaPlayer* _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (player != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (player);
	_g_object_unref0 (_data1_->player);
	_data1_->player = _tmp0_;
	_tmp1_ = self->priv->notify_handlers;
	if (g_hash_table_contains (_tmp1_, _data1_->player)) {
		block1_data_unref (_data1_);
		_data1_ = NULL;
		return;
	}
	_tmp3_ = media_player_get_is_running (_data1_->player);
	_tmp4_ = _tmp3_;
	if (_tmp4_) {
		_tmp2_ = TRUE;
	} else {
		_tmp2_ = !self->priv->hide_inactive;
	}
	if (_tmp2_) {
		sound_menu_insert_player_section (self, _data1_->player);
	}
	sound_menu_update_playlists (self, _data1_->player);
	_tmp5_ = g_signal_connect_data ((GObject*) _data1_->player, "notify::is-running", (GCallback) ___lambda4__g_object_notify, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	handler_id = _tmp5_;
	_tmp6_ = self->priv->notify_handlers;
	_tmp7_ = _g_object_ref0 (_data1_->player);
	g_hash_table_insert (_tmp6_, _tmp7_, (gpointer) ((guintptr) handler_id));
	g_signal_connect_object (_data1_->player, "playlists-changed", (GCallback) _sound_menu_update_playlists_media_player_playlists_changed, self, 0);
	g_signal_connect_object (_data1_->player, "playbackstatus-changed", (GCallback) _sound_menu_update_playbackstatus_media_player_playbackstatus_changed, self, 0);
	sound_menu_check_last_running_player (self);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}

void
sound_menu_remove_player (SoundMenu* self,
                          MediaPlayer* player)
{
	gulong id = 0UL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	guint _tmp2_;
	GHashTable* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (player != NULL);
	sound_menu_remove_player_section (self, player);
	_tmp0_ = self->priv->notify_handlers;
	_tmp1_ = g_hash_table_lookup (_tmp0_, player);
	id = (gulong) ((guintptr) _tmp1_);
	if (id != ((gulong) 0)) {
		g_signal_handler_disconnect ((GObject*) player, id);
	}
	g_signal_parse_name ("playlists-changed", TYPE_MEDIA_PLAYER, &_tmp2_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (player, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _sound_menu_update_playlists_media_player_playlists_changed, self);
	_tmp3_ = self->priv->notify_handlers;
	g_hash_table_remove (_tmp3_, player);
	sound_menu_check_last_running_player (self);
}

void
sound_menu_update_volume_slider (SoundMenu* self,
                                 VolumeControlActiveOutput active_output)
{
	gint index = 0;
	GMenu* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->volume_section;
	index = sound_menu_find_action (self, _tmp0_, "indicator.volume");
	if (index != -1) {
		gchar* label = NULL;
		gchar* _tmp1_;
		GMenu* _tmp10_;
		GMenu* _tmp11_;
		const gchar* _tmp12_;
		GMenuItem* _tmp13_;
		GMenuItem* _tmp14_;
		_tmp1_ = g_strdup ("Volume");
		label = _tmp1_;
		switch (active_output) {
			case VOLUME_CONTROL_ACTIVE_OUTPUT_SPEAKERS:
			{
				gchar* _tmp2_;
				_tmp2_ = g_strdup (_ ("Volume"));
				_g_free0 (label);
				label = _tmp2_;
				break;
			}
			case VOLUME_CONTROL_ACTIVE_OUTPUT_HEADPHONES:
			{
				gchar* _tmp3_;
				_tmp3_ = g_strdup (_ ("Volume (Headphones)"));
				_g_free0 (label);
				label = _tmp3_;
				break;
			}
			case VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_SPEAKER:
			{
				gchar* _tmp4_;
				_tmp4_ = g_strdup (_ ("Volume (Bluetooth)"));
				_g_free0 (label);
				label = _tmp4_;
				break;
			}
			case VOLUME_CONTROL_ACTIVE_OUTPUT_USB_SPEAKER:
			{
				gchar* _tmp5_;
				_tmp5_ = g_strdup (_ ("Volume (Usb)"));
				_g_free0 (label);
				label = _tmp5_;
				break;
			}
			case VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_SPEAKER:
			{
				gchar* _tmp6_;
				_tmp6_ = g_strdup (_ ("Volume (HDMI)"));
				_g_free0 (label);
				label = _tmp6_;
				break;
			}
			case VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_HEADPHONES:
			{
				gchar* _tmp7_;
				_tmp7_ = g_strdup (_ ("Volume (Bluetooth headphones)"));
				_g_free0 (label);
				label = _tmp7_;
				break;
			}
			case VOLUME_CONTROL_ACTIVE_OUTPUT_USB_HEADPHONES:
			{
				gchar* _tmp8_;
				_tmp8_ = g_strdup (_ ("Volume (Usb headphones)"));
				_g_free0 (label);
				label = _tmp8_;
				break;
			}
			case VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_HEADPHONES:
			{
				gchar* _tmp9_;
				_tmp9_ = g_strdup (_ ("Volume (HDMI headphones)"));
				_g_free0 (label);
				label = _tmp9_;
				break;
			}
			case VOLUME_CONTROL_ACTIVE_OUTPUT_CALL_MODE:
			{
				break;
			}
			default:
			break;
		}
		_tmp10_ = self->priv->volume_section;
		g_menu_remove (_tmp10_, index);
		_tmp11_ = self->priv->volume_section;
		_tmp12_ = label;
		_tmp13_ = sound_menu_create_slider_menu_item (self, _ (_tmp12_), "indicator.volume(0)", 0.0, 1.0, 0.01, "audio-volume-low-zero", "audio-volume-high", TRUE);
		_tmp14_ = _tmp13_;
		g_menu_insert_item (_tmp11_, index, _tmp14_);
		_g_object_unref0 (_tmp14_);
		_g_free0 (label);
	}
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static gint
sound_menu_find_player_section (SoundMenu* self,
                                MediaPlayer* player)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* action_name = NULL;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gint n = 0;
	GMenu* _tmp6_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (player != NULL, 0);
	_tmp0_ = media_player_get_id (player);
	_tmp1_ = _tmp0_;
	g_debug ("sound-menu.vala:314: Looking for player: %s", _tmp1_);
	_tmp2_ = media_player_get_id (player);
	_tmp3_ = _tmp2_;
	_tmp4_ = string_to_string (_tmp3_);
	_tmp5_ = g_strconcat ("indicator.", _tmp4_, NULL);
	action_name = _tmp5_;
	_tmp6_ = self->menu;
	n = g_menu_model_get_n_items ((GMenuModel*) _tmp6_);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp7_ = FALSE;
			_tmp7_ = TRUE;
			while (TRUE) {
				GMenuModel* section = NULL;
				GMenu* _tmp9_;
				GMenuModel* _tmp10_;
				GMenuModel* _tmp11_;
				gchar* action = NULL;
				GMenuModel* _tmp12_;
				gchar* _tmp13_ = NULL;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
				if (!_tmp7_) {
					gint _tmp8_;
					_tmp8_ = i;
					i = _tmp8_ + 1;
				}
				_tmp7_ = FALSE;
				if (!(i < n)) {
					break;
				}
				_tmp9_ = self->menu;
				_tmp10_ = g_menu_model_get_item_link ((GMenuModel*) _tmp9_, i, G_MENU_LINK_SECTION);
				section = _tmp10_;
				_tmp11_ = section;
				if (_tmp11_ == NULL) {
					_g_object_unref0 (section);
					continue;
				}
				_tmp12_ = section;
				g_menu_model_get_item_attribute (_tmp12_, 0, "action", "s", &_tmp13_, NULL);
				_g_free0 (action);
				action = _tmp13_;
				_tmp14_ = action;
				_tmp15_ = action_name;
				if (g_strcmp0 (_tmp14_, _tmp15_) == 0) {
					result = i;
					_g_free0 (action);
					_g_object_unref0 (section);
					_g_free0 (action_name);
					return result;
				}
				_g_free0 (action);
				_g_object_unref0 (section);
			}
		}
	}
	_tmp16_ = media_player_get_id (player);
	_tmp17_ = _tmp16_;
	g_debug ("sound-menu.vala:327: Unable to find section for player: %s", _tmp17_);
	result = -1;
	_g_free0 (action_name);
	return result;
}

static gint
sound_menu_find_player_playback_controls_section (SoundMenu* self,
                                                  GMenu* player_menu)
{
	gint n = 0;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (player_menu != NULL, 0);
	n = g_menu_model_get_n_items ((GMenuModel*) player_menu);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp0_ = FALSE;
			_tmp0_ = TRUE;
			while (TRUE) {
				gchar* type = NULL;
				gchar* _tmp2_ = NULL;
				const gchar* _tmp3_;
				if (!_tmp0_) {
					gint _tmp1_;
					_tmp1_ = i;
					i = _tmp1_ + 1;
				}
				_tmp0_ = FALSE;
				if (!(i < n)) {
					break;
				}
				g_menu_model_get_item_attribute ((GMenuModel*) player_menu, i, "x-ayatana-type", "s", &_tmp2_, NULL);
				_g_free0 (type);
				type = _tmp2_;
				_tmp3_ = type;
				if (g_strcmp0 (_tmp3_, SOUND_MENU_PLAYBACK_ITEM_TYPE) == 0) {
					result = i;
					_g_free0 (type);
					return result;
				}
				_g_free0 (type);
			}
		}
	}
	result = -1;
	return result;
}

static GMenuItem*
sound_menu_create_playback_menu_item (SoundMenu* self,
                                      MediaPlayer* player)
{
	GMenuItem* playback_item = NULL;
	GMenuItem* _tmp0_;
	GMenuItem* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GMenuItem* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (player != NULL, NULL);
	_tmp0_ = g_menu_item_new (NULL, NULL);
	playback_item = _tmp0_;
	_tmp1_ = playback_item;
	g_menu_item_set_attribute (_tmp1_, "x-ayatana-type", "s", SOUND_MENU_PLAYBACK_ITEM_TYPE, NULL);
	_tmp2_ = media_player_get_is_running (player);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		gboolean _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp11_;
		gboolean _tmp12_;
		gboolean _tmp18_;
		gboolean _tmp19_;
		_tmp4_ = media_player_get_can_do_play (player);
		_tmp5_ = _tmp4_;
		if (_tmp5_) {
			GMenuItem* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			gchar* _tmp9_;
			gchar* _tmp10_;
			_tmp6_ = playback_item;
			_tmp7_ = media_player_get_id (player);
			_tmp8_ = _tmp7_;
			_tmp9_ = g_strconcat ("indicator.play.", _tmp8_, NULL);
			_tmp10_ = _tmp9_;
			g_menu_item_set_attribute (_tmp6_, "x-ayatana-play-action", "s", _tmp10_, NULL);
			_g_free0 (_tmp10_);
		}
		_tmp11_ = media_player_get_can_do_next (player);
		_tmp12_ = _tmp11_;
		if (_tmp12_) {
			GMenuItem* _tmp13_;
			const gchar* _tmp14_;
			const gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
			_tmp13_ = playback_item;
			_tmp14_ = media_player_get_id (player);
			_tmp15_ = _tmp14_;
			_tmp16_ = g_strconcat ("indicator.next.", _tmp15_, NULL);
			_tmp17_ = _tmp16_;
			g_menu_item_set_attribute (_tmp13_, "x-ayatana-next-action", "s", _tmp17_, NULL);
			_g_free0 (_tmp17_);
		}
		_tmp18_ = media_player_get_can_do_prev (player);
		_tmp19_ = _tmp18_;
		if (_tmp19_) {
			GMenuItem* _tmp20_;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
			_tmp20_ = playback_item;
			_tmp21_ = media_player_get_id (player);
			_tmp22_ = _tmp21_;
			_tmp23_ = g_strconcat ("indicator.previous.", _tmp22_, NULL);
			_tmp24_ = _tmp23_;
			g_menu_item_set_attribute (_tmp20_, "x-ayatana-previous-action", "s", _tmp24_, NULL);
			_g_free0 (_tmp24_);
		}
	} else {
		if (self->priv->add_play_button_inactive_player) {
			GMenuItem* _tmp25_;
			const gchar* _tmp26_;
			const gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			_tmp25_ = playback_item;
			_tmp26_ = media_player_get_id (player);
			_tmp27_ = _tmp26_;
			_tmp28_ = g_strconcat ("indicator.play.", _tmp27_, NULL);
			_tmp29_ = _tmp28_;
			g_menu_item_set_attribute (_tmp25_, "x-ayatana-play-action", "s", _tmp29_, NULL);
			_g_free0 (_tmp29_);
		}
	}
	result = playback_item;
	return result;
}

static void
sound_menu_insert_player_section (SoundMenu* self,
                                  MediaPlayer* player)
{
	GMenu* section = NULL;
	GMenu* _tmp0_;
	GIcon* icon = NULL;
	const gchar* _tmp1_ = NULL;
	gboolean _tmp2_;
	gboolean _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GIcon* _tmp6_;
	GIcon* _tmp7_;
	GIcon* _tmp8_;
	GIcon* _tmp9_;
	gchar* base_action = NULL;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	gchar* _tmp13_;
	GMenuItem* player_item = NULL;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	GMenuItem* _tmp19_;
	GMenuItem* _tmp20_;
	GIcon* _tmp21_;
	GMenu* _tmp26_;
	GMenuItem* _tmp27_;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_;
	gboolean _tmp31_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (player != NULL);
	if (self->priv->hide_players) {
		return;
	}
	_tmp0_ = g_menu_new ();
	section = _tmp0_;
	_tmp2_ = media_player_get_is_running (player);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		_tmp1_ = "running";
	} else {
		_tmp1_ = "not running";
	}
	_tmp4_ = media_player_get_id (player);
	_tmp5_ = _tmp4_;
	g_debug ("sound-menu.vala:371: Adding section for player: %s (%s)", _tmp5_, _tmp1_);
	_tmp6_ = media_player_get_icon (player);
	_tmp7_ = _tmp6_;
	_tmp8_ = _g_object_ref0 (_tmp7_);
	_g_object_unref0 (icon);
	icon = _tmp8_;
	_tmp9_ = icon;
	if (_tmp9_ == NULL) {
		GThemedIcon* _tmp10_;
		_tmp10_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks ("application-default-icon");
		_g_object_unref0 (icon);
		icon = (GIcon*) _tmp10_;
	}
	_tmp11_ = media_player_get_id (player);
	_tmp12_ = _tmp11_;
	_tmp13_ = g_strconcat ("indicator.", _tmp12_, NULL);
	base_action = _tmp13_;
	if (self->priv->greeter_players) {
		const gchar* _tmp14_;
		gchar* _tmp15_;
		_tmp14_ = base_action;
		_tmp15_ = g_strconcat (_tmp14_, ".greeter", NULL);
		_g_free0 (base_action);
		base_action = _tmp15_;
	}
	_tmp16_ = media_player_get_name (player);
	_tmp17_ = _tmp16_;
	_tmp18_ = base_action;
	_tmp19_ = g_menu_item_new (_tmp17_, _tmp18_);
	player_item = _tmp19_;
	_tmp20_ = player_item;
	g_menu_item_set_attribute (_tmp20_, "x-ayatana-type", "s", "org.ayatana.indicator.media-player", NULL);
	_tmp21_ = icon;
	if (_tmp21_ != NULL) {
		GMenuItem* _tmp22_;
		GIcon* _tmp23_;
		GVariant* _tmp24_;
		GVariant* _tmp25_;
		_tmp22_ = player_item;
		_tmp23_ = icon;
		_tmp24_ = g_icon_serialize (_tmp23_);
		_tmp25_ = _tmp24_;
		g_menu_item_set_attribute_value (_tmp22_, "icon", _tmp25_);
		_g_variant_unref0 (_tmp25_);
	}
	_tmp26_ = section;
	_tmp27_ = player_item;
	g_menu_append_item (_tmp26_, _tmp27_);
	_tmp30_ = media_player_get_is_running (player);
	_tmp31_ = _tmp30_;
	if (_tmp31_) {
		_tmp29_ = TRUE;
	} else {
		_tmp29_ = !self->priv->hide_inactive_player_controls;
	}
	if (_tmp29_) {
		_tmp28_ = TRUE;
	} else {
		const gchar* _tmp32_;
		const gchar* _tmp33_;
		const gchar* _tmp34_;
		_tmp32_ = media_player_get_id (player);
		_tmp33_ = _tmp32_;
		_tmp34_ = self->priv->default_player;
		_tmp28_ = g_strcmp0 (_tmp33_, _tmp34_) == 0;
	}
	if (_tmp28_) {
		GMenuItem* playback_item = NULL;
		GMenuItem* _tmp35_;
		GMenu* _tmp36_;
		GMenuItem* _tmp37_;
		_tmp35_ = sound_menu_create_playback_menu_item (self, player);
		playback_item = _tmp35_;
		_tmp36_ = section;
		_tmp37_ = playback_item;
		g_menu_insert_item (_tmp36_, (gint) SOUND_MENU_PLAYER_SECTION_POSITION_PLAYER_CONTROLS, _tmp37_);
		_g_object_unref0 (playback_item);
	}
	if (self->priv->settings_shown) {
		GMenu* _tmp38_;
		GMenu* _tmp39_;
		GMenu* _tmp40_;
		_tmp38_ = self->menu;
		_tmp39_ = self->menu;
		_tmp40_ = section;
		g_menu_insert_section (_tmp38_, g_menu_model_get_n_items ((GMenuModel*) _tmp39_) - 1, NULL, (GMenuModel*) _tmp40_);
	} else {
		GMenu* _tmp41_;
		GMenu* _tmp42_;
		_tmp41_ = self->menu;
		_tmp42_ = section;
		g_menu_append_section (_tmp41_, NULL, (GMenuModel*) _tmp42_);
	}
	_g_object_unref0 (player_item);
	_g_free0 (base_action);
	_g_object_unref0 (icon);
	_g_object_unref0 (section);
}

static void
sound_menu_remove_player_section (SoundMenu* self,
                                  MediaPlayer* player)
{
	gint index = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (player != NULL);
	if (self->priv->hide_players) {
		return;
	}
	index = sound_menu_find_player_section (self, player);
	if (index >= 0) {
		GMenu* _tmp0_;
		_tmp0_ = self->menu;
		g_menu_remove (_tmp0_, index);
	}
}

static void
sound_menu_add_player_playback_controls (SoundMenu* self,
                                         MediaPlayer* player,
                                         gint index,
                                         gboolean adding_default_player)
{
	GMenu* player_section = NULL;
	GMenu* _tmp0_;
	GMenuModel* _tmp1_;
	GMenu* _tmp2_;
	gint play_control_index = 0;
	GMenu* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_;
	gboolean _tmp7_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (player != NULL);
	_tmp0_ = self->menu;
	_tmp1_ = g_menu_model_get_item_link ((GMenuModel*) _tmp0_, index, G_MENU_LINK_SECTION);
	_tmp2_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, g_menu_get_type ()) ? ((GMenu*) _tmp1_) : NULL;
	if (_tmp2_ == NULL) {
		_g_object_unref0 (_tmp1_);
	}
	player_section = _tmp2_;
	_tmp3_ = player_section;
	play_control_index = sound_menu_find_player_playback_controls_section (self, _tmp3_);
	_tmp6_ = media_player_get_is_running (player);
	_tmp7_ = _tmp6_;
	if (_tmp7_) {
		_tmp5_ = TRUE;
	} else {
		_tmp5_ = !self->priv->hide_inactive_player_controls;
	}
	if (_tmp5_) {
		_tmp4_ = TRUE;
	} else {
		gboolean _tmp8_ = FALSE;
		if (self->priv->number_of_running_players == 0) {
			_tmp8_ = adding_default_player;
		} else {
			_tmp8_ = FALSE;
		}
		_tmp4_ = _tmp8_;
	}
	if (_tmp4_) {
		GMenuItem* playback_item = NULL;
		GMenuItem* _tmp9_;
		GMenu* _tmp11_;
		GMenuItem* _tmp12_;
		_tmp9_ = sound_menu_create_playback_menu_item (self, player);
		playback_item = _tmp9_;
		if (play_control_index != -1) {
			GMenu* _tmp10_;
			_tmp10_ = player_section;
			g_menu_remove (_tmp10_, (gint) SOUND_MENU_PLAYER_SECTION_POSITION_PLAYER_CONTROLS);
		}
		_tmp11_ = player_section;
		_tmp12_ = playback_item;
		g_menu_insert_item (_tmp11_, (gint) SOUND_MENU_PLAYER_SECTION_POSITION_PLAYER_CONTROLS, _tmp12_);
		_g_object_unref0 (playback_item);
	} else {
		gboolean _tmp13_ = FALSE;
		if (play_control_index != -1) {
			_tmp13_ = self->priv->number_of_running_players >= 1;
		} else {
			_tmp13_ = FALSE;
		}
		if (_tmp13_) {
			GMenu* _tmp14_;
			GMenu* _tmp15_;
			_tmp14_ = player_section;
			g_menu_remove (_tmp14_, (gint) SOUND_MENU_PLAYER_SECTION_POSITION_PLAYLIST);
			_tmp15_ = player_section;
			g_menu_remove (_tmp15_, (gint) SOUND_MENU_PLAYER_SECTION_POSITION_PLAYER_CONTROLS);
		}
	}
	_g_object_unref0 (player_section);
}

static void
sound_menu_update_player_section (SoundMenu* self,
                                  MediaPlayer* player,
                                  gint index)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (player != NULL);
	sound_menu_add_player_playback_controls (self, player, index, FALSE);
}

static void
sound_menu_update_playlists (SoundMenu* self,
                             MediaPlayer* player)
{
	gint index = 0;
	GMenu* player_section = NULL;
	GMenu* _tmp0_;
	GMenuModel* _tmp1_;
	GMenu* _tmp2_;
	GMenu* _tmp3_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	guint count = 0U;
	GMenu* playlists_section = NULL;
	GMenu* _tmp7_;
	GMenu* submenu = NULL;
	GMenu* _tmp21_;
	GMenu* _tmp22_;
	GMenu* _tmp23_;
	GMenu* _tmp24_;
	GMenu* _tmp25_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (player != NULL);
	index = sound_menu_find_player_section (self, player);
	if (index < 0) {
		return;
	}
	_tmp0_ = self->menu;
	_tmp1_ = g_menu_model_get_item_link ((GMenuModel*) _tmp0_, index, G_MENU_LINK_SECTION);
	_tmp2_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, g_menu_get_type ()) ? ((GMenu*) _tmp1_) : NULL;
	if (_tmp2_ == NULL) {
		_g_object_unref0 (_tmp1_);
	}
	player_section = _tmp2_;
	_tmp3_ = player_section;
	if (g_menu_model_get_n_items ((GMenuModel*) _tmp3_) == 3) {
		GMenu* _tmp4_;
		_tmp4_ = player_section;
		g_menu_remove (_tmp4_, 2);
	}
	_tmp5_ = media_player_get_is_running (player);
	_tmp6_ = _tmp5_;
	if (!_tmp6_) {
		_g_object_unref0 (player_section);
		return;
	}
	count = media_player_get_n_playlists (player);
	if (count == ((guint) 0)) {
		_g_object_unref0 (player_section);
		return;
	}
	_tmp7_ = g_menu_new ();
	playlists_section = _tmp7_;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp8_ = FALSE;
			_tmp8_ = TRUE;
			while (TRUE) {
				gchar* playlist_id = NULL;
				gchar* _tmp10_;
				GMenu* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
				const gchar* _tmp16_;
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				if (!_tmp8_) {
					gint _tmp9_;
					_tmp9_ = i;
					i = _tmp9_ + 1;
				}
				_tmp8_ = FALSE;
				if (!(((guint) i) < count)) {
					break;
				}
				_tmp10_ = media_player_get_playlist_id (player, i);
				playlist_id = _tmp10_;
				_tmp11_ = playlists_section;
				_tmp12_ = media_player_get_playlist_name (player, i);
				_tmp13_ = _tmp12_;
				_tmp14_ = media_player_get_id (player);
				_tmp15_ = _tmp14_;
				_tmp16_ = string_to_string (_tmp15_);
				_tmp17_ = playlist_id;
				_tmp18_ = string_to_string (_tmp17_);
				_tmp19_ = g_strconcat ("indicator.play-playlist.", _tmp16_, "::", _tmp18_, NULL);
				_tmp20_ = _tmp19_;
				g_menu_append (_tmp11_, _tmp13_, _tmp20_);
				_g_free0 (_tmp20_);
				_g_free0 (_tmp13_);
				_g_free0 (playlist_id);
			}
		}
	}
	_tmp21_ = g_menu_new ();
	submenu = _tmp21_;
	_tmp22_ = submenu;
	_tmp23_ = playlists_section;
	g_menu_append_section (_tmp22_, NULL, (GMenuModel*) _tmp23_);
	_tmp24_ = player_section;
	_tmp25_ = submenu;
	g_menu_append_submenu (_tmp24_, _ ("Choose Playlist"), (GMenuModel*) _tmp25_);
	_g_object_unref0 (submenu);
	_g_object_unref0 (playlists_section);
	_g_object_unref0 (player_section);
}

static void
sound_menu_update_playbackstatus (SoundMenu* self,
                                  MediaPlayer* player)
{
	gint index = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (player != NULL);
	index = sound_menu_find_player_section (self, player);
	if (index != -1) {
		sound_menu_update_player_section (self, player, index);
	}
}

static GMenuItem*
sound_menu_create_slider_menu_item (SoundMenu* self,
                                    const gchar* label,
                                    const gchar* action,
                                    gdouble min,
                                    gdouble max,
                                    gdouble step,
                                    const gchar* min_icon_name,
                                    const gchar* max_icon_name,
                                    gboolean sync_action)
{
	GThemedIcon* min_icon = NULL;
	GThemedIcon* _tmp0_;
	GThemedIcon* max_icon = NULL;
	GThemedIcon* _tmp1_;
	GMenuItem* slider = NULL;
	GMenuItem* _tmp2_;
	GMenuItem* _tmp3_;
	GMenuItem* _tmp4_;
	GThemedIcon* _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	GMenuItem* _tmp8_;
	GThemedIcon* _tmp9_;
	GVariant* _tmp10_;
	GVariant* _tmp11_;
	GMenuItem* _tmp12_;
	GMenuItem* _tmp13_;
	GMenuItem* _tmp14_;
	gboolean bLomiri = FALSE;
	GMenuItem* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (label != NULL, NULL);
	g_return_val_if_fail (action != NULL, NULL);
	g_return_val_if_fail (min_icon_name != NULL, NULL);
	g_return_val_if_fail (max_icon_name != NULL, NULL);
	_tmp0_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks (min_icon_name);
	min_icon = _tmp0_;
	_tmp1_ = (GThemedIcon*) g_themed_icon_new_with_default_fallbacks (max_icon_name);
	max_icon = _tmp1_;
	_tmp2_ = g_menu_item_new (label, action);
	slider = _tmp2_;
	_tmp3_ = slider;
	g_menu_item_set_attribute (_tmp3_, "x-ayatana-type", "s", "org.ayatana.indicator.slider", NULL);
	_tmp4_ = slider;
	_tmp5_ = min_icon;
	_tmp6_ = g_icon_serialize ((GIcon*) _tmp5_);
	_tmp7_ = _tmp6_;
	g_menu_item_set_attribute_value (_tmp4_, "min-icon", _tmp7_);
	_g_variant_unref0 (_tmp7_);
	_tmp8_ = slider;
	_tmp9_ = max_icon;
	_tmp10_ = g_icon_serialize ((GIcon*) _tmp9_);
	_tmp11_ = _tmp10_;
	g_menu_item_set_attribute_value (_tmp8_, "max-icon", _tmp11_);
	_g_variant_unref0 (_tmp11_);
	_tmp12_ = slider;
	g_menu_item_set_attribute (_tmp12_, "min-value", "d", min, NULL);
	_tmp13_ = slider;
	g_menu_item_set_attribute (_tmp13_, "max-value", "d", max, NULL);
	_tmp14_ = slider;
	g_menu_item_set_attribute (_tmp14_, "step", "d", step, NULL);
	bLomiri = ayatana_common_utils_is_lomiri ();
	if (!bLomiri) {
		GMenuItem* _tmp15_;
		_tmp15_ = slider;
		g_menu_item_set_attribute (_tmp15_, "digits", "y", 2, NULL);
	}
	if (sync_action) {
		GMenuItem* _tmp16_;
		_tmp16_ = slider;
		g_menu_item_set_attribute (_tmp16_, "x-ayatana-sync-action", "s", "indicator.volume-sync", NULL);
	}
	result = slider;
	_g_object_unref0 (max_icon);
	_g_object_unref0 (min_icon);
	return result;
}

gboolean
sound_menu_get_show_mic_volume (SoundMenu* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->mic_volume_shown;
	return result;
}

void
sound_menu_set_show_mic_volume (SoundMenu* self,
                                gboolean value)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	if (value) {
		_tmp0_ = !self->priv->mic_volume_shown;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GMenuItem* slider = NULL;
		GMenuItem* _tmp1_;
		GMenu* _tmp2_;
		GMenuItem* _tmp3_;
		_tmp1_ = sound_menu_create_slider_menu_item (self, _ ("Microphone Volume"), "indicator.mic-volume", 0.0, 1.0, 0.01, "audio-input-microphone-low-zero", "audio-input-microphone-high", FALSE);
		slider = _tmp1_;
		_tmp2_ = self->priv->volume_section;
		_tmp3_ = slider;
		g_menu_append_item (_tmp2_, _tmp3_);
		self->priv->mic_volume_shown = TRUE;
		_g_object_unref0 (slider);
	} else {
		gboolean _tmp4_ = FALSE;
		if (!value) {
			_tmp4_ = self->priv->mic_volume_shown;
		} else {
			_tmp4_ = FALSE;
		}
		if (_tmp4_) {
			gint location = 0;
			location = -1;
			while (TRUE) {
				GMenu* _tmp5_;
				GMenu* _tmp6_;
				_tmp5_ = self->priv->volume_section;
				location = sound_menu_find_action (self, _tmp5_, "indicator.mic-volume");
				if (!(location != -1)) {
					break;
				}
				_tmp6_ = self->priv->volume_section;
				g_menu_remove (_tmp6_, location);
			}
			self->priv->mic_volume_shown = FALSE;
		}
	}
	g_object_notify_by_pspec ((GObject *) self, sound_menu_properties[SOUND_MENU_SHOW_MIC_VOLUME_PROPERTY]);
}

gboolean
sound_menu_get_show_high_volume_warning (SoundMenu* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->high_volume_warning_shown;
	return result;
}

void
sound_menu_set_show_high_volume_warning (SoundMenu* self,
                                         gboolean value)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	if (value) {
		_tmp0_ = !self->priv->high_volume_warning_shown;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GMenuItem* item = NULL;
		GMenuItem* _tmp1_;
		GMenu* _tmp2_;
		GMenuItem* _tmp3_;
		_tmp1_ = g_menu_item_new (_ ("High volume can damage your hearing."), "indicator.high-volume-warning-item");
		item = _tmp1_;
		_tmp2_ = self->priv->volume_section;
		_tmp3_ = item;
		g_menu_append_item (_tmp2_, _tmp3_);
		self->priv->high_volume_warning_shown = TRUE;
		_g_object_unref0 (item);
	} else {
		gboolean _tmp4_ = FALSE;
		if (!value) {
			_tmp4_ = self->priv->high_volume_warning_shown;
		} else {
			_tmp4_ = FALSE;
		}
		if (_tmp4_) {
			gint location = 0;
			location = -1;
			while (TRUE) {
				GMenu* _tmp5_;
				GMenu* _tmp6_;
				_tmp5_ = self->priv->volume_section;
				location = sound_menu_find_action (self, _tmp5_, "indicator.high-volume-warning-item");
				if (!(location != -1)) {
					break;
				}
				_tmp6_ = self->priv->volume_section;
				g_menu_remove (_tmp6_, location);
			}
			self->priv->high_volume_warning_shown = FALSE;
		}
	}
	g_object_notify_by_pspec ((GObject *) self, sound_menu_properties[SOUND_MENU_SHOW_HIGH_VOLUME_WARNING_PROPERTY]);
}

static void
sound_menu_class_init (SoundMenuClass * klass,
                       gpointer klass_data)
{
	sound_menu_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &SoundMenu_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_menu_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_menu_set_property;
	G_OBJECT_CLASS (klass)->finalize = sound_menu_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_MENU_SHOW_MIC_VOLUME_PROPERTY, sound_menu_properties[SOUND_MENU_SHOW_MIC_VOLUME_PROPERTY] = g_param_spec_boolean ("show-mic-volume", "show-mic-volume", "show-mic-volume", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_MENU_SHOW_HIGH_VOLUME_WARNING_PROPERTY, sound_menu_properties[SOUND_MENU_SHOW_HIGH_VOLUME_WARNING_PROPERTY] = g_param_spec_boolean ("show-high-volume-warning", "show-high-volume-warning", "show-high-volume-warning", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	sound_menu_signals[SOUND_MENU_LAST_PLAYER_UPDATED_SIGNAL] = g_signal_new ("last-player-updated", TYPE_SOUND_MENU, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
}

static void
sound_menu_instance_init (SoundMenu * self,
                          gpointer klass)
{
	gchar* _tmp0_;
	self->priv = sound_menu_get_instance_private (self);
	self->priv->bus = NULL;
	self->priv->export_id = (guint) 0;
	self->priv->settings_shown = FALSE;
	self->priv->high_volume_warning_shown = FALSE;
	self->priv->hide_players = FALSE;
	self->priv->hide_inactive_player_controls = FALSE;
	self->priv->add_play_button_inactive_player = FALSE;
	self->priv->greeter_players = FALSE;
	self->priv->number_of_running_players = 0;
	_tmp0_ = g_strdup ("");
	self->priv->default_player = _tmp0_;
}

static void
sound_menu_finalize (GObject * obj)
{
	SoundMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SOUND_MENU, SoundMenu);
	if (self->priv->export_id != ((guint) 0)) {
		GDBusConnection* _tmp0_;
		_tmp0_ = self->priv->bus;
		g_dbus_connection_unexport_menu_model (_tmp0_, self->priv->export_id);
		self->priv->export_id = (guint) 0;
	}
	_g_object_unref0 (self->priv->bus);
	_g_object_unref0 (self->root);
	_g_object_unref0 (self->menu);
	_g_object_unref0 (self->priv->volume_section);
	_g_hash_table_unref0 (self->priv->notify_handlers);
	_g_free0 (self->priv->default_player);
	G_OBJECT_CLASS (sound_menu_parent_class)->finalize (obj);
}

static GType
sound_menu_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundMenu), 0, (GInstanceInitFunc) sound_menu_instance_init, NULL };
	GType sound_menu_type_id;
	sound_menu_type_id = g_type_register_static (G_TYPE_OBJECT, "SoundMenu", &g_define_type_info, 0);
	SoundMenu_private_offset = g_type_add_instance_private (sound_menu_type_id, sizeof (SoundMenuPrivate));
	return sound_menu_type_id;
}

GType
sound_menu_get_type (void)
{
	static volatile gsize sound_menu_type_id__once = 0;
	if (g_once_init_enter (&sound_menu_type_id__once)) {
		GType sound_menu_type_id;
		sound_menu_type_id = sound_menu_get_type_once ();
		g_once_init_leave (&sound_menu_type_id__once, sound_menu_type_id);
	}
	return sound_menu_type_id__once;
}

static void
_vala_sound_menu_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	SoundMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SOUND_MENU, SoundMenu);
	switch (property_id) {
		case SOUND_MENU_SHOW_MIC_VOLUME_PROPERTY:
		g_value_set_boolean (value, sound_menu_get_show_mic_volume (self));
		break;
		case SOUND_MENU_SHOW_HIGH_VOLUME_WARNING_PROPERTY:
		g_value_set_boolean (value, sound_menu_get_show_high_volume_warning (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_sound_menu_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	SoundMenu * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SOUND_MENU, SoundMenu);
	switch (property_id) {
		case SOUND_MENU_SHOW_MIC_VOLUME_PROPERTY:
		sound_menu_set_show_mic_volume (self, g_value_get_boolean (value));
		break;
		case SOUND_MENU_SHOW_HIGH_VOLUME_WARNING_PROPERTY:
		sound_menu_set_show_high_volume_warning (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

