/* volume-control-pulse.c generated by valac 0.56.16, the Vala compiler
 * generated from volume-control-pulse.vala, do not modify */

/*
 * Copyright 2013 Canonical Ltd.
 * Copyright 2021-2023 Robert Tari
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Alberto Ruiz <alberto.ruiz@canonical.com>
 *      Robert Tari <robert@tari.in>
 */

#include <glib-object.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <pulse/glib-mainloop.h>
#include <pulse/pulseaudio.h>
#include <gio/gio.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <ayatana/common/utils.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_VOLUME_CONTROL (volume_control_get_type ())
#define VOLUME_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VOLUME_CONTROL, VolumeControl))
#define VOLUME_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VOLUME_CONTROL, VolumeControlClass))
#define IS_VOLUME_CONTROL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VOLUME_CONTROL))
#define IS_VOLUME_CONTROL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VOLUME_CONTROL))
#define VOLUME_CONTROL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VOLUME_CONTROL, VolumeControlClass))

typedef struct _VolumeControl VolumeControl;
typedef struct _VolumeControlClass VolumeControlClass;
typedef struct _VolumeControlPrivate VolumeControlPrivate;
typedef enum  {
	VOLUME_CONTROL_ACTIVE_OUTPUT_SPEAKERS,
	VOLUME_CONTROL_ACTIVE_OUTPUT_HEADPHONES,
	VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_HEADPHONES,
	VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_SPEAKER,
	VOLUME_CONTROL_ACTIVE_OUTPUT_USB_SPEAKER,
	VOLUME_CONTROL_ACTIVE_OUTPUT_USB_HEADPHONES,
	VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_SPEAKER,
	VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_HEADPHONES,
	VOLUME_CONTROL_ACTIVE_OUTPUT_CALL_MODE
} VolumeControlActiveOutput;

#define VOLUME_CONTROL_TYPE_ACTIVE_OUTPUT (volume_control_active_output_get_type ())

#define VOLUME_CONTROL_TYPE_VOLUME (volume_control_volume_get_type ())
#define VOLUME_CONTROL_VOLUME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VOLUME_CONTROL_TYPE_VOLUME, VolumeControlVolume))
#define VOLUME_CONTROL_VOLUME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VOLUME_CONTROL_TYPE_VOLUME, VolumeControlVolumeClass))
#define VOLUME_CONTROL_IS_VOLUME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VOLUME_CONTROL_TYPE_VOLUME))
#define VOLUME_CONTROL_IS_VOLUME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VOLUME_CONTROL_TYPE_VOLUME))
#define VOLUME_CONTROL_VOLUME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VOLUME_CONTROL_TYPE_VOLUME, VolumeControlVolumeClass))

typedef struct _VolumeControlVolume VolumeControlVolume;
typedef struct _VolumeControlVolumeClass VolumeControlVolumeClass;

#define INDICATOR_SOUND_TYPE_OPTIONS (indicator_sound_options_get_type ())
#define INDICATOR_SOUND_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), INDICATOR_SOUND_TYPE_OPTIONS, IndicatorSoundOptions))
#define INDICATOR_SOUND_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), INDICATOR_SOUND_TYPE_OPTIONS, IndicatorSoundOptionsClass))
#define INDICATOR_SOUND_IS_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), INDICATOR_SOUND_TYPE_OPTIONS))
#define INDICATOR_SOUND_IS_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), INDICATOR_SOUND_TYPE_OPTIONS))
#define INDICATOR_SOUND_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), INDICATOR_SOUND_TYPE_OPTIONS, IndicatorSoundOptionsClass))

typedef struct _IndicatorSoundOptions IndicatorSoundOptions;
typedef struct _IndicatorSoundOptionsClass IndicatorSoundOptionsClass;

#define TYPE_VOLUME_CONTROL_PULSE (volume_control_pulse_get_type ())
#define VOLUME_CONTROL_PULSE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VOLUME_CONTROL_PULSE, VolumeControlPulse))
#define VOLUME_CONTROL_PULSE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VOLUME_CONTROL_PULSE, VolumeControlPulseClass))
#define IS_VOLUME_CONTROL_PULSE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VOLUME_CONTROL_PULSE))
#define IS_VOLUME_CONTROL_PULSE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VOLUME_CONTROL_PULSE))
#define VOLUME_CONTROL_PULSE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VOLUME_CONTROL_PULSE, VolumeControlPulseClass))

typedef struct _VolumeControlPulse VolumeControlPulse;
typedef struct _VolumeControlPulseClass VolumeControlPulseClass;
typedef struct _VolumeControlPulsePrivate VolumeControlPulsePrivate;

#define TYPE_ACCOUNTS_SERVICE_ACCESS (accounts_service_access_get_type ())
#define ACCOUNTS_SERVICE_ACCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACCOUNTS_SERVICE_ACCESS, AccountsServiceAccess))
#define ACCOUNTS_SERVICE_ACCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACCOUNTS_SERVICE_ACCESS, AccountsServiceAccessClass))
#define IS_ACCOUNTS_SERVICE_ACCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACCOUNTS_SERVICE_ACCESS))
#define IS_ACCOUNTS_SERVICE_ACCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACCOUNTS_SERVICE_ACCESS))
#define ACCOUNTS_SERVICE_ACCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACCOUNTS_SERVICE_ACCESS, AccountsServiceAccessClass))

typedef struct _AccountsServiceAccess AccountsServiceAccess;
typedef struct _AccountsServiceAccessClass AccountsServiceAccessClass;
enum  {
	VOLUME_CONTROL_PULSE_0_PROPERTY,
	VOLUME_CONTROL_PULSE_ACTIVE_MIC_PROPERTY,
	VOLUME_CONTROL_PULSE_MUTE_PROPERTY,
	VOLUME_CONTROL_PULSE_VOLUME_PROPERTY,
	VOLUME_CONTROL_PULSE_MIC_VOLUME_PROPERTY,
	VOLUME_CONTROL_PULSE_NUM_PROPERTIES
};
static GParamSpec* volume_control_pulse_properties[VOLUME_CONTROL_PULSE_NUM_PROPERTIES];
#define _pa_context_unref0(var) ((var == NULL) ? NULL : (var = (pa_context_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _VolumeControlVolumePrivate VolumeControlVolumePrivate;
typedef enum  {
	VOLUME_CONTROL_VOLUME_REASONS_PULSE_CHANGE,
	VOLUME_CONTROL_VOLUME_REASONS_ACCOUNTS_SERVICE_SET,
	VOLUME_CONTROL_VOLUME_REASONS_DEVICE_OUTPUT_CHANGE,
	VOLUME_CONTROL_VOLUME_REASONS_USER_KEYPRESS,
	VOLUME_CONTROL_VOLUME_REASONS_VOLUME_STREAM_CHANGE
} VolumeControlVolumeReasons;

#define VOLUME_CONTROL_TYPE_VOLUME_REASONS (volume_control_volume_reasons_get_type ())
#define _pa_operation_unref0(var) ((var == NULL) ? NULL : (var = (pa_operation_unref (var), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef enum  {
	VOLUME_CONTROL_STREAM_ALERT,
	VOLUME_CONTROL_STREAM_MULTIMEDIA,
	VOLUME_CONTROL_STREAM_ALARM,
	VOLUME_CONTROL_STREAM_PHONE
} VolumeControlStream;

#define VOLUME_CONTROL_TYPE_STREAM (volume_control_stream_get_type ())
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _VolumeControlPulseUpdateActiveSinkInputData VolumeControlPulseUpdateActiveSinkInputData;
#define _pa_proplist_free0(var) ((var == NULL) ? NULL : (var = (pa_proplist_free (var), NULL)))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
typedef struct _VolumeControlPulseSetVolumeActiveRoleData VolumeControlPulseSetVolumeActiveRoleData;

struct _VolumeControl {
	GObject parent_instance;
	VolumeControlPrivate * priv;
	IndicatorSoundOptions* _options;
};

struct _VolumeControlClass {
	GObjectClass parent_class;
	void (*set_mute) (VolumeControl* self, gboolean mute);
	VolumeControlActiveOutput (*active_output) (VolumeControl* self);
	gboolean (*get_active_mic) (VolumeControl* self);
	void (*set_active_mic) (VolumeControl* self, gboolean value);
	gboolean (*get_mute) (VolumeControl* self);
	VolumeControlVolume* (*get_volume) (VolumeControl* self);
	void (*set_volume) (VolumeControl* self, VolumeControlVolume* value);
	gdouble (*get_mic_volume) (VolumeControl* self);
	void (*set_mic_volume) (VolumeControl* self, gdouble value);
};

struct _VolumeControlPulse {
	VolumeControl parent_instance;
	VolumeControlPulsePrivate * priv;
};

struct _VolumeControlPulseClass {
	VolumeControlClass parent_class;
};

struct _VolumeControlPulsePrivate {
	pa_glib_mainloop* loop;
	guint _reconnect_timer;
	pa_context* context;
	gboolean _mute;
	VolumeControlVolume* _volume;
	gdouble _mic_volume;
	GDBusConnection* _pconn;
	GeeArrayList* _sink_input_list;
	GeeHashMap* _sink_input_hash;
	gboolean _pulse_use_stream_restore;
	gint32 _active_sink_input;
	gchar** _valid_roles;
	gint _valid_roles_length1;
	gint __valid_roles_size_;
	gchar* _objp_role_multimedia;
	gchar* _objp_role_alert;
	gchar* _objp_role_alarm;
	gchar* _objp_role_phone;
	guint _pa_volume_sig_count;
	GRecMutex __lock__pa_volume_sig_count;
	guint _local_volume_timer;
	guint _accountservice_volume_timer;
	gboolean _send_next_local_volume;
	gdouble _account_service_volume;
	VolumeControlActiveOutput _active_output;
	AccountsServiceAccess* _accounts_service_access;
	gboolean _external_mic_detected;
	gboolean _source_sink_mic_activated;
	gboolean _active_mic;
};

struct _VolumeControlVolume {
	GObject parent_instance;
	VolumeControlVolumePrivate * priv;
	gdouble volume;
	VolumeControlVolumeReasons reason;
};

struct _VolumeControlVolumeClass {
	GObjectClass parent_class;
};

struct _VolumeControlPulseUpdateActiveSinkInputData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	VolumeControlPulse* self;
	gint32 index;
	gboolean _tmp0_;
	gboolean _tmp1_;
	GeeArrayList* _tmp2_;
	gchar* sink_input_objp;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	GeeHashMap* _tmp5_;
	gpointer _tmp6_;
	VolumeControlStream stream;
	VolumeControlStream _tmp7_;
	VolumeControlStream _tmp8_;
	GVariantBuilder* builder;
	const GVariantType* _tmp9_;
	GVariantBuilder* _tmp10_;
	GVariantBuilder* _tmp11_;
	const gchar* _tmp12_;
	GDBusConnection* _tmp13_;
	GVariantBuilder* _tmp14_;
	GVariant* _tmp15_;
	GVariant* _tmp16_;
	GVariant* _tmp17_;
	GVariant* _tmp18_;
	GError* e;
	GError* _tmp19_;
	const gchar* _tmp20_;
	GVariant* props_variant;
	GDBusConnection* _tmp21_;
	const gchar* _tmp22_;
	GVariant* _tmp23_;
	GVariant* _tmp24_;
	GVariant* _tmp25_;
	GVariant* _tmp26_;
	GVariant* tmp;
	GVariant* _tmp27_;
	GVariant* _tmp28_;
	guint32 type;
	guint32 volume;
	GVariantIter* iter;
	GVariant* _tmp29_;
	GVariantIter* _tmp30_;
	GVariantIter* _tmp31_;
	VolumeControlVolume* vol;
	VolumeControlVolume* _tmp32_;
	VolumeControlVolume* _tmp33_;
	VolumeControlVolume* _tmp34_;
	VolumeControlVolume* _tmp35_;
	GError* _vala1_e;
	const gchar* _tmp36_;
	GError* _tmp37_;
	const gchar* _tmp38_;
	GError* _inner_error0_;
};

struct _VolumeControlPulseSetVolumeActiveRoleData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	VolumeControlPulse* self;
	gchar* active_role_objp;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	GeeArrayList* _tmp3_;
	GeeHashMap* _tmp4_;
	gpointer _tmp5_;
	gdouble vol;
	VolumeControlVolume* _tmp6_;
	GVariantBuilder* builder;
	GVariantType* _tmp7_;
	GVariantType* _tmp8_;
	GVariantBuilder* _tmp9_;
	GVariantBuilder* _tmp10_;
	GVariant* volume;
	GVariant* _tmp11_;
	guint _tmp12_;
	GDBusConnection* _tmp13_;
	const gchar* _tmp14_;
	GVariant* _tmp15_;
	GVariant* _tmp16_;
	GVariant* _tmp17_;
	GVariant* _tmp18_;
	GError* e;
	guint _tmp19_;
	const gchar* _tmp20_;
	GError* _tmp21_;
	const gchar* _tmp22_;
	GError* _inner_error0_;
};

static gint VolumeControlPulse_private_offset;
static gpointer volume_control_pulse_parent_class = NULL;

VALA_EXTERN GType volume_control_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VolumeControl, g_object_unref)
VALA_EXTERN GType volume_control_active_output_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType volume_control_volume_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VolumeControlVolume, g_object_unref)
VALA_EXTERN GType indicator_sound_options_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IndicatorSoundOptions, g_object_unref)
VALA_EXTERN GType volume_control_pulse_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VolumeControlPulse, g_object_unref)
VALA_EXTERN GType accounts_service_access_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (AccountsServiceAccess, g_object_unref)
VALA_EXTERN void volume_control_set_mute (VolumeControl* self,
                              gboolean mute);
VALA_EXTERN VolumeControlActiveOutput volume_control_active_output (VolumeControl* self);
VALA_EXTERN gboolean volume_control_get_active_mic (VolumeControl* self);
VALA_EXTERN void volume_control_set_active_mic (VolumeControl* self,
                                    gboolean value);
VALA_EXTERN gboolean volume_control_get_mute (VolumeControl* self);
VALA_EXTERN VolumeControlVolume* volume_control_get_volume (VolumeControl* self);
VALA_EXTERN void volume_control_set_volume (VolumeControl* self,
                                VolumeControlVolume* value);
VALA_EXTERN gdouble volume_control_get_mic_volume (VolumeControl* self);
VALA_EXTERN void volume_control_set_mic_volume (VolumeControl* self,
                                    gdouble value);
static void volume_control_pulse_stop_all_timers (VolumeControlPulse* self);
VALA_EXTERN VolumeControlVolume* volume_control_volume_new (void);
VALA_EXTERN VolumeControlVolume* volume_control_volume_construct (GType object_type);
VALA_EXTERN VolumeControlPulse* volume_control_pulse_new (IndicatorSoundOptions* options,
                                              pa_glib_mainloop* loop,
                                              AccountsServiceAccess* accounts_service_access);
VALA_EXTERN VolumeControlPulse* volume_control_pulse_construct (GType object_type,
                                                    IndicatorSoundOptions* options,
                                                    pa_glib_mainloop* loop,
                                                    AccountsServiceAccess* accounts_service_access);
VALA_EXTERN VolumeControl* volume_control_construct (GType object_type,
                                         IndicatorSoundOptions* options);
VALA_EXTERN GType volume_control_volume_reasons_get_type (void) G_GNUC_CONST ;
static void __lambda4_ (VolumeControlPulse* self);
VALA_EXTERN gdouble accounts_service_access_get_volume (AccountsServiceAccess* self);
static void volume_control_pulse_start_account_service_volume_timer (VolumeControlPulse* self);
static void ___lambda4__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void __lambda5_ (VolumeControlPulse* self);
VALA_EXTERN gboolean accounts_service_access_get_mute (AccountsServiceAccess* self);
static gboolean volume_control_pulse_set_mute_internal (VolumeControlPulse* self,
                                                 gboolean mute);
static void ___lambda5__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void volume_control_pulse_reconnect_to_pulse (VolumeControlPulse* self);
static void volume_control_pulse_stop_local_volume_timer (VolumeControlPulse* self);
static void volume_control_pulse_stop_account_service_volume_timer (VolumeControlPulse* self);
VALA_EXTERN VolumeControlActiveOutput volume_control_pulse_calculate_active_output (pa_sink_info* sink);
static gboolean volume_control_pulse_is_external_mic (VolumeControlPulse* self,
                                               pa_source_info* sink);
static void volume_control_pulse_context_events_cb (VolumeControlPulse* self,
                                             pa_context* c,
                                             pa_subscription_event_type_t t,
                                             guint32 index);
static void volume_control_pulse_update_sink (VolumeControlPulse* self);
static void volume_control_pulse_handle_new_sink_input_cb (VolumeControlPulse* self,
                                                    pa_context* c,
                                                    pa_sink_input_info* i,
                                                    gint eol);
static void _volume_control_pulse_handle_new_sink_input_cb_pa_sink_input_info_cb_t (pa_context* c,
                                                                             pa_sink_input_info* i,
                                                                             gint eol,
                                                                             gpointer self);
static void volume_control_pulse_handle_changed_sink_input_cb (VolumeControlPulse* self,
                                                        pa_context* c,
                                                        pa_sink_input_info* i,
                                                        gint eol);
static void _volume_control_pulse_handle_changed_sink_input_cb_pa_sink_input_info_cb_t (pa_context* c,
                                                                                 pa_sink_input_info* i,
                                                                                 gint eol,
                                                                                 gpointer self);
static void volume_control_pulse_remove_sink_input_from_list (VolumeControlPulse* self,
                                                       guint32 index);
static void volume_control_pulse_update_source (VolumeControlPulse* self);
static void volume_control_pulse_source_output_info_cb (VolumeControlPulse* self,
                                                 pa_context* c,
                                                 pa_source_output_info* i,
                                                 gint eol);
static void _volume_control_pulse_source_output_info_cb_pa_source_output_info_cb_t (pa_context* c,
                                                                             pa_source_output_info* i,
                                                                             gint eol,
                                                                             gpointer self);
static void volume_control_pulse_sink_info_cb_for_props (VolumeControlPulse* self,
                                                  pa_context* c,
                                                  pa_sink_info* i,
                                                  gint eol);
VALA_EXTERN gboolean volume_control_get_is_playing (VolumeControl* self);
VALA_EXTERN void volume_control_set_is_playing (VolumeControl* self,
                                    gboolean value);
VALA_EXTERN gdouble volume_control_pulse_volume_to_double (pa_volume_t vol);
static void volume_control_pulse_source_info_cb (VolumeControlPulse* self,
                                          pa_context* c,
                                          pa_source_info* i,
                                          gint eol);
static void volume_control_pulse_server_info_cb_for_props (VolumeControlPulse* self,
                                                    pa_context* c,
                                                    pa_server_info* i);
static void _volume_control_pulse_sink_info_cb_for_props_pa_sink_info_cb_t (pa_context* c,
                                                                     pa_sink_info* i,
                                                                     gint eol,
                                                                     gpointer self);
static void _volume_control_pulse_server_info_cb_for_props_pa_server_info_cb_t (pa_context* c,
                                                                         pa_server_info* i,
                                                                         gpointer self);
static void volume_control_pulse_update_source_get_server_info_cb (VolumeControlPulse* self,
                                                            pa_context* c,
                                                            pa_server_info* i);
static void _volume_control_pulse_source_info_cb_pa_source_info_cb_t (pa_context* c,
                                                               pa_source_info* i,
                                                               gint eol,
                                                               gpointer self);
static void _volume_control_pulse_update_source_get_server_info_cb_pa_server_info_cb_t (pa_context* c,
                                                                                 pa_server_info* i,
                                                                                 gpointer self);
static GDBusMessage* volume_control_pulse_pulse_dbus_filter (VolumeControlPulse* self,
                                                      GDBusConnection* connection,
                                                      GDBusMessage* message,
                                                      gboolean incoming);
VALA_EXTERN pa_volume_t volume_control_pulse_double_to_volume (gdouble vol);
VALA_EXTERN GType volume_control_stream_get_type (void) G_GNUC_CONST ;
static VolumeControlStream volume_control_pulse_calculate_active_stream (VolumeControlPulse* self);
static void volume_control_pulse_update_active_sink_input_data_free (gpointer _data);
static void volume_control_pulse_update_active_sink_input (VolumeControlPulse* self,
                                                    gint32 index,
                                                    GAsyncReadyCallback _callback_,
                                                    gpointer _user_data_);
static void volume_control_pulse_update_active_sink_input_finish (VolumeControlPulse* self,
                                                           GAsyncResult* _res_);
static gboolean volume_control_pulse_update_active_sink_input_co (VolumeControlPulseUpdateActiveSinkInputData* _data_);
VALA_EXTERN VolumeControlStream volume_control_get_active_stream (VolumeControl* self);
VALA_EXTERN void volume_control_set_active_stream (VolumeControl* self,
                                       VolumeControlStream value);
static void volume_control_pulse_update_active_sink_input_ready (GObject* source_object,
                                                          GAsyncResult* _res_,
                                                          gpointer _user_data_);
static void volume_control_pulse_add_sink_input_into_list (VolumeControlPulse* self,
                                                    pa_sink_input_info* sink_input);
static gboolean _vala_string_array_contains (gchar* * stack,
                                      gssize stack_length,
                                      const gchar* needle);
static void volume_control_pulse_context_state_callback (VolumeControlPulse* self,
                                                  pa_context* c);
static void _volume_control_pulse_context_events_cb_pa_context_subscribe_cb_t (pa_context* c,
                                                                        pa_subscription_event_type_t t,
                                                                        guint32 idx,
                                                                        gpointer self);
VALA_EXTERN void volume_control_set_ready (VolumeControl* self,
                               gboolean value);
static gboolean volume_control_pulse_reconnect_timeout (VolumeControlPulse* self);
static gboolean _volume_control_pulse_reconnect_timeout_gsource_func (gpointer self);
VALA_EXTERN gboolean volume_control_get_ready (VolumeControl* self);
static void volume_control_pulse_reconnect_pulse_dbus (VolumeControlPulse* self);
static void _volume_control_pulse_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                          gpointer self);
static void volume_control_pulse_sink_info_list_callback_set_mute (VolumeControlPulse* self,
                                                            pa_context* context,
                                                            pa_sink_info* sink,
                                                            gint eol);
static void volume_control_pulse_sink_info_list_callback_unset_mute (VolumeControlPulse* self,
                                                              pa_context* context,
                                                              pa_sink_info* sink,
                                                              gint eol);
static void _volume_control_pulse_sink_info_list_callback_set_mute_pa_sink_info_cb_t (pa_context* c,
                                                                               pa_sink_info* i,
                                                                               gint eol,
                                                                               gpointer self);
static void _volume_control_pulse_sink_info_list_callback_unset_mute_pa_sink_info_cb_t (pa_context* c,
                                                                                 pa_sink_info* i,
                                                                                 gint eol,
                                                                                 gpointer self);
static void volume_control_pulse_real_set_mute (VolumeControl* base,
                                         gboolean mute);
VALA_EXTERN void accounts_service_access_set_mute (AccountsServiceAccess* self,
                                       gboolean value);
VALA_EXTERN void volume_control_pulse_toggle_mute (VolumeControlPulse* self);
static VolumeControlActiveOutput volume_control_pulse_real_active_output (VolumeControl* base);
static void volume_control_pulse_set_volume_success_cb (VolumeControlPulse* self,
                                                 pa_context* c,
                                                 gint success);
static void volume_control_pulse_sink_info_set_volume_cb (VolumeControlPulse* self,
                                                   pa_context* c,
                                                   pa_sink_info* i,
                                                   gint eol);
static void _volume_control_pulse_set_volume_success_cb_pa_context_success_cb_t (pa_context* c,
                                                                          gint success,
                                                                          gpointer self);
static void volume_control_pulse_server_info_cb_for_set_volume (VolumeControlPulse* self,
                                                         pa_context* c,
                                                         pa_server_info* i);
static void _volume_control_pulse_sink_info_set_volume_cb_pa_sink_info_cb_t (pa_context* c,
                                                                      pa_sink_info* i,
                                                                      gint eol,
                                                                      gpointer self);
static void volume_control_pulse_set_volume_active_role_data_free (gpointer _data);
static void volume_control_pulse_set_volume_active_role (VolumeControlPulse* self,
                                                  GAsyncReadyCallback _callback_,
                                                  gpointer _user_data_);
static void volume_control_pulse_set_volume_active_role_finish (VolumeControlPulse* self,
                                                         GAsyncResult* _res_);
static gboolean volume_control_pulse_set_volume_active_role_co (VolumeControlPulseSetVolumeActiveRoleData* _data_);
static void volume_control_pulse_set_volume_active_role_ready (GObject* source_object,
                                                        GAsyncResult* _res_,
                                                        gpointer _user_data_);
static void volume_control_pulse_set_mic_volume_success_cb (VolumeControlPulse* self,
                                                     pa_context* c,
                                                     gint success);
static void volume_control_pulse_set_mic_volume_get_server_info_cb (VolumeControlPulse* self,
                                                             pa_context* c,
                                                             pa_server_info* i);
static void _volume_control_pulse_set_mic_volume_success_cb_pa_context_success_cb_t (pa_context* c,
                                                                              gint success,
                                                                              gpointer self);
VALA_EXTERN GDBusConnection* volume_control_pulse_create_pulse_dbus_connection (void);
static GDBusMessage* _volume_control_pulse_pulse_dbus_filter_gd_bus_message_filter_function (GDBusConnection* connection,
                                                                                      GDBusMessage* message,
                                                                                      gboolean incoming,
                                                                                      gpointer self);
VALA_EXTERN gchar* volume_control_pulse_stream_restore_get_object_path (GDBusConnection* pconn,
                                                            const gchar* name);
static void volume_control_pulse_start_local_volume_timer (VolumeControlPulse* self);
VALA_EXTERN void accounts_service_access_set_volume (AccountsServiceAccess* self,
                                         gdouble value);
static gboolean volume_control_pulse_local_volume_changed_timeout (VolumeControlPulse* self);
static gboolean _volume_control_pulse_local_volume_changed_timeout_gsource_func (gpointer self);
static gboolean volume_control_pulse_accountservice_volume_changed_timeout (VolumeControlPulse* self);
static gboolean _volume_control_pulse_accountservice_volume_changed_timeout_gsource_func (gpointer self);
static void _volume_control_pulse_server_info_cb_for_set_volume_pa_server_info_cb_t (pa_context* c,
                                                                              pa_server_info* i,
                                                                              gpointer self);
static void _volume_control_pulse_set_mic_volume_get_server_info_cb_pa_server_info_cb_t (pa_context* c,
                                                                                  pa_server_info* i,
                                                                                  gpointer self);
static void volume_control_pulse_finalize (GObject * obj);
static GType volume_control_pulse_get_type_once (void);
static void _vala_volume_control_pulse_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_volume_control_pulse_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
volume_control_pulse_get_instance_private (VolumeControlPulse* self)
{
	return G_STRUCT_MEMBER_P (self, VolumeControlPulse_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
__lambda4_ (VolumeControlPulse* self)
{
	gboolean _tmp0_ = FALSE;
	AccountsServiceAccess* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	_tmp1_ = self->priv->_accounts_service_access;
	_tmp2_ = accounts_service_access_get_volume (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_ >= ((gdouble) 0)) {
		AccountsServiceAccess* _tmp4_;
		gdouble _tmp5_;
		gdouble _tmp6_;
		_tmp4_ = self->priv->_accounts_service_access;
		_tmp5_ = accounts_service_access_get_volume (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp0_ = self->priv->_account_service_volume != _tmp6_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		AccountsServiceAccess* _tmp7_;
		gdouble _tmp8_;
		gdouble _tmp9_;
		_tmp7_ = self->priv->_accounts_service_access;
		_tmp8_ = accounts_service_access_get_volume (_tmp7_);
		_tmp9_ = _tmp8_;
		self->priv->_account_service_volume = _tmp9_;
		volume_control_pulse_start_account_service_volume_timer (self);
	}
}

static void
___lambda4__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda4_ ((VolumeControlPulse*) self);
}

static void
__lambda5_ (VolumeControlPulse* self)
{
	AccountsServiceAccess* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	_tmp0_ = self->priv->_accounts_service_access;
	_tmp1_ = accounts_service_access_get_mute (_tmp0_);
	_tmp2_ = _tmp1_;
	if (self->priv->_mute != _tmp2_) {
		AccountsServiceAccess* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = self->priv->_accounts_service_access;
		_tmp4_ = accounts_service_access_get_mute (_tmp3_);
		_tmp5_ = _tmp4_;
		volume_control_pulse_set_mute_internal (self, _tmp5_);
		volume_control_pulse_start_account_service_volume_timer (self);
	}
}

static void
___lambda5__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda5_ ((VolumeControlPulse*) self);
}

VolumeControlPulse*
volume_control_pulse_construct (GType object_type,
                                IndicatorSoundOptions* options,
                                pa_glib_mainloop* loop,
                                AccountsServiceAccess* accounts_service_access)
{
	VolumeControlPulse * self = NULL;
	VolumeControlVolume* _tmp0_;
	VolumeControlVolume* _tmp1_;
	AccountsServiceAccess* _tmp2_;
	AccountsServiceAccess* _tmp3_;
	AccountsServiceAccess* _tmp4_;
	g_return_val_if_fail (options != NULL, NULL);
	g_return_val_if_fail (loop != NULL, NULL);
	self = (VolumeControlPulse*) volume_control_construct (object_type, options);
	_tmp0_ = self->priv->_volume;
	_tmp0_->volume = 0.0;
	_tmp1_ = self->priv->_volume;
	_tmp1_->reason = VOLUME_CONTROL_VOLUME_REASONS_PULSE_CHANGE;
	self->priv->loop = loop;
	_tmp2_ = _g_object_ref0 (accounts_service_access);
	_g_object_unref0 (self->priv->_accounts_service_access);
	self->priv->_accounts_service_access = _tmp2_;
	_tmp3_ = self->priv->_accounts_service_access;
	g_signal_connect_object ((GObject*) _tmp3_, "notify::volume", (GCallback) ___lambda4__g_object_notify, self, 0);
	_tmp4_ = self->priv->_accounts_service_access;
	g_signal_connect_object ((GObject*) _tmp4_, "notify::mute", (GCallback) ___lambda5__g_object_notify, self, 0);
	volume_control_pulse_reconnect_to_pulse (self);
	return self;
}

VolumeControlPulse*
volume_control_pulse_new (IndicatorSoundOptions* options,
                          pa_glib_mainloop* loop,
                          AccountsServiceAccess* accounts_service_access)
{
	return volume_control_pulse_construct (TYPE_VOLUME_CONTROL_PULSE, options, loop, accounts_service_access);
}

static void
volume_control_pulse_stop_all_timers (VolumeControlPulse* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->_reconnect_timer != ((guint) 0)) {
		g_source_remove (self->priv->_reconnect_timer);
		self->priv->_reconnect_timer = (guint) 0;
	}
	volume_control_pulse_stop_local_volume_timer (self);
	volume_control_pulse_stop_account_service_volume_timer (self);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

VolumeControlActiveOutput
volume_control_pulse_calculate_active_output (pa_sink_info* sink)
{
	VolumeControlActiveOutput ret_output = 0;
	gboolean _tmp0_ = FALSE;
	pa_sink_port_info* _tmp1_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	VolumeControlActiveOutput result;
	ret_output = VOLUME_CONTROL_ACTIVE_OUTPUT_SPEAKERS;
	_tmp1_ = (*sink).active_port;
	if (_tmp1_ != NULL) {
		pa_sink_port_info* _tmp2_;
		const gchar* _tmp3_;
		_tmp2_ = (*sink).active_port;
		_tmp3_ = (*_tmp2_).name;
		_tmp0_ = g_strcmp0 (_tmp3_, "output-speaker+wired_headphone") == 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		result = VOLUME_CONTROL_ACTIVE_OUTPUT_CALL_MODE;
		return result;
	}
	_tmp5_ = (*sink).name;
	if (g_strcmp0 (_tmp5_, "indicator_sound_test_headphones") == 0) {
		_tmp4_ = TRUE;
	} else {
		gboolean _tmp6_ = FALSE;
		pa_sink_port_info* _tmp7_;
		_tmp7_ = (*sink).active_port;
		if (_tmp7_ != NULL) {
			gboolean _tmp8_ = FALSE;
			pa_sink_port_info* _tmp9_;
			const gchar* _tmp10_;
			_tmp9_ = (*sink).active_port;
			_tmp10_ = (*_tmp9_).name;
			if (string_contains (_tmp10_, "headset")) {
				_tmp8_ = TRUE;
			} else {
				pa_sink_port_info* _tmp11_;
				const gchar* _tmp12_;
				_tmp11_ = (*sink).active_port;
				_tmp12_ = (*_tmp11_).name;
				_tmp8_ = string_contains (_tmp12_, "headphone");
			}
			_tmp6_ = _tmp8_;
		} else {
			_tmp6_ = FALSE;
		}
		_tmp4_ = _tmp6_;
	}
	if (_tmp4_) {
		const gchar* device_bus = NULL;
		pa_proplist* _tmp13_;
		const gchar* _tmp14_;
		gboolean _tmp15_ = FALSE;
		const gchar* _tmp16_;
		_tmp13_ = (*sink).proplist;
		_tmp14_ = pa_proplist_gets (_tmp13_, "device.bus");
		device_bus = _tmp14_;
		_tmp16_ = device_bus;
		if (_tmp16_ != NULL) {
			const gchar* _tmp17_;
			_tmp17_ = device_bus;
			_tmp15_ = g_strcmp0 (_tmp17_, "bluetooth") == 0;
		} else {
			_tmp15_ = FALSE;
		}
		if (_tmp15_) {
			ret_output = VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_HEADPHONES;
		} else {
			gboolean _tmp18_ = FALSE;
			const gchar* _tmp19_;
			_tmp19_ = device_bus;
			if (_tmp19_ != NULL) {
				const gchar* _tmp20_;
				_tmp20_ = device_bus;
				_tmp18_ = g_strcmp0 (_tmp20_, "usb") == 0;
			} else {
				_tmp18_ = FALSE;
			}
			if (_tmp18_) {
				ret_output = VOLUME_CONTROL_ACTIVE_OUTPUT_USB_HEADPHONES;
			} else {
				gboolean _tmp21_ = FALSE;
				const gchar* _tmp22_;
				_tmp22_ = device_bus;
				if (_tmp22_ != NULL) {
					const gchar* _tmp23_;
					_tmp23_ = device_bus;
					_tmp21_ = g_strcmp0 (_tmp23_, "hdmi") == 0;
				} else {
					_tmp21_ = FALSE;
				}
				if (_tmp21_) {
					ret_output = VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_HEADPHONES;
				} else {
					ret_output = VOLUME_CONTROL_ACTIVE_OUTPUT_HEADPHONES;
				}
			}
		}
	} else {
		const gchar* device_bus = NULL;
		pa_proplist* _tmp24_;
		const gchar* _tmp25_;
		gboolean _tmp26_ = FALSE;
		const gchar* _tmp27_;
		_tmp24_ = (*sink).proplist;
		_tmp25_ = pa_proplist_gets (_tmp24_, "device.bus");
		device_bus = _tmp25_;
		_tmp27_ = device_bus;
		if (_tmp27_ != NULL) {
			const gchar* _tmp28_;
			_tmp28_ = device_bus;
			_tmp26_ = g_strcmp0 (_tmp28_, "bluetooth") == 0;
		} else {
			_tmp26_ = FALSE;
		}
		if (_tmp26_) {
			ret_output = VOLUME_CONTROL_ACTIVE_OUTPUT_BLUETOOTH_SPEAKER;
		} else {
			gboolean _tmp29_ = FALSE;
			const gchar* _tmp30_;
			_tmp30_ = device_bus;
			if (_tmp30_ != NULL) {
				const gchar* _tmp31_;
				_tmp31_ = device_bus;
				_tmp29_ = g_strcmp0 (_tmp31_, "usb") == 0;
			} else {
				_tmp29_ = FALSE;
			}
			if (_tmp29_) {
				ret_output = VOLUME_CONTROL_ACTIVE_OUTPUT_USB_SPEAKER;
			} else {
				gboolean _tmp32_ = FALSE;
				const gchar* _tmp33_;
				_tmp33_ = device_bus;
				if (_tmp33_ != NULL) {
					const gchar* _tmp34_;
					_tmp34_ = device_bus;
					_tmp32_ = g_strcmp0 (_tmp34_, "hdmi") == 0;
				} else {
					_tmp32_ = FALSE;
				}
				if (_tmp32_) {
					ret_output = VOLUME_CONTROL_ACTIVE_OUTPUT_HDMI_SPEAKER;
				} else {
					ret_output = VOLUME_CONTROL_ACTIVE_OUTPUT_SPEAKERS;
				}
			}
		}
	}
	result = ret_output;
	return result;
}

static gboolean
volume_control_pulse_is_external_mic (VolumeControlPulse* self,
                                      pa_source_info* sink)
{
	const gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	pa_source_port_info* _tmp2_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = (*sink).name;
	if (string_contains (_tmp0_, "indicator_sound_test_mic")) {
		result = TRUE;
		return result;
	}
	_tmp2_ = (*sink).active_port;
	if (_tmp2_ != NULL) {
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
		gboolean _tmp5_ = FALSE;
		pa_source_port_info* _tmp6_;
		const gchar* _tmp7_;
		_tmp6_ = (*sink).active_port;
		_tmp7_ = (*_tmp6_).name;
		if (string_contains (_tmp7_, "headphone")) {
			_tmp5_ = TRUE;
		} else {
			pa_source_port_info* _tmp8_;
			const gchar* _tmp9_;
			_tmp8_ = (*sink).active_port;
			_tmp9_ = (*_tmp8_).name;
			_tmp5_ = string_contains (_tmp9_, "headset");
		}
		if (_tmp5_) {
			_tmp4_ = TRUE;
		} else {
			pa_source_port_info* _tmp10_;
			const gchar* _tmp11_;
			_tmp10_ = (*sink).active_port;
			_tmp11_ = (*_tmp10_).name;
			_tmp4_ = string_contains (_tmp11_, "mic");
		}
		if (_tmp4_) {
			gboolean _tmp12_ = FALSE;
			pa_source_port_info* _tmp13_;
			const gchar* _tmp14_;
			_tmp13_ = (*sink).active_port;
			_tmp14_ = (*_tmp13_).name;
			if (!string_contains (_tmp14_, "internal")) {
				pa_source_port_info* _tmp15_;
				const gchar* _tmp16_;
				_tmp15_ = (*sink).active_port;
				_tmp16_ = (*_tmp15_).name;
				_tmp12_ = !string_contains (_tmp16_, "builtin");
			} else {
				_tmp12_ = FALSE;
			}
			_tmp3_ = _tmp12_;
		} else {
			_tmp3_ = FALSE;
		}
		_tmp1_ = _tmp3_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

static void
_volume_control_pulse_handle_new_sink_input_cb_pa_sink_input_info_cb_t (pa_context* c,
                                                                        pa_sink_input_info* i,
                                                                        gint eol,
                                                                        gpointer self)
{
	volume_control_pulse_handle_new_sink_input_cb ((VolumeControlPulse*) self, c, i, eol);
}

static void
_volume_control_pulse_handle_changed_sink_input_cb_pa_sink_input_info_cb_t (pa_context* c,
                                                                            pa_sink_input_info* i,
                                                                            gint eol,
                                                                            gpointer self)
{
	volume_control_pulse_handle_changed_sink_input_cb ((VolumeControlPulse*) self, c, i, eol);
}

static void
_volume_control_pulse_source_output_info_cb_pa_source_output_info_cb_t (pa_context* c,
                                                                        pa_source_output_info* i,
                                                                        gint eol,
                                                                        gpointer self)
{
	volume_control_pulse_source_output_info_cb ((VolumeControlPulse*) self, c, i, eol);
}

static void
volume_control_pulse_context_events_cb (VolumeControlPulse* self,
                                        pa_context* c,
                                        pa_subscription_event_type_t t,
                                        guint32 index)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	switch (t & PA_SUBSCRIPTION_EVENT_FACILITY_MASK) {
		case PA_SUBSCRIPTION_EVENT_SINK:
		{
			volume_control_pulse_update_sink (self);
			break;
		}
		case PA_SUBSCRIPTION_EVENT_SINK_INPUT:
		{
			switch (t & PA_SUBSCRIPTION_EVENT_TYPE_MASK) {
				case PA_SUBSCRIPTION_EVENT_NEW:
				{
					pa_operation* _tmp0_;
					pa_operation* _tmp1_;
					_tmp0_ = pa_context_get_sink_input_info (c, index, _volume_control_pulse_handle_new_sink_input_cb_pa_sink_input_info_cb_t, self);
					_tmp1_ = _tmp0_;
					_pa_operation_unref0 (_tmp1_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_CHANGE:
				{
					pa_operation* _tmp2_;
					pa_operation* _tmp3_;
					_tmp2_ = pa_context_get_sink_input_info (c, index, _volume_control_pulse_handle_changed_sink_input_cb_pa_sink_input_info_cb_t, self);
					_tmp3_ = _tmp2_;
					_pa_operation_unref0 (_tmp3_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_REMOVE:
				{
					volume_control_pulse_remove_sink_input_from_list (self, index);
					break;
				}
				default:
				{
					g_debug ("volume-control-pulse.vala:195: Sink input event not known.");
					break;
				}
			}
			break;
		}
		case PA_SUBSCRIPTION_EVENT_SOURCE:
		{
			volume_control_pulse_update_source (self);
			break;
		}
		case PA_SUBSCRIPTION_EVENT_SOURCE_OUTPUT:
		{
			switch (t & PA_SUBSCRIPTION_EVENT_TYPE_MASK) {
				case PA_SUBSCRIPTION_EVENT_NEW:
				{
					pa_operation* _tmp4_;
					pa_operation* _tmp5_;
					_tmp4_ = pa_context_get_source_output_info (c, index, _volume_control_pulse_source_output_info_cb_pa_source_output_info_cb_t, self);
					_tmp5_ = _tmp4_;
					_pa_operation_unref0 (_tmp5_);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_REMOVE:
				{
					self->priv->_source_sink_mic_activated = FALSE;
					volume_control_set_active_mic ((VolumeControl*) self, self->priv->_external_mic_detected);
					break;
				}
				default:
				{
					break;
				}
			}
			break;
		}
		default:
		{
			break;
		}
	}
}

static void
volume_control_pulse_sink_info_cb_for_props (VolumeControlPulse* self,
                                             pa_context* c,
                                             pa_sink_info* i,
                                             gint eol)
{
	gboolean playing = FALSE;
	gboolean _tmp0_;
	gboolean _tmp1_;
	VolumeControlActiveOutput oldval = 0;
	VolumeControlActiveOutput newval = 0;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (i == NULL) {
		return;
	}
	if (self->priv->_mute != ((gboolean) (*i).mute)) {
		self->priv->_mute = (gboolean) (*i).mute;
		g_object_notify ((GObject*) self, "mute");
	}
	playing = (*i).state == PA_SINK_RUNNING;
	_tmp0_ = volume_control_get_is_playing ((VolumeControl*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ != playing) {
		volume_control_set_is_playing ((VolumeControl*) self, playing);
	}
	oldval = self->priv->_active_output;
	newval = volume_control_pulse_calculate_active_output (i);
	self->priv->_active_output = newval;
	if (oldval != VOLUME_CONTROL_ACTIVE_OUTPUT_CALL_MODE) {
		_tmp3_ = newval != VOLUME_CONTROL_ACTIVE_OUTPUT_CALL_MODE;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		_tmp2_ = oldval != newval;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		g_signal_emit_by_name ((VolumeControl*) self, "active-output-changed", newval);
	}
	if (self->priv->_pulse_use_stream_restore == FALSE) {
		VolumeControlVolume* _tmp5_;
		_tmp5_ = self->priv->_volume;
		_tmp4_ = _tmp5_->volume != volume_control_pulse_volume_to_double (pa_cvolume_max (&(*i).volume));
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		VolumeControlVolume* vol = NULL;
		VolumeControlVolume* _tmp6_;
		VolumeControlVolume* _tmp7_;
		VolumeControlVolume* _tmp8_;
		VolumeControlVolume* _tmp9_;
		_tmp6_ = volume_control_volume_new ();
		vol = _tmp6_;
		_tmp7_ = vol;
		_tmp7_->volume = volume_control_pulse_volume_to_double (pa_cvolume_max (&(*i).volume));
		_tmp8_ = vol;
		_tmp8_->reason = VOLUME_CONTROL_VOLUME_REASONS_PULSE_CHANGE;
		_tmp9_ = vol;
		volume_control_set_volume ((VolumeControl*) self, _tmp9_);
		_g_object_unref0 (vol);
	}
}

static void
volume_control_pulse_source_info_cb (VolumeControlPulse* self,
                                     pa_context* c,
                                     pa_source_info* i,
                                     gint eol)
{
	pa_cvolume _tmp0_;
	pa_volume_t _tmp1_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (i == NULL) {
		return;
	}
	if (volume_control_pulse_is_external_mic (self, i)) {
		volume_control_set_active_mic ((VolumeControl*) self, TRUE);
		self->priv->_external_mic_detected = TRUE;
	} else {
		volume_control_set_active_mic ((VolumeControl*) self, self->priv->_source_sink_mic_activated);
		self->priv->_external_mic_detected = FALSE;
	}
	_tmp0_ = (*i).volume;
	_tmp1_ = _tmp0_.values[0];
	if (self->priv->_mic_volume != volume_control_pulse_volume_to_double (_tmp1_)) {
		pa_cvolume _tmp2_;
		pa_volume_t _tmp3_;
		_tmp2_ = (*i).volume;
		_tmp3_ = _tmp2_.values[0];
		self->priv->_mic_volume = volume_control_pulse_volume_to_double (_tmp3_);
		g_object_notify ((GObject*) self, "mic-volume");
	}
}

static void
_volume_control_pulse_sink_info_cb_for_props_pa_sink_info_cb_t (pa_context* c,
                                                                pa_sink_info* i,
                                                                gint eol,
                                                                gpointer self)
{
	volume_control_pulse_sink_info_cb_for_props ((VolumeControlPulse*) self, c, i, eol);
}

static void
volume_control_pulse_server_info_cb_for_props (VolumeControlPulse* self,
                                               pa_context* c,
                                               pa_server_info* i)
{
	pa_context* _tmp0_;
	const gchar* _tmp1_;
	pa_operation* _tmp2_;
	pa_operation* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (i == NULL) {
		return;
	}
	_tmp0_ = self->priv->context;
	_tmp1_ = (*i).default_sink_name;
	_tmp2_ = pa_context_get_sink_info_by_name (_tmp0_, _tmp1_, _volume_control_pulse_sink_info_cb_for_props_pa_sink_info_cb_t, self);
	_tmp3_ = _tmp2_;
	_pa_operation_unref0 (_tmp3_);
}

static void
_volume_control_pulse_server_info_cb_for_props_pa_server_info_cb_t (pa_context* c,
                                                                    pa_server_info* i,
                                                                    gpointer self)
{
	volume_control_pulse_server_info_cb_for_props ((VolumeControlPulse*) self, c, i);
}

static void
volume_control_pulse_update_sink (VolumeControlPulse* self)
{
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->context;
	_tmp1_ = pa_context_get_server_info (_tmp0_, _volume_control_pulse_server_info_cb_for_props_pa_server_info_cb_t, self);
	_tmp2_ = _tmp1_;
	_pa_operation_unref0 (_tmp2_);
}

static void
_volume_control_pulse_source_info_cb_pa_source_info_cb_t (pa_context* c,
                                                          pa_source_info* i,
                                                          gint eol,
                                                          gpointer self)
{
	volume_control_pulse_source_info_cb ((VolumeControlPulse*) self, c, i, eol);
}

static void
volume_control_pulse_update_source_get_server_info_cb (VolumeControlPulse* self,
                                                       pa_context* c,
                                                       pa_server_info* i)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (i != NULL) {
		pa_context* _tmp0_;
		const gchar* _tmp1_;
		pa_operation* _tmp2_;
		pa_operation* _tmp3_;
		_tmp0_ = self->priv->context;
		_tmp1_ = (*i).default_source_name;
		_tmp2_ = pa_context_get_source_info_by_name (_tmp0_, _tmp1_, _volume_control_pulse_source_info_cb_pa_source_info_cb_t, self);
		_tmp3_ = _tmp2_;
		_pa_operation_unref0 (_tmp3_);
	}
}

static void
_volume_control_pulse_update_source_get_server_info_cb_pa_server_info_cb_t (pa_context* c,
                                                                            pa_server_info* i,
                                                                            gpointer self)
{
	volume_control_pulse_update_source_get_server_info_cb ((VolumeControlPulse*) self, c, i);
}

static void
volume_control_pulse_update_source (VolumeControlPulse* self)
{
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->context;
	_tmp1_ = pa_context_get_server_info (_tmp0_, _volume_control_pulse_update_source_get_server_info_cb_pa_server_info_cb_t, self);
	_tmp2_ = _tmp1_;
	_pa_operation_unref0 (_tmp2_);
}

static gpointer
_g_variant_ref0 (gpointer self)
{
	return self ? g_variant_ref (self) : NULL;
}

static GDBusMessage*
volume_control_pulse_pulse_dbus_filter (VolumeControlPulse* self,
                                        GDBusConnection* connection,
                                        GDBusMessage* message,
                                        gboolean incoming)
{
	GDBusMessage* _tmp21_;
	GError* _inner_error0_ = NULL;
	GDBusMessage* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (connection != NULL, NULL);
	g_return_val_if_fail (message != NULL, NULL);
	if (g_dbus_message_get_message_type (message) == G_DBUS_MESSAGE_TYPE_SIGNAL) {
		gchar* active_role_objp = NULL;
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gboolean _tmp4_ = FALSE;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		_tmp0_ = self->priv->_objp_role_alert;
		_tmp1_ = g_strdup (_tmp0_);
		active_role_objp = _tmp1_;
		if (self->priv->_active_sink_input != ((gint32) -1)) {
			GeeHashMap* _tmp2_;
			gpointer _tmp3_;
			_tmp2_ = self->priv->_sink_input_hash;
			_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, (gpointer) ((guintptr) self->priv->_active_sink_input));
			_g_free0 (active_role_objp);
			active_role_objp = (gchar*) _tmp3_;
		}
		_tmp5_ = g_dbus_message_get_path (message);
		_tmp6_ = active_role_objp;
		if (g_strcmp0 (_tmp5_, _tmp6_) == 0) {
			const gchar* _tmp7_;
			_tmp7_ = g_dbus_message_get_member (message);
			_tmp4_ = g_strcmp0 (_tmp7_, "VolumeUpdated") == 0;
		} else {
			_tmp4_ = FALSE;
		}
		if (_tmp4_) {
			guint sig_count = 0U;
			sig_count = (guint) 0;
			{
				g_rec_mutex_lock (&self->priv->__lock__pa_volume_sig_count);
				{
					sig_count = self->priv->_pa_volume_sig_count;
					if (self->priv->_pa_volume_sig_count > ((guint) 0)) {
						guint _tmp8_;
						_tmp8_ = self->priv->_pa_volume_sig_count;
						self->priv->_pa_volume_sig_count = _tmp8_ - 1;
					}
				}
				__finally0:
				{
					g_rec_mutex_unlock (&self->priv->__lock__pa_volume_sig_count);
				}
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					_g_free0 (active_role_objp);
					_g_object_unref0 (message);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return NULL;
				}
			}
			if (sig_count == ((guint) 0)) {
				GVariant* body = NULL;
				GVariant* _tmp9_;
				GVariant* _tmp10_;
				GVariant* varray = NULL;
				GVariant* _tmp11_;
				GVariant* _tmp12_;
				guint32 type = 0U;
				guint32 lvolume = 0U;
				GVariantIter* iter = NULL;
				GVariant* _tmp13_;
				GVariantIter* _tmp14_;
				GVariantIter* _tmp15_;
				pa_volume_t cvolume = 0U;
				VolumeControlVolume* _tmp16_;
				_tmp9_ = g_dbus_message_get_body (message);
				_tmp10_ = _g_variant_ref0 (_tmp9_);
				body = _tmp10_;
				_tmp11_ = body;
				_tmp12_ = g_variant_get_child_value (_tmp11_, (gsize) 0);
				varray = _tmp12_;
				type = (guint32) 0;
				lvolume = (guint32) 0;
				_tmp13_ = varray;
				_tmp14_ = g_variant_iter_new (_tmp13_);
				iter = _tmp14_;
				_tmp15_ = iter;
				g_variant_iter_next (_tmp15_, "(uu)", &type, &lvolume, NULL);
				_tmp16_ = self->priv->_volume;
				cvolume = volume_control_pulse_double_to_volume (_tmp16_->volume);
				if (lvolume != ((guint32) cvolume)) {
					VolumeControlVolume* vol = NULL;
					VolumeControlVolume* _tmp17_;
					VolumeControlVolume* _tmp18_;
					VolumeControlVolume* _tmp19_;
					VolumeControlVolume* _tmp20_;
					_tmp17_ = volume_control_volume_new ();
					vol = _tmp17_;
					_tmp18_ = vol;
					_tmp18_->volume = volume_control_pulse_volume_to_double ((pa_volume_t) lvolume);
					_tmp19_ = vol;
					_tmp19_->reason = VOLUME_CONTROL_VOLUME_REASONS_PULSE_CHANGE;
					_tmp20_ = vol;
					volume_control_set_volume ((VolumeControl*) self, _tmp20_);
					_g_object_unref0 (vol);
				}
				_g_variant_iter_free0 (iter);
				_g_variant_unref0 (varray);
				_g_variant_unref0 (body);
			}
		}
		_g_free0 (active_role_objp);
	}
	_tmp21_ = _g_object_ref0 (message);
	result = _tmp21_;
	_g_object_unref0 (message);
	return result;
}

static VolumeControlStream
volume_control_pulse_calculate_active_stream (VolumeControlPulse* self)
{
	VolumeControlStream result;
	g_return_val_if_fail (self != NULL, 0);
	if (self->priv->_active_sink_input != ((gint32) -1)) {
		gchar* path = NULL;
		GeeHashMap* _tmp0_;
		gpointer _tmp1_;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		_tmp0_ = self->priv->_sink_input_hash;
		_tmp1_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, (gpointer) ((guintptr) self->priv->_active_sink_input));
		path = (gchar*) _tmp1_;
		_tmp2_ = path;
		_tmp3_ = self->priv->_objp_role_multimedia;
		if (g_strcmp0 (_tmp2_, _tmp3_) == 0) {
			result = VOLUME_CONTROL_STREAM_MULTIMEDIA;
			_g_free0 (path);
			return result;
		}
		_tmp4_ = path;
		_tmp5_ = self->priv->_objp_role_alarm;
		if (g_strcmp0 (_tmp4_, _tmp5_) == 0) {
			result = VOLUME_CONTROL_STREAM_ALARM;
			_g_free0 (path);
			return result;
		}
		_tmp6_ = path;
		_tmp7_ = self->priv->_objp_role_phone;
		if (g_strcmp0 (_tmp6_, _tmp7_) == 0) {
			result = VOLUME_CONTROL_STREAM_PHONE;
			_g_free0 (path);
			return result;
		}
		_g_free0 (path);
	}
	result = VOLUME_CONTROL_STREAM_ALERT;
	return result;
}

static void
volume_control_pulse_update_active_sink_input_data_free (gpointer _data)
{
	VolumeControlPulseUpdateActiveSinkInputData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (VolumeControlPulseUpdateActiveSinkInputData, _data_);
}

static void
volume_control_pulse_update_active_sink_input (VolumeControlPulse* self,
                                               gint32 index,
                                               GAsyncReadyCallback _callback_,
                                               gpointer _user_data_)
{
	VolumeControlPulseUpdateActiveSinkInputData* _data_;
	VolumeControlPulse* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (VolumeControlPulseUpdateActiveSinkInputData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, volume_control_pulse_update_active_sink_input_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_data_->index = index;
	volume_control_pulse_update_active_sink_input_co (_data_);
}

static void
volume_control_pulse_update_active_sink_input_finish (VolumeControlPulse* self,
                                                      GAsyncResult* _res_)
{
	VolumeControlPulseUpdateActiveSinkInputData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
volume_control_pulse_update_active_sink_input_ready (GObject* source_object,
                                                     GAsyncResult* _res_,
                                                     gpointer _user_data_)
{
	VolumeControlPulseUpdateActiveSinkInputData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	volume_control_pulse_update_active_sink_input_co (_data_);
}

static gboolean
volume_control_pulse_update_active_sink_input_co (VolumeControlPulseUpdateActiveSinkInputData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	if (_data_->index == ((gint32) -1)) {
		_data_->_tmp0_ = TRUE;
	} else {
		if (_data_->index != _data_->self->priv->_active_sink_input) {
			_data_->_tmp2_ = _data_->self->priv->_sink_input_list;
			_data_->_tmp1_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _data_->_tmp2_, (gpointer) ((guintptr) _data_->index));
		} else {
			_data_->_tmp1_ = FALSE;
		}
		_data_->_tmp0_ = _data_->_tmp1_;
	}
	if (_data_->_tmp0_) {
		_data_->_tmp3_ = _data_->self->priv->_objp_role_alert;
		_data_->_tmp4_ = g_strdup (_data_->_tmp3_);
		_data_->sink_input_objp = _data_->_tmp4_;
		if (_data_->index != ((gint32) -1)) {
			_data_->_tmp5_ = _data_->self->priv->_sink_input_hash;
			_data_->_tmp6_ = gee_abstract_map_get ((GeeAbstractMap*) _data_->_tmp5_, (gpointer) ((guintptr) _data_->index));
			_g_free0 (_data_->sink_input_objp);
			_data_->sink_input_objp = (gchar*) _data_->_tmp6_;
		}
		_data_->self->priv->_active_sink_input = _data_->index;
		_data_->stream = volume_control_pulse_calculate_active_stream (_data_->self);
		_data_->_tmp7_ = volume_control_get_active_stream ((VolumeControl*) _data_->self);
		_data_->_tmp8_ = _data_->_tmp7_;
		if (_data_->_tmp8_ != _data_->stream) {
			volume_control_set_active_stream ((VolumeControl*) _data_->self, _data_->stream);
		}
		{
			_data_->_tmp9_ = G_VARIANT_TYPE_OBJECT_PATH_ARRAY;
			_data_->_tmp10_ = g_variant_builder_new (_data_->_tmp9_);
			_data_->builder = _data_->_tmp10_;
			_data_->_tmp11_ = _data_->builder;
			_data_->_tmp12_ = _data_->sink_input_objp;
			g_variant_builder_add (_data_->_tmp11_, "o", _data_->_tmp12_, NULL);
			_data_->_tmp13_ = _data_->self->priv->_pconn;
			_data_->_tmp14_ = _data_->builder;
			_data_->_tmp15_ = g_variant_new ("(sao)", "org.PulseAudio.Ext.StreamRestore1.RestoreEntry.VolumeUpdated", _data_->_tmp14_, NULL);
			g_variant_ref_sink (_data_->_tmp15_);
			_data_->_tmp16_ = _data_->_tmp15_;
			_data_->_state_ = 1;
			g_dbus_connection_call (_data_->_tmp13_, "org.PulseAudio.Core1", "/org/pulseaudio/core1", "org.PulseAudio.Core1", "ListenForSignal", _data_->_tmp16_, NULL, G_DBUS_CALL_FLAGS_NONE, -1, NULL, volume_control_pulse_update_active_sink_input_ready, _data_);
			return FALSE;
			_state_1:
			_data_->_tmp17_ = g_dbus_connection_call_finish (_data_->_tmp13_, _data_->_res_, &_data_->_inner_error0_);
			_data_->_tmp18_ = _data_->_tmp17_;
			_g_variant_unref0 (_data_->_tmp18_);
			_g_variant_unref0 (_data_->_tmp16_);
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				_g_variant_builder_unref0 (_data_->builder);
				goto __catch0_g_error;
			}
			_g_variant_builder_unref0 (_data_->builder);
		}
		goto __finally0;
		__catch0_g_error:
		{
			_data_->e = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp19_ = _data_->e;
			_data_->_tmp20_ = _data_->_tmp19_->message;
			g_warning ("volume-control-pulse.vala:382: unable to listen for pulseaudio dbus si" \
"gnals (%s)", _data_->_tmp20_);
			_g_error_free0 (_data_->e);
		}
		__finally0:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_free0 (_data_->sink_input_objp);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		{
			_data_->_tmp21_ = _data_->self->priv->_pconn;
			_data_->_tmp22_ = _data_->sink_input_objp;
			_data_->_tmp23_ = g_variant_new ("(ss)", "org.PulseAudio.Ext.StreamRestore1.RestoreEntry", "Volume", NULL);
			g_variant_ref_sink (_data_->_tmp23_);
			_data_->_tmp24_ = _data_->_tmp23_;
			_data_->_state_ = 2;
			g_dbus_connection_call (_data_->_tmp21_, "org.PulseAudio.Ext.StreamRestore1.RestoreEntry", _data_->_tmp22_, "org.freedesktop.DBus.Properties", "Get", _data_->_tmp24_, NULL, G_DBUS_CALL_FLAGS_NONE, -1, NULL, volume_control_pulse_update_active_sink_input_ready, _data_);
			return FALSE;
			_state_2:
			_data_->_tmp25_ = g_dbus_connection_call_finish (_data_->_tmp21_, _data_->_res_, &_data_->_inner_error0_);
			_data_->_tmp26_ = _data_->_tmp25_;
			_g_variant_unref0 (_data_->_tmp24_);
			_data_->props_variant = _data_->_tmp26_;
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch1_g_error;
			}
			_data_->_tmp27_ = _data_->props_variant;
			_data_->_tmp28_ = NULL;
			g_variant_get (_data_->_tmp27_, "(v)", &_data_->_tmp28_, NULL);
			_g_variant_unref0 (_data_->tmp);
			_data_->tmp = _data_->_tmp28_;
			_data_->type = (guint32) 0;
			_data_->volume = (guint32) 0;
			_data_->_tmp29_ = _data_->tmp;
			_data_->_tmp30_ = g_variant_iter_new (_data_->_tmp29_);
			_data_->iter = _data_->_tmp30_;
			_data_->_tmp31_ = _data_->iter;
			g_variant_iter_next (_data_->_tmp31_, "(uu)", &_data_->type, &_data_->volume, NULL);
			_data_->_tmp32_ = volume_control_volume_new ();
			_data_->vol = _data_->_tmp32_;
			_data_->_tmp33_ = _data_->vol;
			_data_->_tmp33_->volume = volume_control_pulse_volume_to_double ((pa_volume_t) _data_->volume);
			_data_->_tmp34_ = _data_->vol;
			_data_->_tmp34_->reason = VOLUME_CONTROL_VOLUME_REASONS_VOLUME_STREAM_CHANGE;
			_data_->_tmp35_ = _data_->vol;
			volume_control_set_volume ((VolumeControl*) _data_->self, _data_->_tmp35_);
			_g_object_unref0 (_data_->vol);
			_g_variant_iter_free0 (_data_->iter);
			_g_variant_unref0 (_data_->tmp);
			_g_variant_unref0 (_data_->props_variant);
		}
		goto __finally1;
		__catch1_g_error:
		{
			_data_->_vala1_e = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			_data_->_tmp36_ = _data_->sink_input_objp;
			_data_->_tmp37_ = _data_->_vala1_e;
			_data_->_tmp38_ = _data_->_tmp37_->message;
			g_warning ("volume-control-pulse.vala:401: unable to get volume for active role %s" \
" (%s)", _data_->_tmp36_, _data_->_tmp38_);
			_g_error_free0 (_data_->_vala1_e);
		}
		__finally1:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_free0 (_data_->sink_input_objp);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_g_free0 (_data_->sink_input_objp);
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static gboolean
_vala_string_array_contains (gchar* * stack,
                             gssize stack_length,
                             const gchar* needle)
{
	gssize i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}

static void
volume_control_pulse_add_sink_input_into_list (VolumeControlPulse* self,
                                               pa_sink_input_info* sink_input)
{
	const gchar* role = NULL;
	pa_sink_input_info _tmp0_;
	pa_proplist* _tmp1_;
	const gchar* _tmp2_;
	gboolean _tmp3_ = FALSE;
	const gchar* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (sink_input != NULL);
	_tmp0_ = *sink_input;
	_tmp1_ = _tmp0_.proplist;
	_tmp2_ = pa_proplist_gets (_tmp1_, PA_PROP_MEDIA_ROLE);
	role = _tmp2_;
	_tmp4_ = role;
	if (_tmp4_ != NULL) {
		const gchar* _tmp5_;
		gchar** _tmp6_;
		gint _tmp6__length1;
		_tmp5_ = role;
		_tmp6_ = self->priv->_valid_roles;
		_tmp6__length1 = self->priv->_valid_roles_length1;
		_tmp3_ = _vala_string_array_contains (_tmp6_, _tmp6__length1, _tmp5_);
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		gboolean _tmp7_ = FALSE;
		pa_sink_input_info _tmp8_;
		_tmp8_ = *sink_input;
		if (_tmp8_.corked == 0) {
			_tmp7_ = TRUE;
		} else {
			const gchar* _tmp9_;
			_tmp9_ = role;
			_tmp7_ = g_strcmp0 (_tmp9_, "phone") == 0;
		}
		if (_tmp7_) {
			GeeArrayList* _tmp10_;
			pa_sink_input_info _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			GQuark _tmp15_ = 0U;
			static GQuark _tmp14_label0 = 0;
			static GQuark _tmp14_label1 = 0;
			static GQuark _tmp14_label2 = 0;
			static GQuark _tmp14_label3 = 0;
			gboolean _tmp28_ = FALSE;
			_tmp10_ = self->priv->_sink_input_list;
			_tmp11_ = *sink_input;
			gee_abstract_list_insert ((GeeAbstractList*) _tmp10_, 0, (gpointer) ((guintptr) _tmp11_.index));
			_tmp12_ = role;
			_tmp13_ = _tmp12_;
			_tmp15_ = (NULL == _tmp13_) ? 0 : g_quark_from_string (_tmp13_);
			if (_tmp15_ == ((0 != _tmp14_label0) ? _tmp14_label0 : (_tmp14_label0 = g_quark_from_static_string ("multimedia")))) {
				switch (0) {
					default:
					{
						GeeHashMap* _tmp16_;
						pa_sink_input_info _tmp17_;
						const gchar* _tmp18_;
						_tmp16_ = self->priv->_sink_input_hash;
						_tmp17_ = *sink_input;
						_tmp18_ = self->priv->_objp_role_multimedia;
						gee_abstract_map_set ((GeeAbstractMap*) _tmp16_, (gpointer) ((guintptr) _tmp17_.index), _tmp18_);
						break;
					}
				}
			} else if (_tmp15_ == ((0 != _tmp14_label1) ? _tmp14_label1 : (_tmp14_label1 = g_quark_from_static_string ("alert")))) {
				switch (0) {
					default:
					{
						GeeHashMap* _tmp19_;
						pa_sink_input_info _tmp20_;
						const gchar* _tmp21_;
						_tmp19_ = self->priv->_sink_input_hash;
						_tmp20_ = *sink_input;
						_tmp21_ = self->priv->_objp_role_alert;
						gee_abstract_map_set ((GeeAbstractMap*) _tmp19_, (gpointer) ((guintptr) _tmp20_.index), _tmp21_);
						break;
					}
				}
			} else if (_tmp15_ == ((0 != _tmp14_label2) ? _tmp14_label2 : (_tmp14_label2 = g_quark_from_static_string ("alarm")))) {
				switch (0) {
					default:
					{
						GeeHashMap* _tmp22_;
						pa_sink_input_info _tmp23_;
						const gchar* _tmp24_;
						_tmp22_ = self->priv->_sink_input_hash;
						_tmp23_ = *sink_input;
						_tmp24_ = self->priv->_objp_role_alarm;
						gee_abstract_map_set ((GeeAbstractMap*) _tmp22_, (gpointer) ((guintptr) _tmp23_.index), _tmp24_);
						break;
					}
				}
			} else if (_tmp15_ == ((0 != _tmp14_label3) ? _tmp14_label3 : (_tmp14_label3 = g_quark_from_static_string ("phone")))) {
				switch (0) {
					default:
					{
						GeeHashMap* _tmp25_;
						pa_sink_input_info _tmp26_;
						const gchar* _tmp27_;
						_tmp25_ = self->priv->_sink_input_hash;
						_tmp26_ = *sink_input;
						_tmp27_ = self->priv->_objp_role_phone;
						gee_abstract_map_set ((GeeAbstractMap*) _tmp25_, (gpointer) ((guintptr) _tmp26_.index), _tmp27_);
						break;
					}
				}
			}
			if (self->priv->_active_sink_input == ((gint32) -1)) {
				_tmp28_ = TRUE;
			} else {
				GeeHashMap* _tmp29_;
				gpointer _tmp30_;
				gchar* _tmp31_;
				const gchar* _tmp32_;
				_tmp29_ = self->priv->_sink_input_hash;
				_tmp30_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp29_, (gpointer) ((guintptr) self->priv->_active_sink_input));
				_tmp31_ = (gchar*) _tmp30_;
				_tmp32_ = self->priv->_objp_role_phone;
				_tmp28_ = g_strcmp0 (_tmp31_, _tmp32_) != 0;
				_g_free0 (_tmp31_);
			}
			if (_tmp28_) {
				pa_sink_input_info _tmp33_;
				_tmp33_ = *sink_input;
				volume_control_pulse_update_active_sink_input (self, (gint32) _tmp33_.index, NULL, NULL);
			}
		}
	}
}

static void
volume_control_pulse_remove_sink_input_from_list (VolumeControlPulse* self,
                                                  guint32 index)
{
	GeeArrayList* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_sink_input_list;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (gpointer) ((guintptr) index))) {
		GeeArrayList* _tmp1_;
		GeeHashMap* _tmp2_;
		_tmp1_ = self->priv->_sink_input_list;
		gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, (gpointer) ((guintptr) index));
		_tmp2_ = self->priv->_sink_input_hash;
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp2_, (gpointer) ((guintptr) index), NULL);
		if (index == ((guint32) self->priv->_active_sink_input)) {
			GeeArrayList* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
			_tmp3_ = self->priv->_sink_input_list;
			_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
			_tmp5_ = _tmp4_;
			if (_tmp5_ != 0) {
				GeeArrayList* _tmp6_;
				gpointer _tmp7_;
				_tmp6_ = self->priv->_sink_input_list;
				_tmp7_ = gee_abstract_list_get ((GeeAbstractList*) _tmp6_, 0);
				volume_control_pulse_update_active_sink_input (self, (gint32) ((guint32) ((guintptr) _tmp7_)), NULL, NULL);
			} else {
				volume_control_pulse_update_active_sink_input (self, (gint32) -1, NULL, NULL);
			}
		}
	}
}

static void
volume_control_pulse_handle_new_sink_input_cb (VolumeControlPulse* self,
                                               pa_context* c,
                                               pa_sink_input_info* i,
                                               gint eol)
{
	pa_sink_input_info _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (i == NULL) {
		return;
	}
	_tmp0_ = *i;
	volume_control_pulse_add_sink_input_into_list (self, &_tmp0_);
}

static void
volume_control_pulse_handle_changed_sink_input_cb (VolumeControlPulse* self,
                                                   pa_context* c,
                                                   pa_sink_input_info* i,
                                                   gint eol)
{
	GeeArrayList* _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (i == NULL) {
		return;
	}
	_tmp0_ = self->priv->_sink_input_list;
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, (gpointer) ((guintptr) (*i).index))) {
		gboolean _tmp1_ = FALSE;
		if ((*i).corked == 1) {
			GeeHashMap* _tmp2_;
			gpointer _tmp3_;
			gchar* _tmp4_;
			const gchar* _tmp5_;
			_tmp2_ = self->priv->_sink_input_hash;
			_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, (gpointer) ((guintptr) (*i).index));
			_tmp4_ = (gchar*) _tmp3_;
			_tmp5_ = self->priv->_objp_role_phone;
			_tmp1_ = g_strcmp0 (_tmp4_, _tmp5_) != 0;
			_g_free0 (_tmp4_);
		} else {
			_tmp1_ = FALSE;
		}
		if (_tmp1_) {
			volume_control_pulse_remove_sink_input_from_list (self, (*i).index);
		}
	} else {
		if ((*i).corked == 0) {
			pa_sink_input_info _tmp6_;
			_tmp6_ = *i;
			volume_control_pulse_add_sink_input_into_list (self, &_tmp6_);
		}
	}
}

static void
volume_control_pulse_source_output_info_cb (VolumeControlPulse* self,
                                            pa_context* c,
                                            pa_source_output_info* i,
                                            gint eol)
{
	const gchar* role = NULL;
	pa_proplist* _tmp0_;
	const gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (i == NULL) {
		return;
	}
	_tmp0_ = (*i).proplist;
	_tmp1_ = pa_proplist_gets (_tmp0_, PA_PROP_MEDIA_ROLE);
	role = _tmp1_;
	_tmp3_ = role;
	if (g_strcmp0 (_tmp3_, "phone") == 0) {
		_tmp2_ = TRUE;
	} else {
		const gchar* _tmp4_;
		_tmp4_ = role;
		_tmp2_ = g_strcmp0 (_tmp4_, "production") == 0;
	}
	if (_tmp2_) {
		volume_control_set_active_mic ((VolumeControl*) self, TRUE);
		self->priv->_source_sink_mic_activated = TRUE;
	}
}

static void
_volume_control_pulse_context_events_cb_pa_context_subscribe_cb_t (pa_context* c,
                                                                   pa_subscription_event_type_t t,
                                                                   guint32 idx,
                                                                   gpointer self)
{
	volume_control_pulse_context_events_cb ((VolumeControlPulse*) self, c, t, idx);
}

static gboolean
_volume_control_pulse_reconnect_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = volume_control_pulse_reconnect_timeout ((VolumeControlPulse*) self);
	return result;
}

static void
volume_control_pulse_context_state_callback (VolumeControlPulse* self,
                                             pa_context* c)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	switch (pa_context_get_state (c)) {
		case PA_CONTEXT_READY:
		{
			if (self->priv->_pulse_use_stream_restore) {
				pa_operation* _tmp0_;
				pa_operation* _tmp1_;
				_tmp0_ = pa_context_subscribe (c, ((PA_SUBSCRIPTION_MASK_SINK | PA_SUBSCRIPTION_MASK_SINK_INPUT) | PA_SUBSCRIPTION_MASK_SOURCE) | PA_SUBSCRIPTION_MASK_SOURCE_OUTPUT, NULL, NULL);
				_tmp1_ = _tmp0_;
				_pa_operation_unref0 (_tmp1_);
			} else {
				pa_operation* _tmp2_;
				pa_operation* _tmp3_;
				_tmp2_ = pa_context_subscribe (c, (PA_SUBSCRIPTION_MASK_SINK | PA_SUBSCRIPTION_MASK_SOURCE) | PA_SUBSCRIPTION_MASK_SOURCE_OUTPUT, NULL, NULL);
				_tmp3_ = _tmp2_;
				_pa_operation_unref0 (_tmp3_);
			}
			pa_context_set_subscribe_callback (c, _volume_control_pulse_context_events_cb_pa_context_subscribe_cb_t, self);
			volume_control_pulse_update_sink (self);
			volume_control_pulse_update_source (self);
			volume_control_set_ready ((VolumeControl*) self, TRUE);
			break;
		}
		case PA_CONTEXT_FAILED:
		case PA_CONTEXT_TERMINATED:
		{
			if (self->priv->_reconnect_timer == ((guint) 0)) {
				self->priv->_reconnect_timer = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, _volume_control_pulse_reconnect_timeout_gsource_func, g_object_ref (self), g_object_unref);
			}
			break;
		}
		default:
		{
			volume_control_set_ready ((VolumeControl*) self, FALSE);
			break;
		}
	}
}

static gboolean
volume_control_pulse_reconnect_timeout (VolumeControlPulse* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->_reconnect_timer = (guint) 0;
	volume_control_pulse_reconnect_to_pulse (self);
	result = G_SOURCE_REMOVE;
	return result;
}

static void
_volume_control_pulse_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                     gpointer self)
{
	volume_control_pulse_context_state_callback ((VolumeControlPulse*) self, c);
}

static void
volume_control_pulse_reconnect_to_pulse (VolumeControlPulse* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	pa_proplist* props = NULL;
	pa_proplist* _tmp3_;
	pa_glib_mainloop* _tmp8_;
	pa_mainloop_api* _tmp9_;
	pa_proplist* _tmp10_;
	pa_context* _tmp11_;
	pa_context* _tmp12_;
	const gchar* server_string = NULL;
	const gchar* _tmp13_;
	pa_context* _tmp14_;
	const gchar* _tmp15_;
	g_return_if_fail (self != NULL);
	_tmp0_ = volume_control_get_ready ((VolumeControl*) self);
	_tmp1_ = _tmp0_;
	if (_tmp1_) {
		pa_context* _tmp2_;
		_tmp2_ = self->priv->context;
		pa_context_disconnect (_tmp2_);
		_pa_context_unref0 (self->priv->context);
		self->priv->context = NULL;
		volume_control_set_ready ((VolumeControl*) self, FALSE);
	}
	_tmp3_ = pa_proplist_new ();
	props = _tmp3_;
	if (ayatana_common_utils_is_unity ()) {
		pa_proplist* _tmp4_;
		pa_proplist* _tmp5_;
		pa_proplist* _tmp6_;
		pa_proplist* _tmp7_;
		_tmp4_ = props;
		pa_proplist_sets (_tmp4_, PA_PROP_APPLICATION_NAME, "Ubuntu Audio Settings");
		_tmp5_ = props;
		pa_proplist_sets (_tmp5_, PA_PROP_APPLICATION_ID, "com.canonical.settings.sound");
		_tmp6_ = props;
		pa_proplist_sets (_tmp6_, PA_PROP_APPLICATION_ICON_NAME, "multimedia-volume-control");
		_tmp7_ = props;
		pa_proplist_sets (_tmp7_, PA_PROP_APPLICATION_VERSION, "0.1");
	}
	volume_control_pulse_reconnect_pulse_dbus (self);
	_tmp8_ = self->priv->loop;
	_tmp9_ = pa_glib_mainloop_get_api (_tmp8_);
	_tmp10_ = props;
	_tmp11_ = pa_context_new_with_proplist (_tmp9_, NULL, _tmp10_);
	_pa_context_unref0 (self->priv->context);
	self->priv->context = _tmp11_;
	_tmp12_ = self->priv->context;
	pa_context_set_state_callback (_tmp12_, _volume_control_pulse_context_state_callback_pa_context_notify_cb_t, self);
	_tmp13_ = g_getenv ("PULSE_SERVER");
	server_string = _tmp13_;
	_tmp14_ = self->priv->context;
	_tmp15_ = server_string;
	if (pa_context_connect (_tmp14_, _tmp15_, PA_CONTEXT_NOFAIL, NULL) < 0) {
		pa_context* _tmp16_;
		const gchar* _tmp17_;
		_tmp16_ = self->priv->context;
		_tmp17_ = pa_strerror (pa_context_errno (_tmp16_));
		g_warning ("volume-control-pulse.vala:551: pa_context_connect() failed: %s\n", _tmp17_);
	}
	_pa_proplist_free0 (props);
}

static void
volume_control_pulse_sink_info_list_callback_set_mute (VolumeControlPulse* self,
                                                       pa_context* context,
                                                       pa_sink_info* sink,
                                                       gint eol)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	if (sink != NULL) {
		pa_operation* _tmp0_;
		pa_operation* _tmp1_;
		_tmp0_ = pa_context_set_sink_mute_by_index (context, (*sink).index, TRUE, NULL, NULL);
		_tmp1_ = _tmp0_;
		_pa_operation_unref0 (_tmp1_);
	}
}

static void
volume_control_pulse_sink_info_list_callback_unset_mute (VolumeControlPulse* self,
                                                         pa_context* context,
                                                         pa_sink_info* sink,
                                                         gint eol)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	if (sink != NULL) {
		pa_operation* _tmp0_;
		pa_operation* _tmp1_;
		_tmp0_ = pa_context_set_sink_mute_by_index (context, (*sink).index, FALSE, NULL, NULL);
		_tmp1_ = _tmp0_;
		_pa_operation_unref0 (_tmp1_);
	}
}

static void
_volume_control_pulse_sink_info_list_callback_set_mute_pa_sink_info_cb_t (pa_context* c,
                                                                          pa_sink_info* i,
                                                                          gint eol,
                                                                          gpointer self)
{
	volume_control_pulse_sink_info_list_callback_set_mute ((VolumeControlPulse*) self, c, i, eol);
}

static void
_volume_control_pulse_sink_info_list_callback_unset_mute_pa_sink_info_cb_t (pa_context* c,
                                                                            pa_sink_info* i,
                                                                            gint eol,
                                                                            gpointer self)
{
	volume_control_pulse_sink_info_list_callback_unset_mute ((VolumeControlPulse*) self, c, i, eol);
}

static gboolean
volume_control_pulse_set_mute_internal (VolumeControlPulse* self,
                                        gboolean mute)
{
	pa_context* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->context;
	g_return_val_if_fail (pa_context_get_state (_tmp0_) == PA_CONTEXT_READY, FALSE);
	if (self->priv->_mute != mute) {
		if (mute) {
			pa_context* _tmp1_;
			pa_operation* _tmp2_;
			pa_operation* _tmp3_;
			_tmp1_ = self->priv->context;
			_tmp2_ = pa_context_get_sink_info_list (_tmp1_, _volume_control_pulse_sink_info_list_callback_set_mute_pa_sink_info_cb_t, self);
			_tmp3_ = _tmp2_;
			_pa_operation_unref0 (_tmp3_);
		} else {
			pa_context* _tmp4_;
			pa_operation* _tmp5_;
			pa_operation* _tmp6_;
			_tmp4_ = self->priv->context;
			_tmp5_ = pa_context_get_sink_info_list (_tmp4_, _volume_control_pulse_sink_info_list_callback_unset_mute_pa_sink_info_cb_t, self);
			_tmp6_ = _tmp5_;
			_pa_operation_unref0 (_tmp6_);
		}
		result = TRUE;
		return result;
	} else {
		result = FALSE;
		return result;
	}
}

static void
volume_control_pulse_real_set_mute (VolumeControl* base,
                                    gboolean mute)
{
	VolumeControlPulse * self;
	self = (VolumeControlPulse*) base;
	if (volume_control_pulse_set_mute_internal (self, mute)) {
		AccountsServiceAccess* _tmp0_;
		_tmp0_ = self->priv->_accounts_service_access;
		accounts_service_access_set_mute (_tmp0_, mute);
	}
}

void
volume_control_pulse_toggle_mute (VolumeControlPulse* self)
{
	g_return_if_fail (self != NULL);
	volume_control_set_mute ((VolumeControl*) self, !self->priv->_mute);
}

static VolumeControlActiveOutput
volume_control_pulse_real_active_output (VolumeControl* base)
{
	VolumeControlPulse * self;
	VolumeControlActiveOutput result;
	self = (VolumeControlPulse*) base;
	result = self->priv->_active_output;
	return result;
}

pa_volume_t
volume_control_pulse_double_to_volume (gdouble vol)
{
	gdouble tmp = 0.0;
	pa_volume_t result;
	tmp = ((gdouble) (PA_VOLUME_NORM - PA_VOLUME_MUTED)) * vol;
	result = ((pa_volume_t) tmp) + PA_VOLUME_MUTED;
	return result;
}

gdouble
volume_control_pulse_volume_to_double (pa_volume_t vol)
{
	gdouble tmp = 0.0;
	gdouble result;
	tmp = (gdouble) (vol - PA_VOLUME_MUTED);
	result = tmp / ((gdouble) (PA_VOLUME_NORM - PA_VOLUME_MUTED));
	return result;
}

static void
volume_control_pulse_set_volume_success_cb (VolumeControlPulse* self,
                                            pa_context* c,
                                            gint success)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if ((gboolean) success) {
		g_object_notify ((GObject*) self, "volume");
	}
}

static void
_volume_control_pulse_set_volume_success_cb_pa_context_success_cb_t (pa_context* c,
                                                                     gint success,
                                                                     gpointer self)
{
	volume_control_pulse_set_volume_success_cb ((VolumeControlPulse*) self, c, success);
}

static void
volume_control_pulse_sink_info_set_volume_cb (VolumeControlPulse* self,
                                              pa_context* c,
                                              pa_sink_info* i,
                                              gint eol)
{
	pa_cvolume cvol = {0};
	pa_cvolume _tmp0_;
	VolumeControlVolume* _tmp1_;
	pa_cvolume _tmp2_;
	pa_operation* _tmp3_;
	pa_operation* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (i == NULL) {
		return;
	}
	_tmp0_ = (*i).volume;
	cvol = _tmp0_;
	_tmp1_ = self->priv->_volume;
	pa_cvolume_scale (&cvol, volume_control_pulse_double_to_volume (_tmp1_->volume));
	_tmp2_ = cvol;
	_tmp3_ = pa_context_set_sink_volume_by_index (c, (*i).index, &_tmp2_, _volume_control_pulse_set_volume_success_cb_pa_context_success_cb_t, self);
	_tmp4_ = _tmp3_;
	_pa_operation_unref0 (_tmp4_);
}

static void
_volume_control_pulse_sink_info_set_volume_cb_pa_sink_info_cb_t (pa_context* c,
                                                                 pa_sink_info* i,
                                                                 gint eol,
                                                                 gpointer self)
{
	volume_control_pulse_sink_info_set_volume_cb ((VolumeControlPulse*) self, c, i, eol);
}

static void
volume_control_pulse_server_info_cb_for_set_volume (VolumeControlPulse* self,
                                                    pa_context* c,
                                                    pa_server_info* i)
{
	pa_context* _tmp0_;
	const gchar* _tmp1_;
	pa_operation* _tmp2_;
	pa_operation* _tmp3_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (i == NULL) {
		g_warning ("volume-control-pulse.vala:637: Could not get PulseAudio server info");
		return;
	}
	_tmp0_ = self->priv->context;
	_tmp1_ = (*i).default_sink_name;
	_tmp2_ = pa_context_get_sink_info_by_name (_tmp0_, _tmp1_, _volume_control_pulse_sink_info_set_volume_cb_pa_sink_info_cb_t, self);
	_tmp3_ = _tmp2_;
	_pa_operation_unref0 (_tmp3_);
}

static void
volume_control_pulse_set_volume_active_role_data_free (gpointer _data)
{
	VolumeControlPulseSetVolumeActiveRoleData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (VolumeControlPulseSetVolumeActiveRoleData, _data_);
}

static void
volume_control_pulse_set_volume_active_role (VolumeControlPulse* self,
                                             GAsyncReadyCallback _callback_,
                                             gpointer _user_data_)
{
	VolumeControlPulseSetVolumeActiveRoleData* _data_;
	VolumeControlPulse* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (VolumeControlPulseSetVolumeActiveRoleData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, volume_control_pulse_set_volume_active_role_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	volume_control_pulse_set_volume_active_role_co (_data_);
}

static void
volume_control_pulse_set_volume_active_role_finish (VolumeControlPulse* self,
                                                    GAsyncResult* _res_)
{
	VolumeControlPulseSetVolumeActiveRoleData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
volume_control_pulse_set_volume_active_role_ready (GObject* source_object,
                                                   GAsyncResult* _res_,
                                                   gpointer _user_data_)
{
	VolumeControlPulseSetVolumeActiveRoleData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	volume_control_pulse_set_volume_active_role_co (_data_);
}

static gboolean
volume_control_pulse_set_volume_active_role_co (VolumeControlPulseSetVolumeActiveRoleData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->_objp_role_alert;
	_data_->_tmp1_ = g_strdup (_data_->_tmp0_);
	_data_->active_role_objp = _data_->_tmp1_;
	if (_data_->self->priv->_active_sink_input != ((gint32) -1)) {
		_data_->_tmp3_ = _data_->self->priv->_sink_input_list;
		_data_->_tmp2_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _data_->_tmp3_, (gpointer) ((guintptr) _data_->self->priv->_active_sink_input));
	} else {
		_data_->_tmp2_ = FALSE;
	}
	if (_data_->_tmp2_) {
		_data_->_tmp4_ = _data_->self->priv->_sink_input_hash;
		_data_->_tmp5_ = gee_abstract_map_get ((GeeAbstractMap*) _data_->_tmp4_, (gpointer) ((guintptr) _data_->self->priv->_active_sink_input));
		_g_free0 (_data_->active_role_objp);
		_data_->active_role_objp = (gchar*) _data_->_tmp5_;
	}
	{
		_data_->_tmp6_ = _data_->self->priv->_volume;
		_data_->vol = _data_->_tmp6_->volume;
		_data_->_tmp7_ = g_variant_type_new ("a(uu)");
		_data_->_tmp8_ = _data_->_tmp7_;
		_data_->_tmp9_ = g_variant_builder_new (_data_->_tmp8_);
		_data_->_tmp10_ = _data_->_tmp9_;
		_g_variant_type_free0 (_data_->_tmp8_);
		_data_->builder = _data_->_tmp10_;
		g_variant_builder_add (_data_->builder, "(uu)", 0, volume_control_pulse_double_to_volume (_data_->vol), NULL);
		_data_->_tmp11_ = g_variant_builder_end (_data_->builder);
		g_variant_ref_sink (_data_->_tmp11_);
		_data_->volume = _data_->_tmp11_;
		{
			g_rec_mutex_lock (&_data_->self->priv->__lock__pa_volume_sig_count);
			{
				_data_->_tmp12_ = _data_->self->priv->_pa_volume_sig_count;
				_data_->self->priv->_pa_volume_sig_count = _data_->_tmp12_ + 1;
			}
			__finally1:
			{
				g_rec_mutex_unlock (&_data_->self->priv->__lock__pa_volume_sig_count);
			}
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				_g_variant_unref0 (_data_->volume);
				_g_variant_builder_unref0 (_data_->builder);
				goto __catch0_g_error;
			}
		}
		_data_->_tmp13_ = _data_->self->priv->_pconn;
		_data_->_tmp14_ = _data_->active_role_objp;
		_data_->_tmp15_ = g_variant_new ("(ssv)", "org.PulseAudio.Ext.StreamRestore1.RestoreEntry", "Volume", _data_->volume, NULL);
		g_variant_ref_sink (_data_->_tmp15_);
		_data_->_tmp16_ = _data_->_tmp15_;
		_data_->_state_ = 1;
		g_dbus_connection_call (_data_->_tmp13_, "org.PulseAudio.Ext.StreamRestore1.RestoreEntry", _data_->_tmp14_, "org.freedesktop.DBus.Properties", "Set", _data_->_tmp16_, NULL, G_DBUS_CALL_FLAGS_NONE, -1, NULL, volume_control_pulse_set_volume_active_role_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp17_ = g_dbus_connection_call_finish (_data_->_tmp13_, _data_->_res_, &_data_->_inner_error0_);
		_data_->_tmp18_ = _data_->_tmp17_;
		_g_variant_unref0 (_data_->_tmp18_);
		_g_variant_unref0 (_data_->_tmp16_);
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			_g_variant_unref0 (_data_->volume);
			_g_variant_builder_unref0 (_data_->builder);
			goto __catch0_g_error;
		}
		_g_variant_unref0 (_data_->volume);
		_g_variant_builder_unref0 (_data_->builder);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		{
			g_rec_mutex_lock (&_data_->self->priv->__lock__pa_volume_sig_count);
			{
				_data_->_tmp19_ = _data_->self->priv->_pa_volume_sig_count;
				_data_->self->priv->_pa_volume_sig_count = _data_->_tmp19_ - 1;
			}
			__finally2:
			{
				g_rec_mutex_unlock (&_data_->self->priv->__lock__pa_volume_sig_count);
			}
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				_g_error_free0 (_data_->e);
				_g_free0 (_data_->active_role_objp);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
				g_clear_error (&_data_->_inner_error0_);
				g_object_unref (_data_->_async_result);
				return FALSE;
			}
		}
		_data_->_tmp20_ = _data_->active_role_objp;
		_data_->_tmp21_ = _data_->e;
		_data_->_tmp22_ = _data_->_tmp21_->message;
		g_warning ("volume-control-pulse.vala:670: unable to set volume for stream obj pat" \
"h %s (%s)", _data_->_tmp20_, _data_->_tmp22_);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		_g_free0 (_data_->active_role_objp);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	_g_free0 (_data_->active_role_objp);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
volume_control_pulse_set_mic_volume_success_cb (VolumeControlPulse* self,
                                                pa_context* c,
                                                gint success)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if ((gboolean) success) {
		g_object_notify ((GObject*) self, "mic-volume");
	}
}

static void
_volume_control_pulse_set_mic_volume_success_cb_pa_context_success_cb_t (pa_context* c,
                                                                         gint success,
                                                                         gpointer self)
{
	volume_control_pulse_set_mic_volume_success_cb ((VolumeControlPulse*) self, c, success);
}

static void
volume_control_pulse_set_mic_volume_get_server_info_cb (VolumeControlPulse* self,
                                                        pa_context* c,
                                                        pa_server_info* i)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (i != NULL) {
		pa_cvolume cvol = {0};
		const gchar* _tmp0_;
		pa_cvolume _tmp1_;
		pa_operation* _tmp2_;
		pa_operation* _tmp3_;
		pa_cvolume_init (&cvol);
		pa_cvolume_set (&cvol, (guint8) 1, volume_control_pulse_double_to_volume (self->priv->_mic_volume));
		_tmp0_ = (*i).default_source_name;
		_tmp1_ = cvol;
		_tmp2_ = pa_context_set_source_volume_by_name (c, _tmp0_, &_tmp1_, _volume_control_pulse_set_mic_volume_success_cb_pa_context_success_cb_t, self);
		_tmp3_ = _tmp2_;
		_pa_operation_unref0 (_tmp3_);
	}
}

GDBusConnection*
volume_control_pulse_create_pulse_dbus_connection (void)
{
	const gchar* pulse_dbus_server_env = NULL;
	const gchar* _tmp0_;
	gchar* address = NULL;
	const gchar* _tmp1_;
	GDBusConnection* conn = NULL;
	const gchar* _tmp28_;
	GDBusConnection* _tmp29_;
	GError* _inner_error0_ = NULL;
	GDBusConnection* result;
	_tmp0_ = g_getenv ("PULSE_DBUS_SERVER");
	pulse_dbus_server_env = _tmp0_;
	_tmp1_ = pulse_dbus_server_env;
	if (_tmp1_ != NULL) {
		const gchar* _tmp2_;
		gchar* _tmp3_;
		_tmp2_ = pulse_dbus_server_env;
		_tmp3_ = g_strdup (_tmp2_);
		_g_free0 (address);
		address = _tmp3_;
	} else {
		GDBusConnection* conn = NULL;
		GVariant* props = NULL;
		{
			GDBusConnection* _tmp4_ = NULL;
			GDBusConnection* _tmp5_;
			GDBusConnection* _tmp6_;
			_tmp5_ = g_bus_get_sync (G_BUS_TYPE_SESSION, NULL, &_inner_error0_);
			_tmp4_ = _tmp5_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				if (_inner_error0_->domain == G_IO_ERROR) {
					goto __catch0_g_io_error;
				}
				_g_variant_unref0 (props);
				_g_object_unref0 (conn);
				_g_free0 (address);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
				g_clear_error (&_inner_error0_);
				return NULL;
			}
			_tmp6_ = _tmp4_;
			_tmp4_ = NULL;
			_g_object_unref0 (conn);
			conn = _tmp6_;
			_g_object_unref0 (_tmp4_);
		}
		goto __finally0;
		__catch0_g_io_error:
		{
			GError* e = NULL;
			GError* _tmp7_;
			const gchar* _tmp8_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp7_ = e;
			_tmp8_ = _tmp7_->message;
			g_warning ("volume-control-pulse.vala:744: unable to get the dbus session bus: %s", _tmp8_);
			result = NULL;
			_g_error_free0 (e);
			_g_variant_unref0 (props);
			_g_object_unref0 (conn);
			_g_free0 (address);
			return result;
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (props);
			_g_object_unref0 (conn);
			_g_free0 (address);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		{
			GVariant* props_variant = NULL;
			GDBusConnection* _tmp9_;
			GVariant* _tmp10_;
			GVariant* _tmp11_;
			GVariant* _tmp12_;
			GVariant* _tmp13_;
			GVariant* _tmp14_;
			GVariant* _tmp15_ = NULL;
			GVariant* _tmp16_;
			const gchar* _tmp17_;
			gchar* _tmp18_;
			_tmp9_ = conn;
			_tmp10_ = g_variant_new ("(ss)", "org.PulseAudio.ServerLookup1", "Address", NULL);
			g_variant_ref_sink (_tmp10_);
			_tmp11_ = _tmp10_;
			_tmp12_ = g_dbus_connection_call_sync (_tmp9_, "org.PulseAudio1", "/org/pulseaudio/server_lookup1", "org.freedesktop.DBus.Properties", "Get", _tmp11_, NULL, G_DBUS_CALL_FLAGS_NONE, -1, NULL, &_inner_error0_);
			_tmp13_ = _tmp12_;
			_g_variant_unref0 (_tmp11_);
			props_variant = _tmp13_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch1_g_error;
			}
			_tmp14_ = props_variant;
			g_variant_get (_tmp14_, "(v)", &_tmp15_, NULL);
			_g_variant_unref0 (props);
			props = _tmp15_;
			_tmp16_ = props;
			_tmp17_ = g_variant_get_string (_tmp16_, NULL);
			_tmp18_ = g_strdup (_tmp17_);
			_g_free0 (address);
			address = _tmp18_;
			_g_variant_unref0 (props_variant);
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			GError* _tmp19_;
			const gchar* _tmp20_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp19_ = e;
			_tmp20_ = _tmp19_->message;
			g_warning ("volume-control-pulse.vala:756: unable to get pulse unix socket: %s", _tmp20_);
			result = NULL;
			_g_error_free0 (e);
			_g_variant_unref0 (props);
			_g_object_unref0 (conn);
			_g_free0 (address);
			return result;
		}
		__finally1:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_variant_unref0 (props);
			_g_object_unref0 (conn);
			_g_free0 (address);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_g_variant_unref0 (props);
		_g_object_unref0 (conn);
	}
	conn = NULL;
	{
		GDBusConnection* _tmp21_ = NULL;
		const gchar* _tmp22_;
		GDBusConnection* _tmp23_;
		GDBusConnection* _tmp24_;
		_tmp22_ = address;
		_tmp23_ = g_dbus_connection_new_for_address_sync (_tmp22_, G_DBUS_CONNECTION_FLAGS_AUTHENTICATION_CLIENT, NULL, NULL, &_inner_error0_);
		_tmp21_ = _tmp23_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch2_g_error;
		}
		_tmp24_ = _tmp21_;
		_tmp21_ = NULL;
		_g_object_unref0 (conn);
		conn = _tmp24_;
		_g_object_unref0 (_tmp21_);
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp25_;
		GError* _tmp26_;
		const gchar* _tmp27_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp25_ = address;
		_tmp26_ = e;
		_tmp27_ = _tmp26_->message;
		g_warning ("volume-control-pulse.vala:765: Unable to connect to dbus server at '%s" \
"': %s", _tmp25_, _tmp27_);
		_g_error_free0 (e);
	}
	__finally2:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (conn);
		_g_free0 (address);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	_tmp28_ = address;
	_tmp29_ = conn;
	g_debug ("volume-control-pulse.vala:768: PulseAudio dbus address is '%s', connec" \
"tion is '%p'", _tmp28_, _tmp29_);
	result = conn;
	_g_free0 (address);
	return result;
}

static GDBusMessage*
_volume_control_pulse_pulse_dbus_filter_gd_bus_message_filter_function (GDBusConnection* connection,
                                                                        GDBusMessage* message,
                                                                        gboolean incoming,
                                                                        gpointer self)
{
	GDBusMessage* result;
	result = volume_control_pulse_pulse_dbus_filter ((VolumeControlPulse*) self, connection, message, incoming);
	return result;
}

static void
volume_control_pulse_reconnect_pulse_dbus (VolumeControlPulse* self)
{
	GDBusConnection* _tmp0_;
	GDBusConnection* _tmp1_;
	GDBusConnection* _tmp2_;
	GDBusConnection* _tmp3_;
	gchar* _tmp4_;
	GDBusConnection* _tmp5_;
	gchar* _tmp6_;
	GDBusConnection* _tmp7_;
	gchar* _tmp8_;
	GDBusConnection* _tmp9_;
	gchar* _tmp10_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	const gchar* _tmp14_;
	g_return_if_fail (self != NULL);
	self->priv->_pulse_use_stream_restore = FALSE;
	self->priv->_pa_volume_sig_count = (guint) 0;
	_tmp0_ = volume_control_pulse_create_pulse_dbus_connection ();
	_g_object_unref0 (self->priv->_pconn);
	self->priv->_pconn = _tmp0_;
	_tmp1_ = self->priv->_pconn;
	if (_tmp1_ == NULL) {
		return;
	}
	_tmp2_ = self->priv->_pconn;
	g_dbus_connection_add_filter (_tmp2_, _volume_control_pulse_pulse_dbus_filter_gd_bus_message_filter_function, g_object_ref (self), g_object_unref);
	_tmp3_ = self->priv->_pconn;
	_tmp4_ = volume_control_pulse_stream_restore_get_object_path (_tmp3_, "sink-input-by-media-role:multimedia");
	_g_free0 (self->priv->_objp_role_multimedia);
	self->priv->_objp_role_multimedia = _tmp4_;
	_tmp5_ = self->priv->_pconn;
	_tmp6_ = volume_control_pulse_stream_restore_get_object_path (_tmp5_, "sink-input-by-media-role:alert");
	_g_free0 (self->priv->_objp_role_alert);
	self->priv->_objp_role_alert = _tmp6_;
	_tmp7_ = self->priv->_pconn;
	_tmp8_ = volume_control_pulse_stream_restore_get_object_path (_tmp7_, "sink-input-by-media-role:alarm");
	_g_free0 (self->priv->_objp_role_alarm);
	self->priv->_objp_role_alarm = _tmp8_;
	_tmp9_ = self->priv->_pconn;
	_tmp10_ = volume_control_pulse_stream_restore_get_object_path (_tmp9_, "sink-input-by-media-role:phone");
	_g_free0 (self->priv->_objp_role_phone);
	self->priv->_objp_role_phone = _tmp10_;
	_tmp14_ = self->priv->_objp_role_multimedia;
	if (_tmp14_ != NULL) {
		const gchar* _tmp15_;
		_tmp15_ = self->priv->_objp_role_alert;
		_tmp13_ = _tmp15_ != NULL;
	} else {
		_tmp13_ = FALSE;
	}
	if (_tmp13_) {
		const gchar* _tmp16_;
		_tmp16_ = self->priv->_objp_role_alarm;
		_tmp12_ = _tmp16_ != NULL;
	} else {
		_tmp12_ = FALSE;
	}
	if (_tmp12_) {
		const gchar* _tmp17_;
		_tmp17_ = self->priv->_objp_role_phone;
		_tmp11_ = _tmp17_ != NULL;
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		g_debug ("volume-control-pulse.vala:795: Using PulseAudio DBUS Stream Restore mo" \
"dule");
		volume_control_pulse_update_active_sink_input (self, (gint32) -1, NULL, NULL);
		self->priv->_pulse_use_stream_restore = TRUE;
	}
}

gchar*
volume_control_pulse_stream_restore_get_object_path (GDBusConnection* pconn,
                                                     const gchar* name)
{
	gchar* objp = NULL;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (pconn != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	objp = NULL;
	{
		GVariant* props_variant = NULL;
		GVariant* _tmp0_;
		GVariant* _tmp1_;
		GVariant* _tmp2_;
		GVariant* _tmp3_;
		GVariantIter* iter = NULL;
		GVariantIter* _tmp4_;
		GVariantIter* _tmp5_;
		_tmp0_ = g_variant_new ("(s)", name, NULL);
		g_variant_ref_sink (_tmp0_);
		_tmp1_ = _tmp0_;
		_tmp2_ = g_dbus_connection_call_sync (pconn, "org.PulseAudio.Ext.StreamRestore1", "/org/pulseaudio/stream_restore1", "org.PulseAudio.Ext.StreamRestore1", "GetEntryByName", _tmp1_, NULL, G_DBUS_CALL_FLAGS_NONE, -1, NULL, &_inner_error0_);
		_tmp3_ = _tmp2_;
		_g_variant_unref0 (_tmp1_);
		props_variant = _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_tmp4_ = g_variant_iter_new (props_variant);
		iter = _tmp4_;
		_tmp5_ = iter;
		g_variant_iter_next (_tmp5_, "o", &objp, NULL);
		g_debug ("volume-control-pulse.vala:811: Found obj path %s for restore data name" \
"d %s\n", objp, name);
		_g_variant_iter_free0 (iter);
		_g_variant_unref0 (props_variant);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp6_;
		const gchar* _tmp7_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp6_ = e;
		_tmp7_ = _tmp6_->message;
		g_debug ("volume-control-pulse.vala:813: unable to find stream restore data for:" \
" %s. Error: %s", name, _tmp7_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (objp);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return NULL;
	}
	result = objp;
	return result;
}

static gboolean
_volume_control_pulse_local_volume_changed_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = volume_control_pulse_local_volume_changed_timeout ((VolumeControlPulse*) self);
	return result;
}

static void
volume_control_pulse_start_local_volume_timer (VolumeControlPulse* self)
{
	g_return_if_fail (self != NULL);
	volume_control_pulse_stop_account_service_volume_timer (self);
	if (self->priv->_local_volume_timer == ((guint) 0)) {
		AccountsServiceAccess* _tmp0_;
		VolumeControlVolume* _tmp1_;
		_tmp0_ = self->priv->_accounts_service_access;
		_tmp1_ = self->priv->_volume;
		accounts_service_access_set_volume (_tmp0_, _tmp1_->volume);
		self->priv->_local_volume_timer = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, _volume_control_pulse_local_volume_changed_timeout_gsource_func, g_object_ref (self), g_object_unref);
	} else {
		self->priv->_send_next_local_volume = TRUE;
	}
}

static void
volume_control_pulse_stop_local_volume_timer (VolumeControlPulse* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->_local_volume_timer != ((guint) 0)) {
		g_source_remove (self->priv->_local_volume_timer);
		self->priv->_local_volume_timer = (guint) 0;
	}
}

static gboolean
volume_control_pulse_local_volume_changed_timeout (VolumeControlPulse* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->_local_volume_timer = (guint) 0;
	if (self->priv->_send_next_local_volume) {
		self->priv->_send_next_local_volume = FALSE;
		volume_control_pulse_start_local_volume_timer (self);
	}
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
_volume_control_pulse_accountservice_volume_changed_timeout_gsource_func (gpointer self)
{
	gboolean result;
	result = volume_control_pulse_accountservice_volume_changed_timeout ((VolumeControlPulse*) self);
	return result;
}

static void
volume_control_pulse_start_account_service_volume_timer (VolumeControlPulse* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->_accountservice_volume_timer == ((guint) 0)) {
		if (self->priv->_local_volume_timer == ((guint) 0)) {
			VolumeControlVolume* vol = NULL;
			VolumeControlVolume* _tmp0_;
			VolumeControlVolume* _tmp1_;
			VolumeControlVolume* _tmp2_;
			VolumeControlVolume* _tmp3_;
			_tmp0_ = volume_control_volume_new ();
			vol = _tmp0_;
			_tmp1_ = vol;
			_tmp1_->volume = self->priv->_account_service_volume;
			_tmp2_ = vol;
			_tmp2_->reason = VOLUME_CONTROL_VOLUME_REASONS_ACCOUNTS_SERVICE_SET;
			_tmp3_ = vol;
			volume_control_set_volume ((VolumeControl*) self, _tmp3_);
			_g_object_unref0 (vol);
			return;
		}
		self->priv->_accountservice_volume_timer = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, _volume_control_pulse_accountservice_volume_changed_timeout_gsource_func, g_object_ref (self), g_object_unref);
	}
}

static void
volume_control_pulse_stop_account_service_volume_timer (VolumeControlPulse* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->_accountservice_volume_timer != ((guint) 0)) {
		g_source_remove (self->priv->_accountservice_volume_timer);
		self->priv->_accountservice_volume_timer = (guint) 0;
	}
}

static gboolean
volume_control_pulse_accountservice_volume_changed_timeout (VolumeControlPulse* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	self->priv->_accountservice_volume_timer = (guint) 0;
	volume_control_pulse_start_account_service_volume_timer (self);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
volume_control_pulse_real_get_active_mic (VolumeControl* base)
{
	gboolean result;
	VolumeControlPulse* self;
	self = (VolumeControlPulse*) base;
	result = self->priv->_active_mic;
	return result;
}

static void
volume_control_pulse_real_set_active_mic (VolumeControl* base,
                                          gboolean value)
{
	VolumeControlPulse* self;
	gboolean old_value;
	self = (VolumeControlPulse*) base;
	old_value = volume_control_pulse_real_get_active_mic (base);
	if (old_value != value) {
		self->priv->_active_mic = value;
		g_object_notify_by_pspec ((GObject *) self, volume_control_pulse_properties[VOLUME_CONTROL_PULSE_ACTIVE_MIC_PROPERTY]);
	}
}

static gboolean
volume_control_pulse_real_get_mute (VolumeControl* base)
{
	gboolean result;
	VolumeControlPulse* self;
	self = (VolumeControlPulse*) base;
	result = self->priv->_mute;
	return result;
}

static VolumeControlVolume*
volume_control_pulse_real_get_volume (VolumeControl* base)
{
	VolumeControlVolume* result;
	VolumeControlPulse* self;
	VolumeControlVolume* _tmp0_;
	self = (VolumeControlPulse*) base;
	_tmp0_ = self->priv->_volume;
	result = _tmp0_;
	return result;
}

static void
_volume_control_pulse_server_info_cb_for_set_volume_pa_server_info_cb_t (pa_context* c,
                                                                         pa_server_info* i,
                                                                         gpointer self)
{
	volume_control_pulse_server_info_cb_for_set_volume ((VolumeControlPulse*) self, c, i);
}

static void
volume_control_pulse_real_set_volume (VolumeControl* base,
                                      VolumeControlVolume* value)
{
	VolumeControlPulse* self;
	gboolean volume_changed = FALSE;
	VolumeControlVolume* _tmp0_;
	VolumeControlVolume* _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	pa_context* _tmp4_;
	gboolean _tmp9_ = FALSE;
	VolumeControlVolume* _tmp10_;
	VolumeControlVolume* _tmp11_;
	self = (VolumeControlPulse*) base;
	_tmp0_ = self->priv->_volume;
	volume_changed = value->volume != _tmp0_->volume;
	g_debug ("volume-control-pulse.vala:694: Setting volume to %f for profile %d bec" \
"ause %d", value->volume, (gint) self->priv->_active_sink_input, (gint) value->reason);
	_tmp1_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_volume);
	self->priv->_volume = _tmp1_;
	_tmp4_ = self->priv->context;
	if (pa_context_get_state (_tmp4_) == PA_CONTEXT_READY) {
		VolumeControlVolume* _tmp5_;
		_tmp5_ = self->priv->_volume;
		_tmp3_ = _tmp5_->reason != VOLUME_CONTROL_VOLUME_REASONS_PULSE_CHANGE;
	} else {
		_tmp3_ = FALSE;
	}
	if (_tmp3_) {
		_tmp2_ = volume_changed;
	} else {
		_tmp2_ = FALSE;
	}
	if (_tmp2_) {
		if (self->priv->_pulse_use_stream_restore) {
			volume_control_pulse_set_volume_active_role (self, NULL, NULL);
		} else {
			pa_context* _tmp6_;
			pa_operation* _tmp7_;
			pa_operation* _tmp8_;
			_tmp6_ = self->priv->context;
			_tmp7_ = pa_context_get_server_info (_tmp6_, _volume_control_pulse_server_info_cb_for_set_volume_pa_server_info_cb_t, self);
			_tmp8_ = _tmp7_;
			_pa_operation_unref0 (_tmp8_);
		}
	}
	_tmp10_ = volume_control_get_volume ((VolumeControl*) self);
	_tmp11_ = _tmp10_;
	if (_tmp11_->reason != VOLUME_CONTROL_VOLUME_REASONS_ACCOUNTS_SERVICE_SET) {
		_tmp9_ = volume_changed;
	} else {
		_tmp9_ = FALSE;
	}
	if (_tmp9_) {
		volume_control_pulse_start_local_volume_timer (self);
	}
	g_object_notify_by_pspec ((GObject *) self, volume_control_pulse_properties[VOLUME_CONTROL_PULSE_VOLUME_PROPERTY]);
}

static gdouble
volume_control_pulse_real_get_mic_volume (VolumeControl* base)
{
	gdouble result;
	VolumeControlPulse* self;
	self = (VolumeControlPulse*) base;
	result = self->priv->_mic_volume;
	return result;
}

static void
_volume_control_pulse_set_mic_volume_get_server_info_cb_pa_server_info_cb_t (pa_context* c,
                                                                             pa_server_info* i,
                                                                             gpointer self)
{
	volume_control_pulse_set_mic_volume_get_server_info_cb ((VolumeControlPulse*) self, c, i);
}

static void
volume_control_pulse_real_set_mic_volume (VolumeControl* base,
                                          gdouble value)
{
	VolumeControlPulse* self;
	pa_context* _tmp0_;
	pa_context* _tmp1_;
	pa_operation* _tmp2_;
	pa_operation* _tmp3_;
	self = (VolumeControlPulse*) base;
	_tmp0_ = self->priv->context;
	g_return_if_fail (pa_context_get_state (_tmp0_) == PA_CONTEXT_READY);
	self->priv->_mic_volume = value;
	_tmp1_ = self->priv->context;
	_tmp2_ = pa_context_get_server_info (_tmp1_, _volume_control_pulse_set_mic_volume_get_server_info_cb_pa_server_info_cb_t, self);
	_tmp3_ = _tmp2_;
	_pa_operation_unref0 (_tmp3_);
	g_object_notify_by_pspec ((GObject *) self, volume_control_pulse_properties[VOLUME_CONTROL_PULSE_MIC_VOLUME_PROPERTY]);
}

static void
volume_control_pulse_class_init (VolumeControlPulseClass * klass,
                                 gpointer klass_data)
{
	volume_control_pulse_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &VolumeControlPulse_private_offset);
	((VolumeControlClass *) klass)->set_mute = (void (*) (VolumeControl*, gboolean)) volume_control_pulse_real_set_mute;
	((VolumeControlClass *) klass)->active_output = (VolumeControlActiveOutput (*) (VolumeControl*)) volume_control_pulse_real_active_output;
	VOLUME_CONTROL_CLASS (klass)->get_active_mic = (gboolean (*) (VolumeControl*)) volume_control_pulse_real_get_active_mic;
	VOLUME_CONTROL_CLASS (klass)->set_active_mic = (void (*) (VolumeControl*, gboolean)) volume_control_pulse_real_set_active_mic;
	VOLUME_CONTROL_CLASS (klass)->get_mute = (gboolean (*) (VolumeControl*)) volume_control_pulse_real_get_mute;
	VOLUME_CONTROL_CLASS (klass)->get_volume = (VolumeControlVolume* (*) (VolumeControl*)) volume_control_pulse_real_get_volume;
	VOLUME_CONTROL_CLASS (klass)->set_volume = (void (*) (VolumeControl*, VolumeControlVolume*)) volume_control_pulse_real_set_volume;
	VOLUME_CONTROL_CLASS (klass)->get_mic_volume = (gdouble (*) (VolumeControl*)) volume_control_pulse_real_get_mic_volume;
	VOLUME_CONTROL_CLASS (klass)->set_mic_volume = (void (*) (VolumeControl*, gdouble)) volume_control_pulse_real_set_mic_volume;
	G_OBJECT_CLASS (klass)->get_property = _vala_volume_control_pulse_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_volume_control_pulse_set_property;
	G_OBJECT_CLASS (klass)->finalize = volume_control_pulse_finalize;
	/** true when a microphone is active **/
	g_object_class_install_property (G_OBJECT_CLASS (klass), VOLUME_CONTROL_PULSE_ACTIVE_MIC_PROPERTY, volume_control_pulse_properties[VOLUME_CONTROL_PULSE_ACTIVE_MIC_PROPERTY] = g_param_spec_boolean ("active-mic", "active-mic", "active-mic", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VOLUME_CONTROL_PULSE_MUTE_PROPERTY, volume_control_pulse_properties[VOLUME_CONTROL_PULSE_MUTE_PROPERTY] = g_param_spec_boolean ("mute", "mute", "mute", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), VOLUME_CONTROL_PULSE_VOLUME_PROPERTY, volume_control_pulse_properties[VOLUME_CONTROL_PULSE_VOLUME_PROPERTY] = g_param_spec_object ("volume", "volume", "volume", VOLUME_CONTROL_TYPE_VOLUME, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	/** MIC VOLUME PROPERTY */
	g_object_class_install_property (G_OBJECT_CLASS (klass), VOLUME_CONTROL_PULSE_MIC_VOLUME_PROPERTY, volume_control_pulse_properties[VOLUME_CONTROL_PULSE_MIC_VOLUME_PROPERTY] = g_param_spec_double ("mic-volume", "mic-volume", "mic-volume", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
volume_control_pulse_instance_init (VolumeControlPulse * self,
                                    gpointer klass)
{
	VolumeControlVolume* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeHashMap* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	self->priv = volume_control_pulse_get_instance_private (self);
	self->priv->loop = NULL;
	self->priv->_reconnect_timer = (guint) 0;
	self->priv->_mute = TRUE;
	_tmp0_ = volume_control_volume_new ();
	self->priv->_volume = _tmp0_;
	self->priv->_mic_volume = 0.0;
	_tmp1_ = gee_array_list_new (G_TYPE_UINT, NULL, NULL, NULL, NULL, NULL);
	self->priv->_sink_input_list = _tmp1_;
	_tmp2_ = gee_hash_map_new (G_TYPE_UINT, NULL, NULL, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
	self->priv->_sink_input_hash = _tmp2_;
	self->priv->_pulse_use_stream_restore = FALSE;
	self->priv->_active_sink_input = (gint32) -1;
	_tmp3_ = g_strdup ("multimedia");
	_tmp4_ = g_strdup ("alert");
	_tmp5_ = g_strdup ("alarm");
	_tmp6_ = g_strdup ("phone");
	_tmp7_ = g_new0 (gchar*, 4 + 1);
	_tmp7_[0] = _tmp3_;
	_tmp7_[1] = _tmp4_;
	_tmp7_[2] = _tmp5_;
	_tmp7_[3] = _tmp6_;
	self->priv->_valid_roles = _tmp7_;
	self->priv->_valid_roles_length1 = 4;
	self->priv->__valid_roles_size_ = self->priv->_valid_roles_length1;
	self->priv->_objp_role_multimedia = NULL;
	self->priv->_objp_role_alert = NULL;
	self->priv->_objp_role_alarm = NULL;
	self->priv->_objp_role_phone = NULL;
	g_rec_mutex_init (&self->priv->__lock__pa_volume_sig_count);
	self->priv->_pa_volume_sig_count = (guint) 0;
	self->priv->_local_volume_timer = (guint) 0;
	self->priv->_accountservice_volume_timer = (guint) 0;
	self->priv->_send_next_local_volume = FALSE;
	self->priv->_account_service_volume = 0.0;
	self->priv->_active_output = VOLUME_CONTROL_ACTIVE_OUTPUT_SPEAKERS;
	self->priv->_external_mic_detected = FALSE;
	self->priv->_source_sink_mic_activated = FALSE;
	self->priv->_active_mic = FALSE;
}

static void
volume_control_pulse_finalize (GObject * obj)
{
	VolumeControlPulse * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VOLUME_CONTROL_PULSE, VolumeControlPulse);
	volume_control_pulse_stop_all_timers (self);
	_pa_context_unref0 (self->priv->context);
	_g_object_unref0 (self->priv->_volume);
	_g_object_unref0 (self->priv->_pconn);
	_g_object_unref0 (self->priv->_sink_input_list);
	_g_object_unref0 (self->priv->_sink_input_hash);
	self->priv->_valid_roles = (_vala_array_free (self->priv->_valid_roles, self->priv->_valid_roles_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (self->priv->_objp_role_multimedia);
	_g_free0 (self->priv->_objp_role_alert);
	_g_free0 (self->priv->_objp_role_alarm);
	_g_free0 (self->priv->_objp_role_phone);
	g_rec_mutex_clear (&self->priv->__lock__pa_volume_sig_count);
	_g_object_unref0 (self->priv->_accounts_service_access);
	G_OBJECT_CLASS (volume_control_pulse_parent_class)->finalize (obj);
}

static GType
volume_control_pulse_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VolumeControlPulseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) volume_control_pulse_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VolumeControlPulse), 0, (GInstanceInitFunc) volume_control_pulse_instance_init, NULL };
	GType volume_control_pulse_type_id;
	volume_control_pulse_type_id = g_type_register_static (TYPE_VOLUME_CONTROL, "VolumeControlPulse", &g_define_type_info, 0);
	VolumeControlPulse_private_offset = g_type_add_instance_private (volume_control_pulse_type_id, sizeof (VolumeControlPulsePrivate));
	return volume_control_pulse_type_id;
}

GType
volume_control_pulse_get_type (void)
{
	static volatile gsize volume_control_pulse_type_id__once = 0;
	if (g_once_init_enter (&volume_control_pulse_type_id__once)) {
		GType volume_control_pulse_type_id;
		volume_control_pulse_type_id = volume_control_pulse_get_type_once ();
		g_once_init_leave (&volume_control_pulse_type_id__once, volume_control_pulse_type_id);
	}
	return volume_control_pulse_type_id__once;
}

static void
_vala_volume_control_pulse_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	VolumeControlPulse * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_VOLUME_CONTROL_PULSE, VolumeControlPulse);
	switch (property_id) {
		case VOLUME_CONTROL_PULSE_ACTIVE_MIC_PROPERTY:
		g_value_set_boolean (value, volume_control_get_active_mic ((VolumeControl*) self));
		break;
		case VOLUME_CONTROL_PULSE_MUTE_PROPERTY:
		g_value_set_boolean (value, volume_control_get_mute ((VolumeControl*) self));
		break;
		case VOLUME_CONTROL_PULSE_VOLUME_PROPERTY:
		g_value_set_object (value, volume_control_get_volume ((VolumeControl*) self));
		break;
		case VOLUME_CONTROL_PULSE_MIC_VOLUME_PROPERTY:
		g_value_set_double (value, volume_control_get_mic_volume ((VolumeControl*) self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_volume_control_pulse_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	VolumeControlPulse * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_VOLUME_CONTROL_PULSE, VolumeControlPulse);
	switch (property_id) {
		case VOLUME_CONTROL_PULSE_ACTIVE_MIC_PROPERTY:
		volume_control_set_active_mic ((VolumeControl*) self, g_value_get_boolean (value));
		break;
		case VOLUME_CONTROL_PULSE_VOLUME_PROPERTY:
		volume_control_set_volume ((VolumeControl*) self, g_value_get_object (value));
		break;
		case VOLUME_CONTROL_PULSE_MIC_VOLUME_PROPERTY:
		volume_control_set_mic_volume ((VolumeControl*) self, g_value_get_double (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

