/* volume-warning-pulse.c generated by valac 0.56.16, the Vala compiler
 * generated from volume-warning-pulse.vala, do not modify */

/*
 * -*- Mode:Vala; indent-tabs-mode:t; tab-width:4; encoding:utf8 -*-
 *
 * Copyright 2015 Canonical Ltd.
 * Copyright 2021 Robert Tari
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; version 3.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *      Charles Kerr <charles.kerr@canonical.com>
 *      Robert Tari <robert@tari.in>
 */

#include <glib-object.h>
#include <pulse/pulseaudio.h>
#include <pulse/glib-mainloop.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <ayatana/common/utils.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_VOLUME_WARNING (volume_warning_get_type ())
#define VOLUME_WARNING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VOLUME_WARNING, VolumeWarning))
#define VOLUME_WARNING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VOLUME_WARNING, VolumeWarningClass))
#define IS_VOLUME_WARNING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VOLUME_WARNING))
#define IS_VOLUME_WARNING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VOLUME_WARNING))
#define VOLUME_WARNING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VOLUME_WARNING, VolumeWarningClass))

typedef struct _VolumeWarning VolumeWarning;
typedef struct _VolumeWarningClass VolumeWarningClass;
typedef struct _VolumeWarningPrivate VolumeWarningPrivate;

#define TYPE_VOLUME_WARNING_PULSE (volume_warning_pulse_get_type ())
#define VOLUME_WARNING_PULSE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_VOLUME_WARNING_PULSE, VolumeWarningPulse))
#define VOLUME_WARNING_PULSE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_VOLUME_WARNING_PULSE, VolumeWarningPulseClass))
#define IS_VOLUME_WARNING_PULSE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_VOLUME_WARNING_PULSE))
#define IS_VOLUME_WARNING_PULSE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_VOLUME_WARNING_PULSE))
#define VOLUME_WARNING_PULSE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_VOLUME_WARNING_PULSE, VolumeWarningPulseClass))

typedef struct _VolumeWarningPulse VolumeWarningPulse;
typedef struct _VolumeWarningPulseClass VolumeWarningPulseClass;
typedef struct _VolumeWarningPulsePrivate VolumeWarningPulsePrivate;
enum  {
	VOLUME_WARNING_PULSE_0_PROPERTY,
	VOLUME_WARNING_PULSE_NUM_PROPERTIES
};
static GParamSpec* volume_warning_pulse_properties[VOLUME_WARNING_PULSE_NUM_PROPERTIES];
#define _pa_context_unref0(var) ((var == NULL) ? NULL : (var = (pa_context_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))

#define INDICATOR_SOUND_TYPE_OPTIONS (indicator_sound_options_get_type ())
#define INDICATOR_SOUND_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), INDICATOR_SOUND_TYPE_OPTIONS, IndicatorSoundOptions))
#define INDICATOR_SOUND_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), INDICATOR_SOUND_TYPE_OPTIONS, IndicatorSoundOptionsClass))
#define INDICATOR_SOUND_IS_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), INDICATOR_SOUND_TYPE_OPTIONS))
#define INDICATOR_SOUND_IS_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), INDICATOR_SOUND_TYPE_OPTIONS))
#define INDICATOR_SOUND_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), INDICATOR_SOUND_TYPE_OPTIONS, IndicatorSoundOptionsClass))

typedef struct _IndicatorSoundOptions IndicatorSoundOptions;
typedef struct _IndicatorSoundOptionsClass IndicatorSoundOptionsClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _pa_operation_unref0(var) ((var == NULL) ? NULL : (var = (pa_operation_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
#define _pa_proplist_free0(var) ((var == NULL) ? NULL : (var = (pa_proplist_free (var), NULL)))

struct _VolumeWarning {
	GObject parent_instance;
	VolumeWarningPrivate * priv;
};

struct _VolumeWarningClass {
	GObjectClass parent_class;
	void (*sound_system_set_multimedia_volume) (VolumeWarning* self, pa_volume_t volume);
	void (*preshow) (VolumeWarning* self);
};

struct _VolumeWarningPulse {
	VolumeWarning parent_instance;
	VolumeWarningPulsePrivate * priv;
};

struct _VolumeWarningPulseClass {
	VolumeWarningClass parent_class;
};

struct _VolumeWarningPulsePrivate {
	pa_glib_mainloop* _pgloop;
	pa_context* _pulse_context;
	guint _pulse_reconnect_timer;
	guint _pending_sink_inputs_timer;
	GHashTable* _pending_sink_inputs;
	guint soon_interval_msec;
	guint32 _target_sink_input_index;
	guint32 _multimedia_sink_input_index;
};

struct _Block1Data {
	int _ref_count_;
	GHashTable* self;
	GFunc func;
	gpointer func_target;
};

static gint VolumeWarningPulse_private_offset;
static gpointer volume_warning_pulse_parent_class = NULL;

VALA_EXTERN GType volume_warning_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VolumeWarning, g_object_unref)
VALA_EXTERN GType volume_warning_pulse_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VolumeWarningPulse, g_object_unref)
VALA_EXTERN void volume_warning_preshow (VolumeWarning* self);
VALA_EXTERN void volume_warning_sound_system_set_multimedia_volume (VolumeWarning* self,
                                                        pa_volume_t volume);
VALA_EXTERN void volume_warning_clear_timer (VolumeWarning* self,
                                 guint* timer);
static void volume_warning_pulse_pulse_disconnect (VolumeWarningPulse* self);
VALA_EXTERN GType indicator_sound_options_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IndicatorSoundOptions, g_object_unref)
VALA_EXTERN VolumeWarningPulse* volume_warning_pulse_new (IndicatorSoundOptions* options,
                                              pa_glib_mainloop* pgloop);
VALA_EXTERN VolumeWarningPulse* volume_warning_pulse_construct (GType object_type,
                                                    IndicatorSoundOptions* options,
                                                    pa_glib_mainloop* pgloop);
VALA_EXTERN VolumeWarning* volume_warning_construct (GType object_type,
                                         IndicatorSoundOptions* options);
static void volume_warning_pulse_pulse_reconnect (VolumeWarningPulse* self);
static void volume_warning_pulse_real_preshow (VolumeWarning* base);
static void volume_warning_pulse_real_sound_system_set_multimedia_volume (VolumeWarning* base,
                                                                   pa_volume_t volume);
static gboolean volume_warning_pulse_is_active_multimedia (VolumeWarningPulse* self,
                                                    pa_sink_input_info* i);
static void volume_warning_pulse_clear_multimedia (VolumeWarningPulse* self);
VALA_EXTERN void volume_warning_set_multimedia_volume (VolumeWarning* self,
                                           guint value);
VALA_EXTERN void volume_warning_set_multimedia_active (VolumeWarning* self,
                                           gboolean value);
static void volume_warning_pulse_on_sink_input_info (VolumeWarningPulse* self,
                                              pa_context* c,
                                              pa_sink_input_info* i,
                                              gint eol);
static void volume_warning_pulse_update_all_sink_inputs (VolumeWarningPulse* self);
static void _volume_warning_pulse_on_sink_input_info_pa_sink_input_info_cb_t (pa_context* c,
                                                                       pa_sink_input_info* i,
                                                                       gint eol,
                                                                       gpointer self);
static void volume_warning_pulse_update_sink_input (VolumeWarningPulse* self,
                                             guint32 index);
static void volume_warning_pulse_update_sink_input_soon (VolumeWarningPulse* self,
                                                  guint32 index);
static gboolean ___lambda4_ (VolumeWarningPulse* self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void ___lambda2__gh_func (gconstpointer key,
                          gconstpointer value,
                          gpointer self);
static void __lambda5_ (VolumeWarningPulse* self,
                 guint32 i);
static void ___lambda5__gfunc (gconstpointer data,
                        gpointer self);
static gboolean ____lambda4__gsource_func (gpointer self);
static void volume_warning_pulse_context_events_cb (VolumeWarningPulse* self,
                                             pa_context* c,
                                             pa_subscription_event_type_t t,
                                             guint32 index);
static void volume_warning_pulse_pulse_context_state_callback (VolumeWarningPulse* self,
                                                        pa_context* c);
static void _volume_warning_pulse_context_events_cb_pa_context_subscribe_cb_t (pa_context* c,
                                                                        pa_subscription_event_type_t t,
                                                                        guint32 idx,
                                                                        gpointer self);
static void volume_warning_pulse_pulse_reconnect_soon (VolumeWarningPulse* self);
static gboolean ___lambda6_ (VolumeWarningPulse* self);
static gboolean ____lambda6__gsource_func (gpointer self);
static void _volume_warning_pulse_pulse_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                                gpointer self);
static void volume_warning_pulse_finalize (GObject * obj);
static GType volume_warning_pulse_get_type_once (void);

static inline gpointer
volume_warning_pulse_get_instance_private (VolumeWarningPulse* self)
{
	return G_STRUCT_MEMBER_P (self, VolumeWarningPulse_private_offset);
}

VolumeWarningPulse*
volume_warning_pulse_construct (GType object_type,
                                IndicatorSoundOptions* options,
                                pa_glib_mainloop* pgloop)
{
	VolumeWarningPulse * self = NULL;
	g_return_val_if_fail (options != NULL, NULL);
	g_return_val_if_fail (pgloop != NULL, NULL);
	self = (VolumeWarningPulse*) volume_warning_construct (object_type, options);
	self->priv->_pgloop = pgloop;
	volume_warning_pulse_pulse_reconnect (self);
	return self;
}

VolumeWarningPulse*
volume_warning_pulse_new (IndicatorSoundOptions* options,
                          pa_glib_mainloop* pgloop)
{
	return volume_warning_pulse_construct (TYPE_VOLUME_WARNING_PULSE, options, pgloop);
}

static void
volume_warning_pulse_real_preshow (VolumeWarning* base)
{
	VolumeWarningPulse * self;
	self = (VolumeWarningPulse*) base;
	self->priv->_target_sink_input_index = self->priv->_multimedia_sink_input_index;
}

static gchar*
pulse_audio_cvolume_sprint (pa_cvolume *self)
{
	gchar* buffer = NULL;
	gchar* _tmp0_;
	gint buffer_length1;
	gint _buffer_size_;
	gchar* _tmp1_;
	gchar* result;
	_tmp0_ = g_new0 (gchar, PA_CVOLUME_SNPRINT_MAX);
	buffer = _tmp0_;
	buffer_length1 = PA_CVOLUME_SNPRINT_MAX;
	_buffer_size_ = buffer_length1;
	pa_cvolume_snprint (buffer, (gint) buffer_length1, &(*self));
	_tmp1_ = g_strdup ((const gchar*) buffer);
	result = _tmp1_;
	buffer = (g_free (buffer), NULL);
	return result;
}

static gchar*
pulse_audio_cvolume_to_string (pa_cvolume *self)
{
	gchar* _tmp0_;
	gchar* result;
	_tmp0_ = pulse_audio_cvolume_sprint (&(*self));
	result = _tmp0_;
	return result;
}

static void
volume_warning_pulse_real_sound_system_set_multimedia_volume (VolumeWarning* base,
                                                              pa_volume_t volume)
{
	VolumeWarningPulse * self;
	guint32 index = 0U;
	pa_context* _tmp0_;
	pa_cvolume cvol = {0};
	gchar* _tmp1_;
	gchar* _tmp2_;
	pa_context* _tmp3_;
	pa_cvolume _tmp4_;
	pa_operation* _tmp5_;
	pa_operation* _tmp6_;
	self = (VolumeWarningPulse*) base;
	index = self->priv->_target_sink_input_index;
	_tmp0_ = self->priv->_pulse_context;
	g_return_if_fail (_tmp0_ != NULL);
	g_return_if_fail (index != PA_INVALID_INDEX);
	g_return_if_fail (volume != PA_VOLUME_MAX);
	pa_cvolume_init (&cvol);
	pa_cvolume_set (&cvol, (guint8) 1, volume);
	_tmp1_ = pulse_audio_cvolume_to_string (&cvol);
	_tmp2_ = _tmp1_;
	g_debug ("volume-warning-pulse.vala:62: setting multimedia (sink_input index %d)" \
" volume to %s", (gint) index, _tmp2_);
	_g_free0 (_tmp2_);
	_tmp3_ = self->priv->_pulse_context;
	_tmp4_ = cvol;
	_tmp5_ = pa_context_set_sink_input_volume (_tmp3_, index, &_tmp4_, NULL, NULL);
	_tmp6_ = _tmp5_;
	_pa_operation_unref0 (_tmp6_);
}

/***/
static gboolean
volume_warning_pulse_is_active_multimedia (VolumeWarningPulse* self,
                                           pa_sink_input_info* i)
{
	gboolean _tmp0_ = FALSE;
	pa_sink_input_info _tmp1_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (i != NULL, FALSE);
	_tmp1_ = *i;
	if (_tmp1_.corked == 0) {
		pa_sink_input_info _tmp2_;
		pa_proplist* _tmp3_;
		const gchar* _tmp4_;
		_tmp2_ = *i;
		_tmp3_ = _tmp2_.proplist;
		_tmp4_ = pa_proplist_gets (_tmp3_, PA_PROP_MEDIA_ROLE);
		_tmp0_ = g_strcmp0 (_tmp4_, "multimedia") == 0;
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

static void
volume_warning_pulse_clear_multimedia (VolumeWarningPulse* self)
{
	g_return_if_fail (self != NULL);
	self->priv->_multimedia_sink_input_index = PA_INVALID_INDEX;
	volume_warning_set_multimedia_volume ((VolumeWarning*) self, (guint) PA_VOLUME_MAX);
	volume_warning_set_multimedia_active ((VolumeWarning*) self, FALSE);
}

static void
volume_warning_pulse_on_sink_input_info (VolumeWarningPulse* self,
                                         pa_context* c,
                                         pa_sink_input_info* i,
                                         gint eol)
{
	pa_sink_input_info _tmp0_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	if (i == NULL) {
		return;
	}
	_tmp0_ = *i;
	if (volume_warning_pulse_is_active_multimedia (self, &_tmp0_)) {
		g_debug ("volume-warning-pulse.vala:97: on_sink_input_info() setting multimedia " \
"sink input index to %d, sink index to %d", (gint) (*i).index, (gint) (*i).sink);
		self->priv->_multimedia_sink_input_index = (*i).index;
		volume_warning_set_multimedia_volume ((VolumeWarning*) self, (guint) pa_cvolume_max (&(*i).volume));
		volume_warning_set_multimedia_active ((VolumeWarning*) self, TRUE);
	} else {
		if ((*i).index == self->priv->_multimedia_sink_input_index) {
			volume_warning_pulse_clear_multimedia (self);
		}
	}
}

static void
_volume_warning_pulse_on_sink_input_info_pa_sink_input_info_cb_t (pa_context* c,
                                                                  pa_sink_input_info* i,
                                                                  gint eol,
                                                                  gpointer self)
{
	volume_warning_pulse_on_sink_input_info ((VolumeWarningPulse*) self, c, i, eol);
}

static void
volume_warning_pulse_update_all_sink_inputs (VolumeWarningPulse* self)
{
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_pulse_context;
	_tmp1_ = pa_context_get_sink_input_info_list (_tmp0_, _volume_warning_pulse_on_sink_input_info_pa_sink_input_info_cb_t, self);
	_tmp2_ = _tmp1_;
	_pa_operation_unref0 (_tmp2_);
}

static void
volume_warning_pulse_update_sink_input (VolumeWarningPulse* self,
                                        guint32 index)
{
	pa_context* _tmp0_;
	pa_operation* _tmp1_;
	pa_operation* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_pulse_context;
	_tmp1_ = pa_context_get_sink_input_info (_tmp0_, index, _volume_warning_pulse_on_sink_input_info_pa_sink_input_info_cb_t, self);
	_tmp2_ = _tmp1_;
	_pa_operation_unref0 (_tmp2_);
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		GHashTable* self;
		self = _data1_->self;
		_g_hash_table_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static void
__lambda2_ (Block1Data* _data1_,
            gconstpointer k,
            gconstpointer v)
{
	GHashTable* self;
	self = _data1_->self;
	_data1_->func (v, _data1_->func_target);
}

static void
___lambda2__gh_func (gconstpointer key,
                     gconstpointer value,
                     gpointer self)
{
	__lambda2_ (self, key, value);
}

static void
_vala_g_hash_set_foreach (GHashTable* self,
                          GFunc func,
                          gpointer func_target)
{
	Block1Data* _data1_;
	g_return_if_fail (self != NULL);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_hash_table_ref (self);
	_data1_->func = func;
	_data1_->func_target = func_target;
	g_hash_table_foreach ((GHashTable*) self, ___lambda2__gh_func, _data1_);
	block1_data_unref (_data1_);
	_data1_ = NULL;
}

static void
__lambda5_ (VolumeWarningPulse* self,
            guint32 i)
{
	volume_warning_pulse_update_sink_input (self, i);
}

static void
___lambda5__gfunc (gconstpointer data,
                   gpointer self)
{
	__lambda5_ ((VolumeWarningPulse*) self, (guint32) ((guintptr) data));
}

static gboolean
___lambda4_ (VolumeWarningPulse* self)
{
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	gboolean result;
	self->priv->_pending_sink_inputs_timer = (guint) 0;
	_tmp0_ = self->priv->_pending_sink_inputs;
	_vala_g_hash_set_foreach (_tmp0_, ___lambda5__gfunc, self);
	_tmp1_ = self->priv->_pending_sink_inputs;
	g_hash_table_remove_all (_tmp1_);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
____lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda4_ ((VolumeWarningPulse*) self);
	return result;
}

static void
volume_warning_pulse_update_sink_input_soon (VolumeWarningPulse* self,
                                             guint32 index)
{
	GHashTable* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_pending_sink_inputs;
	g_hash_table_add (_tmp0_, (gpointer) ((guintptr) index));
	if (self->priv->_pending_sink_inputs_timer == ((guint) 0)) {
		self->priv->_pending_sink_inputs_timer = g_timeout_add_full (G_PRIORITY_DEFAULT, self->priv->soon_interval_msec, ____lambda4__gsource_func, g_object_ref (self), g_object_unref);
	}
}

static void
volume_warning_pulse_context_events_cb (VolumeWarningPulse* self,
                                        pa_context* c,
                                        pa_subscription_event_type_t t,
                                        guint32 index)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	switch (t & PA_SUBSCRIPTION_EVENT_FACILITY_MASK) {
		case PA_SUBSCRIPTION_EVENT_SINK_INPUT:
		{
			switch (t & PA_SUBSCRIPTION_EVENT_TYPE_MASK) {
				case PA_SUBSCRIPTION_EVENT_NEW:
				case PA_SUBSCRIPTION_EVENT_CHANGE:
				{
					volume_warning_pulse_update_sink_input_soon (self, index);
					break;
				}
				case PA_SUBSCRIPTION_EVENT_REMOVE:
				{
					if (index == self->priv->_multimedia_sink_input_index) {
						volume_warning_pulse_clear_multimedia (self);
						volume_warning_pulse_update_all_sink_inputs (self);
					}
					break;
				}
				default:
				{
					g_debug ("volume-warning-pulse.vala:151: Sink input event not known.");
					break;
				}
			}
			break;
		}
		default:
		{
			break;
		}
	}
}

static void
_volume_warning_pulse_context_events_cb_pa_context_subscribe_cb_t (pa_context* c,
                                                                   pa_subscription_event_type_t t,
                                                                   guint32 idx,
                                                                   gpointer self)
{
	volume_warning_pulse_context_events_cb ((VolumeWarningPulse*) self, c, t, idx);
}

static void
volume_warning_pulse_pulse_context_state_callback (VolumeWarningPulse* self,
                                                   pa_context* c)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (c != NULL);
	switch (pa_context_get_state (c)) {
		case PA_CONTEXT_READY:
		{
			pa_operation* _tmp0_;
			pa_operation* _tmp1_;
			pa_context_set_subscribe_callback (c, _volume_warning_pulse_context_events_cb_pa_context_subscribe_cb_t, self);
			_tmp0_ = pa_context_subscribe (c, PA_SUBSCRIPTION_MASK_SINK | PA_SUBSCRIPTION_MASK_SINK_INPUT, NULL, NULL);
			_tmp1_ = _tmp0_;
			_pa_operation_unref0 (_tmp1_);
			volume_warning_pulse_update_all_sink_inputs (self);
			break;
		}
		case PA_CONTEXT_FAILED:
		case PA_CONTEXT_TERMINATED:
		{
			volume_warning_pulse_pulse_reconnect_soon (self);
			break;
		}
		default:
		{
			break;
		}
	}
}

static void
volume_warning_pulse_pulse_disconnect (VolumeWarningPulse* self)
{
	pa_context* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_pulse_context;
	if (_tmp0_ != NULL) {
		pa_context* _tmp1_;
		_tmp1_ = self->priv->_pulse_context;
		pa_context_disconnect (_tmp1_);
		_pa_context_unref0 (self->priv->_pulse_context);
		self->priv->_pulse_context = NULL;
	}
}

static gboolean
___lambda6_ (VolumeWarningPulse* self)
{
	gboolean result;
	self->priv->_pulse_reconnect_timer = (guint) 0;
	volume_warning_pulse_pulse_reconnect (self);
	result = G_SOURCE_REMOVE;
	return result;
}

static gboolean
____lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda6_ ((VolumeWarningPulse*) self);
	return result;
}

static void
volume_warning_pulse_pulse_reconnect_soon (VolumeWarningPulse* self)
{
	g_return_if_fail (self != NULL);
	if (self->priv->_pulse_reconnect_timer == ((guint) 0)) {
		self->priv->_pulse_reconnect_timer = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 2, ____lambda6__gsource_func, g_object_ref (self), g_object_unref);
	}
}

static void
_volume_warning_pulse_pulse_context_state_callback_pa_context_notify_cb_t (pa_context* c,
                                                                           gpointer self)
{
	volume_warning_pulse_pulse_context_state_callback ((VolumeWarningPulse*) self, c);
}

static void
volume_warning_pulse_pulse_reconnect (VolumeWarningPulse* self)
{
	pa_proplist* props = NULL;
	pa_proplist* _tmp0_;
	pa_glib_mainloop* _tmp5_;
	pa_mainloop_api* _tmp6_;
	pa_proplist* _tmp7_;
	pa_context* _tmp8_;
	pa_context* _tmp9_;
	const gchar* server_string = NULL;
	const gchar* _tmp10_;
	pa_context* _tmp11_;
	const gchar* _tmp12_;
	g_return_if_fail (self != NULL);
	volume_warning_pulse_pulse_disconnect (self);
	_tmp0_ = pa_proplist_new ();
	props = _tmp0_;
	if (ayatana_common_utils_is_unity ()) {
		pa_proplist* _tmp1_;
		pa_proplist* _tmp2_;
		pa_proplist* _tmp3_;
		pa_proplist* _tmp4_;
		_tmp1_ = props;
		pa_proplist_sets (_tmp1_, PA_PROP_APPLICATION_NAME, "Ubuntu Audio Settings");
		_tmp2_ = props;
		pa_proplist_sets (_tmp2_, PA_PROP_APPLICATION_ID, "com.canonical.settings.sound");
		_tmp3_ = props;
		pa_proplist_sets (_tmp3_, PA_PROP_APPLICATION_ICON_NAME, "multimedia-volume-control");
		_tmp4_ = props;
		pa_proplist_sets (_tmp4_, PA_PROP_APPLICATION_VERSION, "0.1");
	}
	_tmp5_ = self->priv->_pgloop;
	_tmp6_ = pa_glib_mainloop_get_api (_tmp5_);
	_tmp7_ = props;
	_tmp8_ = pa_context_new_with_proplist (_tmp6_, NULL, _tmp7_);
	_pa_context_unref0 (self->priv->_pulse_context);
	self->priv->_pulse_context = _tmp8_;
	_tmp9_ = self->priv->_pulse_context;
	pa_context_set_state_callback (_tmp9_, _volume_warning_pulse_pulse_context_state_callback_pa_context_notify_cb_t, self);
	_tmp10_ = g_getenv ("PULSE_SERVER");
	server_string = _tmp10_;
	_tmp11_ = self->priv->_pulse_context;
	_tmp12_ = server_string;
	if (pa_context_connect (_tmp11_, _tmp12_, PA_CONTEXT_NOFAIL, NULL) < 0) {
		pa_context* _tmp13_;
		const gchar* _tmp14_;
		_tmp13_ = self->priv->_pulse_context;
		_tmp14_ = pa_strerror (pa_context_errno (_tmp13_));
		g_warning ("volume-warning-pulse.vala:216: pa_context_connect() failed: %s\n", _tmp14_);
	}
	_pa_proplist_free0 (props);
}

static void
volume_warning_pulse_class_init (VolumeWarningPulseClass * klass,
                                 gpointer klass_data)
{
	volume_warning_pulse_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &VolumeWarningPulse_private_offset);
	((VolumeWarningClass *) klass)->preshow = (void (*) (VolumeWarning*)) volume_warning_pulse_real_preshow;
	((VolumeWarningClass *) klass)->sound_system_set_multimedia_volume = (void (*) (VolumeWarning*, pa_volume_t)) volume_warning_pulse_real_sound_system_set_multimedia_volume;
	G_OBJECT_CLASS (klass)->finalize = volume_warning_pulse_finalize;
}

static void
volume_warning_pulse_instance_init (VolumeWarningPulse * self,
                                    gpointer klass)
{
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	self->priv = volume_warning_pulse_get_instance_private (self);
	self->priv->_pgloop = NULL;
	self->priv->_pulse_context = NULL;
	self->priv->_pulse_reconnect_timer = (guint) 0;
	self->priv->_pending_sink_inputs_timer = (guint) 0;
	_tmp0_ = g_direct_hash;
	_tmp1_ = g_direct_equal;
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, NULL, NULL);
	self->priv->_pending_sink_inputs = _tmp2_;
	self->priv->soon_interval_msec = (guint) 500;
	self->priv->_target_sink_input_index = PA_INVALID_INDEX;
	self->priv->_multimedia_sink_input_index = PA_INVALID_INDEX;
}

static void
volume_warning_pulse_finalize (GObject * obj)
{
	VolumeWarningPulse * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_VOLUME_WARNING_PULSE, VolumeWarningPulse);
	volume_warning_clear_timer ((VolumeWarning*) self, &self->priv->_pulse_reconnect_timer);
	volume_warning_clear_timer ((VolumeWarning*) self, &self->priv->_pending_sink_inputs_timer);
	volume_warning_pulse_pulse_disconnect (self);
	_pa_context_unref0 (self->priv->_pulse_context);
	_g_hash_table_unref0 (self->priv->_pending_sink_inputs);
	G_OBJECT_CLASS (volume_warning_pulse_parent_class)->finalize (obj);
}

/**
 * A VolumeWarning that uses PulseAudio to
 * (a) implement sound_system_set_multimedia_volume() and
 * (b) keep the multimedia_active and multimedia_volume properties up-to-date
 */
static GType
volume_warning_pulse_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VolumeWarningPulseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) volume_warning_pulse_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VolumeWarningPulse), 0, (GInstanceInitFunc) volume_warning_pulse_instance_init, NULL };
	GType volume_warning_pulse_type_id;
	volume_warning_pulse_type_id = g_type_register_static (TYPE_VOLUME_WARNING, "VolumeWarningPulse", &g_define_type_info, 0);
	VolumeWarningPulse_private_offset = g_type_add_instance_private (volume_warning_pulse_type_id, sizeof (VolumeWarningPulsePrivate));
	return volume_warning_pulse_type_id;
}

GType
volume_warning_pulse_get_type (void)
{
	static volatile gsize volume_warning_pulse_type_id__once = 0;
	if (g_once_init_enter (&volume_warning_pulse_type_id__once)) {
		GType volume_warning_pulse_type_id;
		volume_warning_pulse_type_id = volume_warning_pulse_get_type_once ();
		g_once_init_leave (&volume_warning_pulse_type_id__once, volume_warning_pulse_type_id);
	}
	return volume_warning_pulse_type_id__once;
}

